import java.awt.*;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.*;
import java.io.*;
import java.lang.String.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.BoxLayout;
import javax.swing.event.*;
import java.text.*;
import javax.swing.border.*;
import java.util.HashMap;
/**
 * SnakeOil (c) 2015 - 2019
 * https://bitbucket.org/MysticLord/
 */
public class DiffTables extends JFrame
{
    //local references to static fields
    private HashMap<String, Integer[]> diffsDataStruct;
    private Integer[] currentEntryArray;

    //misc class fields
    private String currentEntryName;

    //container area
    private JScrollPane diffsScrollPane;
    private Box FrameBox;
    private JPanel BorderPanel;
    private JPanel FlowPanel;
    
    //secondary container area
    private Box firstBox;
    private Box secondBox;

    //diffs table selector area
    private Box diffsSelectorBox;
    private JList<String> diffsSelector;

    //diffs entry area
    private JPanel entryPanel;
    private JComboBox<Integer> diff00;
    private JComboBox<Integer> diff01;
    private JComboBox<Integer> diff02;
    private JComboBox<Integer> diff03;
    private JComboBox<Integer> diff04;
    private JComboBox<Integer> diff05;
    private JComboBox<Integer> diff06;
    private JComboBox<Integer> diff07;
    private JComboBox<Integer> diff08;
    private JComboBox<Integer> diff09;
    private JComboBox<Integer> diff10;
    private JComboBox<Integer> diff11;
    private JComboBox<Integer> diff12;
    private JComboBox<Integer> diff13;
    private JComboBox<Integer> diff14;
    private JComboBox<Integer> diff15;
    private JComboBox<Integer> diff16;
    private JComboBox<Integer> diff17;
    private JComboBox<Integer> diff18;
    private JComboBox<Integer> diff19;
    private JComboBox<Integer> diff20;

    public DiffTables()
    {
        super("Difficulty Tables");

        for (FixedSizeDataTable dataTable : DataHandler.dataTables)
        {
            if (dataTable.getTableName().equals("diffTables"))
            {//never entering this point..., check data handler
                //find and link local reference
                diffsDataStruct = dataTable.data;
                break;//quit when you find it - no reason to keep searching.
            }
        }
        
        setupContainers();
        setupSelector();
        setupEntryArea();
        
        currentEntryArray = diffsDataStruct.get("0");
        
        initializeAndUpdate();
        pack();
        diffsSelector.setSelectedIndex(0);
        setVisible(true);
    }

    private void setupContainers()
    {
        //essential, do not modify
        BorderPanel = new JPanel(new BorderLayout());
        FlowPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        FrameBox = new Box(BoxLayout.X_AXIS);

        BorderPanel.add(FrameBox, BorderLayout.NORTH);
        FlowPanel.add(BorderPanel);

        diffsScrollPane = new JScrollPane(FlowPanel, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        getContentPane().add(diffsScrollPane);
        
        firstBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(firstBox);
        
        secondBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(secondBox);
    }
    
    private void setupSelector()
    {
        //gun tech selector area
        diffsSelectorBox = new Box(BoxLayout.Y_AXIS);
        diffsSelectorBox.setBorder(new BevelBorder(BevelBorder.RAISED));
        firstBox.add(diffsSelectorBox);
        
        diffsSelector = new JList<String>(DataHandler.genStrIntArray(DataHandler.genIntArray(0, 2, new Integer[3])));
        diffsSelector.setVisibleRowCount(3);
        diffsSelector.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        diffsSelector.addListSelectionListener(new ListSelectionListener()
            {
                public void valueChanged(ListSelectionEvent e)
                {
                    currentEntryName = (String)diffsSelector.getSelectedValue();
                    currentEntryArray = diffsDataStruct.get(currentEntryName);
                    initializeAndUpdate();
                }
            });
        diffsSelectorBox.add(diffsSelector);
    }
    
    private void setupEntryArea()
    {
        entryPanel = new JPanel(new GridLayout(1,21,1,1));
        entryPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED),"Entries", TitledBorder.CENTER, TitledBorder.CENTER));
        secondBox.add(entryPanel);
        
        diff00 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff00.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[0] = diff00.getSelectedIndex();
                }
            });
        entryPanel.add(diff00);
        
        diff01 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff01.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[1] = diff01.getSelectedIndex();
                }
            });
        entryPanel.add(diff01);
        
        diff02 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff02.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[2] = diff02.getSelectedIndex();
                }
            });
        entryPanel.add(diff02);
        
        diff03 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff03.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[3] = diff03.getSelectedIndex();
                }
            });
        entryPanel.add(diff03);
        
        diff04 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff04.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[4] = diff04.getSelectedIndex();
                }
            });
        entryPanel.add(diff04);
        
        diff05 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff05.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[5] = diff05.getSelectedIndex();
                }
            });
        entryPanel.add(diff05);
        
        diff06 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff06.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[6] = diff06.getSelectedIndex();
                }
            });
        entryPanel.add(diff06);
        
        diff07 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff07.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[7] = diff07.getSelectedIndex();
                }
            });
        entryPanel.add(diff07);
        
        diff08 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff08.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[8] = diff08.getSelectedIndex();
                }
            });
        entryPanel.add(diff08);
        
        diff09 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff09.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[9] = diff09.getSelectedIndex();
                }
            });
        entryPanel.add(diff09);
        
        diff10 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff10.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[10] = diff10.getSelectedIndex();
                }
            });
        entryPanel.add(diff10);
        
        diff11 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff11.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[11] = diff11.getSelectedIndex();
                }
            });
        entryPanel.add(diff11);
        
        diff12 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff12.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[12] = diff12.getSelectedIndex();
                }
            });
        entryPanel.add(diff12);
        
        diff13 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff13.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[13] = diff13.getSelectedIndex();
                }
            });
        entryPanel.add(diff13);
        
        diff14 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff14.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[14] = diff14.getSelectedIndex();
                }
            });
        entryPanel.add(diff14);
        
        diff15 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff15.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[15] = diff15.getSelectedIndex();
                }
            });
        entryPanel.add(diff15);
        
        diff16 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff16.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[16] = diff16.getSelectedIndex();
                }
            });
        entryPanel.add(diff16);
        
        diff17 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff17.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[17] = diff17.getSelectedIndex();
                }
            });
        entryPanel.add(diff17);
        
        diff18 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff18.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[18] = diff18.getSelectedIndex();
                }
            });
        entryPanel.add(diff18);
        
        diff19 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff19.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[19] = diff19.getSelectedIndex();
                }
            });
        entryPanel.add(diff19);
        
        diff20 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        diff20.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[20] = diff20.getSelectedIndex();
                }
            });
        entryPanel.add(diff20);
    }
    
    private void initializeAndUpdate()
    {
        diff00.setSelectedItem(currentEntryArray[0]);
        diff01.setSelectedItem(currentEntryArray[1]);
        diff02.setSelectedItem(currentEntryArray[2]);
        diff03.setSelectedItem(currentEntryArray[3]);
        diff04.setSelectedItem(currentEntryArray[4]);
        diff05.setSelectedItem(currentEntryArray[5]);
        diff06.setSelectedItem(currentEntryArray[6]);
        diff07.setSelectedItem(currentEntryArray[7]);
        diff08.setSelectedItem(currentEntryArray[8]);
        diff09.setSelectedItem(currentEntryArray[9]);
        diff10.setSelectedItem(currentEntryArray[10]);
        diff11.setSelectedItem(currentEntryArray[11]);
        diff12.setSelectedItem(currentEntryArray[12]);
        diff13.setSelectedItem(currentEntryArray[13]);
        diff14.setSelectedItem(currentEntryArray[14]);
        diff15.setSelectedItem(currentEntryArray[15]);
        diff16.setSelectedItem(currentEntryArray[16]);
        diff17.setSelectedItem(currentEntryArray[17]);
        diff18.setSelectedItem(currentEntryArray[18]);
        diff19.setSelectedItem(currentEntryArray[19]);
        diff20.setSelectedItem(currentEntryArray[20]);
    }
}
