 
import java.util.HashMap;
/** 
 * SnakeOil (c) 2015 - 2019
 * https://bitbucket.org/MysticLord/
 */
public abstract class FixedSizeDataTable extends AbstractDataTable
{
    private int tableLength;
    private int entrySize;
    private int numOfEntries;

    public FixedSizeDataTable(String tName, String fName, int tLength, int eSize, 
    int nEntries)
    {
        super(tName, fName);
        tableLength = tLength;
        entrySize = eSize;
        numOfEntries = nEntries;
    }

    public int getTableLength() {return tableLength;}

    public int getEntrySize() {return entrySize;}

    public int getNumOfEntries() {return numOfEntries;}

    public int getPointerLength() {return 0;}

    public boolean isLittleEndian() {return false;}

    public long getPointerAddress() {return 0L;}

    public long getTableAddress() {return 0L;}

    public void setTableAddress() {}

    public String toString()
    {
        String returnString = super.toString();
        returnString += " " + getTableLength();
        returnString += " " + getEntrySize();
        returnString += " " + getNumOfEntries();
        return returnString;
    }
}
