import java.awt.*;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.*;
import java.io.*;
import java.lang.String.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.BoxLayout;
import javax.swing.event.*;
import java.text.*;
import javax.swing.border.*;
import java.util.HashMap;
/**
 * SnakeOil (c) 2015 - 2019
 * https://bitbucket.org/MysticLord/
 */
public class GunLearning extends JFrame
{
    //local references to static fields
    private HashMap<String, Integer[]> gunTechDataStruct;
    private Integer[] currentEntryArray;

    //misc class fields
    private String currentEntryName;

    //container area
    private JScrollPane gunTechScrollPane;
    private Box FrameBox;
    private JPanel BorderPanel;
    private JPanel FlowPanel;
    
    //secondary container area
    private Box firstBox;
    private Box secondBox;

    //skill selector area
    private Box gunTechSelectorBox;
    private JList<String> gunTechSelector;
    private JScrollPane gunTechSelectorScrollPane;

    //skill area
    private Box factorBox;
    private JLabel factorLabel;
    private JComboBox<Integer> factor;

    public GunLearning()
    {
        super("Gun Learning Difficulty Factors");

        for (FixedSizeDataTable dataTable : DataHandler.dataTables)
        {
            if (dataTable.getTableName().equals("gunLearning"))
            {//never entering this point..., check data handler
                //find and link local reference
                gunTechDataStruct = dataTable.data;
                break;//quit when you find it - no reason to keep searching.
            }
        }
        
        setupContainers();
        setupSelector();
        setupFactorArea();
        
        currentEntryArray = gunTechDataStruct.get("040: Shot");
        
        initializeAndUpdate();
        pack();
        gunTechSelector.setSelectedIndex(0);
        setVisible(true);
    }

    private void setupContainers()
    {
        //essential, do not modify
        BorderPanel = new JPanel(new BorderLayout());
        FlowPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        FrameBox = new Box(BoxLayout.X_AXIS);

        BorderPanel.add(FrameBox, BorderLayout.NORTH);
        FlowPanel.add(BorderPanel);

        gunTechScrollPane = new JScrollPane(FlowPanel, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        getContentPane().add(gunTechScrollPane);
        
        firstBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(firstBox);
        
        secondBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(secondBox);
    }
    
    private void setupSelector()
    {
        //gun tech selector area
        gunTechSelectorBox = new Box(BoxLayout.Y_AXIS);
        gunTechSelectorBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED),"Gun Techs", TitledBorder.CENTER, TitledBorder.CENTER));
        firstBox.add(gunTechSelectorBox);
        
        gunTechSelector = new JList<String>(DataHandler.ARRAY_STRING_GUN_TECHS);
        gunTechSelector.setVisibleRowCount(8);
        gunTechSelector.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        gunTechSelector.addListSelectionListener(new ListSelectionListener()
            {
                public void valueChanged(ListSelectionEvent e)
                {
                    currentEntryName = (String)gunTechSelector.getSelectedValue();
                    currentEntryArray = gunTechDataStruct.get(currentEntryName);
                    initializeAndUpdate();
                }
            });
        
        gunTechSelectorScrollPane = new JScrollPane(gunTechSelector, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        gunTechSelectorBox.add(gunTechSelectorScrollPane);
    }
    
    private void setupFactorArea()
    {
        factorBox = new Box(BoxLayout.X_AXIS);
        factorBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED),"Factor", TitledBorder.CENTER, TitledBorder.CENTER));
        secondBox.add(factorBox);
        
        JPanel leftPanel = new JPanel(new GridLayout(6,1,1,1));
        factorBox.add(leftPanel);
        
        JPanel rightPanel = new JPanel(new GridLayout(6,1,1,1));
        factorBox.add(rightPanel);
        
        factorLabel = new JLabel("Difficulty");
        leftPanel.add(factorLabel);
        
        factor = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        factor.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[0] = factor.getSelectedIndex();
                }
            });
        rightPanel.add(factor);
    }
    
    private void initializeAndUpdate()
    {
        factor.setSelectedItem(currentEntryArray[0]);
    }
}