import java.awt.*;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.*;
import java.io.*;
import java.lang.String.*;
import java.lang.String;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.BoxLayout;
import javax.swing.event.*;
import java.text.*;
import javax.swing.border.*;
import java.util.HashMap;
/**
 * Editor for initial character data.
 * SnakeOil (c) 2015 - 2019
 * https://bitbucket.org/MysticLord/
 */
public class InitChar extends JFrame
{
    //local references to static fields
    private HashMap<String, Integer[]> charDataStruct;
    private Integer[] currentEntryArray;

    //misc class fields
    private String currentEntryName;
    private String editorName = "initialCharacter";

    //primary container area
    private JScrollPane charScrollPane;
    private Box FrameBox;
    private JPanel BorderPanel;
    private JPanel FlowPanel;

    //secondary container area
    private Box firstBox;
    private Box secondBox;
    private Box thirdBox;
    private Box fourthBox;
    private Box fifthBox;

    //character selector area
    private Box charSelectorBox;
    private JList<String> charSelector;
    private JScrollPane charSelectorScrollPane;

    //misc area
    private JPanel miscPanel;
    private JLabel nameLabel;
    private JComboBox<Integer>name;
    private JLabel spriteLabel;
    private JComboBox<Integer> sprite;
    private JLabel lastOptionLabel;
    private JComboBox<Integer> battleOption;
    private JLabel encountersLabel;
    private JComboBox<Integer> encounters;
    private JLabel sparkTalentsLabel;
    private JComboBox<Integer> sparkTalents;
    private JLabel monsterFormMecTypeLabel;
    private JComboBox<Integer> monsterFormMecType;

    //magic gifts area
    private JPanel magicGiftsPanel;
    private JCheckBox giftLight;
    private JCheckBox giftShadow;
    private JCheckBox giftRealm;
    private JCheckBox giftMystic;
    private JCheckBox giftMind;
    private JCheckBox giftEvil;
    private JCheckBox giftArcane;
    private JCheckBox giftRune;

    //race and gender area
    private JPanel raceGenderPanel;
    private JCheckBox human;
    private JCheckBox mystic;
    private JCheckBox mec;
    private JCheckBox monster;
    private JCheckBox unknown;
    private JCheckBox unused;
    private JCheckBox female;
    private JCheckBox male;

    //starting stats area
    private JPanel startingStatsPanel;
    private JLabel hp1Label;
    private JComboBox<Integer> hp1;
    private JLabel hp2Label;
    private JComboBox<Integer> hp2;
    private JLabel lpLabel;
    private JComboBox<Integer> lp;
    private JLabel wpLabel;
    private JComboBox<Integer> wp;
    private JLabel jpLabel;
    private JComboBox<Integer> jp;
    private JLabel strLabel;
    private JComboBox<Integer> str;
    private JLabel quiLabel;
    private JComboBox<Integer> qui;
    private JLabel intLabel;
    private JComboBox<Integer> intelligence;
    private JLabel wilLabel;
    private JComboBox<Integer> wil;
    private JLabel psyLabel;
    private JComboBox<Integer> psy;
    private JLabel vitLabel;
    private JComboBox<Integer> vit;
    private JLabel chaLabel;
    private JComboBox<Integer> cha;

    //stat talents area
    private JPanel statTalentsPanel;
    private JLabel talentStrLabel;
    private JComboBox<Integer> talentStr;
    private JLabel talentQuiLabel;
    private JComboBox<Integer> talentQui;
    private JLabel talentIntLabel;
    private JComboBox<Integer> talentInt;
    private JLabel talentWilLabel;
    private JComboBox<Integer> talentWil;
    private JLabel talentPsyLabel;
    private JComboBox<Integer> talentPsy;
    private JLabel talentVitLabel;
    private JComboBox<Integer> talentVit;
    private JLabel talentChaLabel;
    private JComboBox<Integer> talentCha;
    private JLabel talentHPLabel;
    private JComboBox<Integer> talentHP;

    //equipment area
    private JPanel equipmentPanel;
    private JComboBox<String> gearSlot1;
    private JComboBox<String> gearSlot2;
    private JComboBox<String> gearSlot3;
    private JComboBox<String> gearSlot4;
    private JComboBox<String> gearSlot5;
    private JComboBox<String> gearSlot6;
    private JComboBox<String> gearSlot7;
    private JComboBox<String> gearSlot8;

    //equipped skills area
    private JPanel equippedSkillsPanel;
    private JComboBox<String> skillSlot1;
    private JComboBox<String> skillSlot2;
    private JComboBox<String> skillSlot3;
    private JComboBox<String> skillSlot4;
    private JComboBox<String> skillSlot5;
    private JComboBox<String> skillSlot6;
    private JComboBox<String> skillSlot7;
    private JComboBox<String> skillSlot8;

    //mystic absorbs area
    private Box mysticAbsorbsBox;
    private JLabel mysticSwordLabel;
    private JComboBox<String> mysticSword;
    private JLabel statAmountMSLabel;
    private JComboBox<Integer> statAmountMS;
    private JCheckBox strMS;
    private JCheckBox quiMS;
    private JCheckBox intMS;
    private JCheckBox wilMS;
    private JCheckBox psyMS;
    private JCheckBox vitMS;
    private JCheckBox chaMS;
    private JCheckBox hpMS;
    private JLabel mysticGlovesLabel;
    private JComboBox<String> mysticGloves;
    private JLabel statAmountMGLabel;
    private JComboBox<Integer> statAmountMG;
    private JCheckBox strMG;
    private JCheckBox quiMG;
    private JCheckBox intMG;
    private JCheckBox wilMG;
    private JCheckBox psyMG;
    private JCheckBox vitMG;
    private JCheckBox chaMG;
    private JCheckBox hpMG;
    private JLabel mysticBootsLabel;
    private JComboBox<String> mysticBoots;
    private JLabel statAmountMBLabel;
    private JComboBox<Integer> statAmountMB;
    private JCheckBox strMB;
    private JCheckBox quiMB;
    private JCheckBox intMB;
    private JCheckBox wilMB;
    private JCheckBox psyMB;
    private JCheckBox vitMB;
    private JCheckBox chaMB;
    private JCheckBox hpMB;

    //monster base HP area
    private JPanel monsterHPPanel;
    private JLabel monsterHP1Label;
    private JComboBox<Integer> monsterHP1;
    private JLabel monsterHP2Label;
    private JComboBox<Integer> monsterHP2;
    private JLabel monsterHP3Label;
    private JComboBox<Integer> monsterHP3;

    //learned skills area
    private JPanel learnedSkillsPanel;
    private JCheckBox[] checkBoxes;

    public InitChar(int table)
    {
        super("Characters " + table);
        editorName = editorName + table;
        for (FixedSizeDataTable dataTable : DataHandler.dataTables)
        {
            if (dataTable.getTableName().equals(editorName))
            {
                //find and link local reference
                charDataStruct = dataTable.data;//yet this is not null
                break;
                //quit when found, no reason to keep searching
            }
        }

        setupContainers();
        setupSelector();
        setupMiscArea();
        setupMagicGifts();
        setupRaceGender();
        setupBaseStats();
        setupStatTalentsArea();
        setupEquipmentArea();
        setupEquippedSkills();
        setupMysticAbsorbsArea();
        setupMonsterHPArea();
        setupLearnedSkills();

        pack();
        currentEntryName = "00: Emelia";
        currentEntryArray = charDataStruct.get(currentEntryName);

        setVisible(true);
    }

    private void setupContainers()
    {
        //essential, do not modify
        BorderPanel = new JPanel(new BorderLayout());
        FlowPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        FrameBox = new Box(BoxLayout.X_AXIS);

        BorderPanel.add(FrameBox, BorderLayout.NORTH);
        FlowPanel.add(BorderPanel);

        charScrollPane = new JScrollPane(FlowPanel, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        getContentPane().add(charScrollPane);

        firstBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(firstBox);

        secondBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(secondBox);

        thirdBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(thirdBox);

        fourthBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(fourthBox);

        fifthBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(fifthBox);
    }

    private void setupSelector()
    {
        charSelectorBox = new Box(BoxLayout.Y_AXIS);
        charSelectorBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Character", TitledBorder.CENTER, TitledBorder.CENTER));
        firstBox.add(charSelectorBox);

        charSelector = new JList<String>(DataHandler.ARRAY_STRING_CHARACTERS);
        charSelector.setVisibleRowCount(16);
        charSelector.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        charSelector.addListSelectionListener(new ListSelectionListener()
            {
                public void valueChanged(ListSelectionEvent e)
                {
                    currentEntryName = (String)charSelector.getSelectedValue();
                    currentEntryArray = charDataStruct.get(currentEntryName);
                    initializeCharacters();
                }
            });
        charSelectorBox.add(charSelector);
    }

    private void setupMiscArea()
    {
        miscPanel = new JPanel(new GridLayout(4,1,1,1));
        miscPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Misc", TitledBorder.CENTER, TitledBorder.CENTER));
        secondBox.add(miscPanel);

        nameLabel = new JLabel("Name");
        miscPanel.add(nameLabel);

        name = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        name.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[0] = (Integer)name.getSelectedItem();
                }
            });
        miscPanel.add(name);

        spriteLabel = new JLabel("Sprite");
        miscPanel.add(spriteLabel);

        sprite = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        sprite.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[1] = (Integer)sprite.getSelectedItem();
                }
            });
        miscPanel.add(sprite);

        sparkTalentsLabel = new JLabel("Sparks");
        sparkTalentsLabel.setToolTipText("Spark Talents List");
        miscPanel.add(sparkTalentsLabel);

        sparkTalents = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        sparkTalents.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[23] = (Integer)sparkTalents.getSelectedItem();
                }
            });
        miscPanel.add(sparkTalents);

        monsterFormMecTypeLabel = new JLabel("Form");
        monsterFormMecTypeLabel.setToolTipText("Monster Form and Mec Type");
        miscPanel.add(monsterFormMecTypeLabel);

        monsterFormMecType = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        monsterFormMecType.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[120] = (Integer)monsterFormMecType.getSelectedItem();
                }
            });
        miscPanel.add(monsterFormMecType);
    }

    private void setupMagicGifts()
    {
        magicGiftsPanel = new JPanel(new GridLayout(4,2,1,1));
        magicGiftsPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Magic Gifts", TitledBorder.CENTER, TitledBorder.CENTER));
        secondBox.add(magicGiftsPanel);

        giftLight = new JCheckBox("Light");
        giftLight.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {//21
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[21] & 0x01) != 0x01)
                    {
                        if (giftLight.isSelected())
                        {
                            charDataStruct.get(charName)[21] |= 0x01;
                        }
                        else
                        {
                            charDataStruct.get(charName)[21] -= 0x01;
                        }
                    }
                }
            });
        magicGiftsPanel.add(giftLight);
        giftShadow = new JCheckBox("Shadow");
        giftShadow.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {//21
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[21] & 0x02) != 0x02)
                    {
                        if (giftShadow.isSelected())
                        {
                            charDataStruct.get(charName)[21] |= 0x02;
                        }
                        else
                        {
                            charDataStruct.get(charName)[21] -= 0x02;
                        }
                    }
                }
            });
        magicGiftsPanel.add(giftShadow);
        giftRealm = new JCheckBox("Realm");
        giftRealm.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {//21
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[21] & 0x04) != 0x04)
                    {
                        if (giftRealm.isSelected())
                        {
                            charDataStruct.get(charName)[21] |= 0x04;
                        }
                        else
                        {
                            charDataStruct.get(charName)[21] -= 0x04;
                        }
                    }
                }
            });
        magicGiftsPanel.add(giftRealm);
        giftMystic = new JCheckBox("Mystic");
        giftMystic.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {//21
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[21] & 0x08) != 0x08)
                    {
                        if (giftMystic.isSelected())
                        {
                            charDataStruct.get(charName)[21] |= 0x08;
                        }
                        else
                        {
                            charDataStruct.get(charName)[21] -= 0x08;
                        }
                    }
                }
            });
        magicGiftsPanel.add(giftMystic);
        giftMind = new JCheckBox("Mind");
        giftMind.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {//21
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[21] & 0x10) != 0x10)
                    {
                        if (giftMind.isSelected())
                        {
                            charDataStruct.get(charName)[21] |= 0x10;
                        }
                        else
                        {
                            charDataStruct.get(charName)[21] -= 0x10;
                        }
                    }
                }
            });
        magicGiftsPanel.add(giftMind);
        giftEvil = new JCheckBox("Evil");
        giftEvil.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {//21
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[21] & 0x20) != 0x20)
                    {
                        if (giftEvil.isSelected())
                        {
                            charDataStruct.get(charName)[21] |= 0x20;
                        }
                        else
                        {
                            charDataStruct.get(charName)[21] -= 0x20;
                        }
                    }
                }
            });
        magicGiftsPanel.add(giftEvil);
        giftArcane = new JCheckBox("Arcane");
        giftArcane.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {//21
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[21] & 0x40) != 0x40)
                    {
                        if (giftArcane.isSelected())
                        {
                            charDataStruct.get(charName)[21] |= 0x40;
                        }
                        else
                        {
                            charDataStruct.get(charName)[21] -= 0x40;
                        }
                    }
                }
            });
        magicGiftsPanel.add(giftArcane);
        giftRune = new JCheckBox("Rune");
        giftRune.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {//21
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[21] & 0x80) != 0x80)
                    {
                        if (giftRune.isSelected())
                        {
                            charDataStruct.get(charName)[21] |= 0x80;
                        }
                        else
                        {
                            charDataStruct.get(charName)[21] -= 0x80;
                        }
                    }
                }
            });
        magicGiftsPanel.add(giftRune);
    }

    private void setupRaceGender()
    {
        raceGenderPanel = new JPanel(new GridLayout(4,2,1,1));
        raceGenderPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Race and Gender", TitledBorder.CENTER, TitledBorder.CENTER));
        secondBox.add(raceGenderPanel);

        human = new JCheckBox("Human");
        human.addActionListener(new ActionListener()
            {//22
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[22] & 0x01) != 0x01)
                    {
                        if (human.isSelected())
                        {
                            charDataStruct.get(charName)[22] |= 0x01;
                        }
                        else
                        {
                            charDataStruct.get(charName)[22] -= 0x01;
                        }
                    }
                }
            });
        raceGenderPanel.add(human);
        mystic = new JCheckBox("Mystic");
        mystic.addActionListener(new ActionListener()
            {//22
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[22] & 0x02) != 0x02)
                    {
                        if (mystic.isSelected())
                        {
                            charDataStruct.get(charName)[22] |= 0x02;
                        }
                        else
                        {
                            charDataStruct.get(charName)[22] -= 0x02;
                        }
                    }
                }
            });
        raceGenderPanel.add(mystic);
        mec = new JCheckBox("Mec");
        mec.addActionListener(new ActionListener()
            {//22
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[22] & 0x04) != 0x04)
                    {
                        if (mec.isSelected())
                        {
                            charDataStruct.get(charName)[22] |= 0x04;
                        }
                        else
                        {
                            charDataStruct.get(charName)[22] -= 0x04;
                        }
                    }
                }
            });
        raceGenderPanel.add(mec);
        monster = new JCheckBox("Monster");
        monster.addActionListener(new ActionListener()
            {//22
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[22] & 0x08) != 0x08)
                    {
                        if (monster.isSelected())
                        {
                            charDataStruct.get(charName)[22] |= 0x08;
                        }
                        else
                        {
                            charDataStruct.get(charName)[22] -= 0x08;
                        }
                    }
                }
            });
        raceGenderPanel.add(monster);
        unknown = new JCheckBox("Unknown");
        unknown.addActionListener(new ActionListener()
            {//22
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[22] & 0x10) != 0x10)
                    {
                        if (unknown.isSelected())
                        {
                            charDataStruct.get(charName)[22] |= 0x10;
                        }
                        else
                        {
                            charDataStruct.get(charName)[22] -= 0x10;
                        }
                    }
                }
            });
        raceGenderPanel.add(unknown);
        unused = new JCheckBox("Unused");
        unused.addActionListener(new ActionListener()
            {//22
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[22] & 0x20) != 0x20)
                    {
                        if (unused.isSelected())
                        {
                            charDataStruct.get(charName)[22] |= 0x20;
                        }
                        else
                        {
                            charDataStruct.get(charName)[22] -= 0x20;
                        }
                    }
                }
            });
        raceGenderPanel.add(unused);
        female = new JCheckBox("Female");
        female.addActionListener(new ActionListener()
            {//22
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[22] & 0x40) != 0x40)
                    {
                        if (female.isSelected())
                        {
                            charDataStruct.get(charName)[22] |= 0x40;
                        }
                        else
                        {
                            charDataStruct.get(charName)[22] -= 0x40;
                        }
                    }
                }
            });
        raceGenderPanel.add(female);
        male = new JCheckBox("Male");
        male.addActionListener(new ActionListener()
            {//22
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if ((charDataStruct.get(charName)[22] & 0x80) != 0x80)
                    {
                        if (male.isSelected())
                        {
                            charDataStruct.get(charName)[22] |= 0x80;
                        }
                        else
                        {
                            charDataStruct.get(charName)[22] -= 0x80;
                        }
                    }
                }
            });
        raceGenderPanel.add(male);
    }

    private void setupBaseStats()
    {
        startingStatsPanel = new JPanel(new GridLayout(12,2,1,1));
        startingStatsPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Initial Stats", TitledBorder.CENTER, TitledBorder.CENTER));
        secondBox.add(startingStatsPanel);

        hp1Label = new JLabel("HP 1");
        startingStatsPanel.add(hp1Label);

        hp1 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        hp1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[4] = ((Integer)hp1.getSelectedItem());
                }
            });
        startingStatsPanel.add(hp1);

        hp2Label = new JLabel("HP 2");
        hp2Label.setToolTipText("Multiply HP 2 by 256 and add to HP 1 to get actual HP");
        startingStatsPanel.add(hp2Label);

        hp2 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        hp2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[5] = ((Integer)hp2.getSelectedItem());
                }
            });
        startingStatsPanel.add(hp2);

        lpLabel = new JLabel("LP");
        startingStatsPanel.add(lpLabel);

        lp = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        lp.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[6] = ((Integer)lp.getSelectedItem());
                    charDataStruct.get(charName)[7] = ((Integer)lp.getSelectedItem());
                }
            });
        startingStatsPanel.add(lp);

        wpLabel = new JLabel("WP");
        startingStatsPanel.add(wpLabel);

        wp = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        wp.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[8] = ((Integer)wp.getSelectedItem());
                    charDataStruct.get(charName)[9] = ((Integer)wp.getSelectedItem());
                }
            });
        startingStatsPanel.add(wp);

        jpLabel = new JLabel("JP");
        startingStatsPanel.add(jpLabel);

        jp = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        jp.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[10] = ((Integer)jp.getSelectedItem());
                    charDataStruct.get(charName)[11] = ((Integer)jp.getSelectedItem());
                }
            });
        startingStatsPanel.add(jp);

        strLabel = new JLabel("Str");
        startingStatsPanel.add(strLabel);

        str = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        str.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[14] = ((Integer)str.getSelectedItem());
                }
            });
        startingStatsPanel.add(str);

        quiLabel = new JLabel("Qui");
        startingStatsPanel.add(quiLabel);

        qui = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        qui.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[15] = ((Integer)qui.getSelectedItem());
                }
            });
        startingStatsPanel.add(qui);

        intLabel = new JLabel("Int");
        startingStatsPanel.add(intLabel);

        intelligence = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        intelligence.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[16] = ((Integer)intelligence.getSelectedItem());
                }
            });
        startingStatsPanel.add(intelligence);

        wilLabel = new JLabel("Wil");
        startingStatsPanel.add(wilLabel);

        wil = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        wil.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[17] = ((Integer)wil.getSelectedItem());
                }
            });
        startingStatsPanel.add(wil);

        psyLabel = new JLabel("Psy");
        startingStatsPanel.add(psyLabel);

        psy = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        psy.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[18] = ((Integer)psy.getSelectedItem());
                }
            });
        startingStatsPanel.add(psy);

        vitLabel = new JLabel("Vit");
        startingStatsPanel.add(vitLabel);

        vit = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        vit.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[19] = ((Integer)vit.getSelectedItem());
                }
            });
        startingStatsPanel.add(vit);

        chaLabel = new JLabel("Cha");
        startingStatsPanel.add(chaLabel);

        cha = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        cha.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[20] = ((Integer)cha.getSelectedItem());
                }
            });
        startingStatsPanel.add(cha);
    }

    private void setupStatTalentsArea()
    {
        statTalentsPanel = new JPanel(new GridLayout(8,2,1,1));
        statTalentsPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Stat Talents", TitledBorder.CENTER, TitledBorder.CENTER));
        thirdBox.add(statTalentsPanel);

        talentStrLabel = new JLabel("Str");
        statTalentsPanel.add(talentStrLabel);

        talentStr = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        talentStr.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[48] = ((Integer)talentStr.getSelectedItem());
                }
            });
        statTalentsPanel.add(talentStr);

        talentQuiLabel = new JLabel("Qui");
        statTalentsPanel.add(talentQuiLabel);

        talentQui = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        talentQui.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[49] = ((Integer)talentQui.getSelectedItem());
                }
            });
        statTalentsPanel.add(talentQui);

        talentIntLabel = new JLabel("Int");
        talentIntLabel.setToolTipText("Also gun/magic learning talent");
        statTalentsPanel.add(talentIntLabel);

        talentInt = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        talentInt.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[50] = ((Integer)talentInt.getSelectedItem());
                }
            });
        statTalentsPanel.add(talentInt);

        talentWilLabel = new JLabel("Wil");
        statTalentsPanel.add(talentWilLabel);

        talentWil = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        talentWil.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[51] = ((Integer)talentWil.getSelectedItem());
                }
            });
        statTalentsPanel.add(talentWil);

        talentPsyLabel = new JLabel("Psy");
        statTalentsPanel.add(talentPsyLabel);

        talentPsy = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        talentPsy.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[52] = ((Integer)talentPsy.getSelectedItem());
                }
            });
        statTalentsPanel.add(talentPsy);

        talentVitLabel = new JLabel("Vit");
        statTalentsPanel.add(talentVitLabel);

        talentVit = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        talentVit.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[53] = ((Integer)talentVit.getSelectedItem());
                }
            });
        statTalentsPanel.add(talentVit);

        talentChaLabel = new JLabel("Cha");
        statTalentsPanel.add(talentChaLabel);

        talentCha = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        talentCha.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[54] = ((Integer)talentCha.getSelectedItem());
                }
            });
        statTalentsPanel.add(talentCha);

        talentHPLabel = new JLabel("HP");
        statTalentsPanel.add(talentHPLabel);

        talentHP = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        talentHP.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[55] = ((Integer)talentHP.getSelectedItem());
                }
            });
        statTalentsPanel.add(talentHP);

    }

    private void setupEquipmentArea()
    {
        equipmentPanel = new JPanel(new GridLayout(8,1,1,1));
        equipmentPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Equipment", TitledBorder.CENTER, TitledBorder.CENTER));
        thirdBox.add(equipmentPanel);

        gearSlot1 = new JComboBox<String>(DataHandler.ARRAY_STRING_ITEMS);
        gearSlot1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)gearSlot1.getSelectedItem();
                    String str2 = str1.substring(0,2);
                    int selectedItem = Integer.parseInt(str2,16);
                    charDataStruct.get(charName)[40] = selectedItem;
                }
            });
        equipmentPanel.add(gearSlot1);

        gearSlot2 = new JComboBox<String>(DataHandler.ARRAY_STRING_ITEMS);
        gearSlot2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)gearSlot2.getSelectedItem();
                    String str2 = str1.substring(0,2);
                    int selectedItem = Integer.parseInt(str2,16);
                    charDataStruct.get(charName)[41] = selectedItem;
                }
            });
        equipmentPanel.add(gearSlot2);

        gearSlot3 = new JComboBox<String>(DataHandler.ARRAY_STRING_ITEMS);
        gearSlot3.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)gearSlot3.getSelectedItem();
                    String str2 = str1.substring(0,2);
                    int selectedItem = Integer.parseInt(str2,16);
                    charDataStruct.get(charName)[42] = selectedItem;
                }
            });
        equipmentPanel.add(gearSlot3);

        gearSlot4 = new JComboBox<String>(DataHandler.ARRAY_STRING_ITEMS);
        gearSlot4.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)gearSlot4.getSelectedItem();
                    String str2 = str1.substring(0,2);
                    int selectedItem = Integer.parseInt(str2,16);
                    charDataStruct.get(charName)[43] = selectedItem;
                }
            });
        equipmentPanel.add(gearSlot4);

        gearSlot5 = new JComboBox<String>(DataHandler.ARRAY_STRING_ITEMS);
        gearSlot5.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)gearSlot5.getSelectedItem();
                    String str2 = str1.substring(0,2);
                    int selectedItem = Integer.parseInt(str2,16);
                    charDataStruct.get(charName)[44] = selectedItem;
                }
            });
        equipmentPanel.add(gearSlot5);

        gearSlot6 = new JComboBox<String>(DataHandler.ARRAY_STRING_ITEMS);
        gearSlot6.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)gearSlot6.getSelectedItem();
                    String str2 = str1.substring(0,2);
                    int selectedItem = Integer.parseInt(str2,16);
                    charDataStruct.get(charName)[45] = selectedItem;
                }
            });
        equipmentPanel.add(gearSlot6);

        gearSlot7 = new JComboBox<String>(DataHandler.ARRAY_STRING_ITEMS);
        gearSlot7.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)gearSlot7.getSelectedItem();
                    String str2 = str1.substring(0,2);
                    int selectedItem = Integer.parseInt(str2,16);
                    charDataStruct.get(charName)[46] = selectedItem;
                }
            });
        equipmentPanel.add(gearSlot7);

        gearSlot8 = new JComboBox<String>(DataHandler.ARRAY_STRING_ITEMS);
        gearSlot8.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)gearSlot8.getSelectedItem();
                    String str2 = str1.substring(0,2);
                    int selectedItem = Integer.parseInt(str2,16);
                    charDataStruct.get(charName)[47] = selectedItem;
                }
            });
        equipmentPanel.add(gearSlot8);
    }

    private void setupEquippedSkills()
    {
        equippedSkillsPanel = new JPanel(new GridLayout(8,1,1,1));
        equippedSkillsPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Equipped Skills", TitledBorder.CENTER, TitledBorder.CENTER));
        thirdBox.add(equippedSkillsPanel);

        skillSlot1 = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        skillSlot1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)skillSlot1.getSelectedItem();
                    String str2 = str1.substring(0,3);
                    int selectedItem = Integer.parseInt(str2,16);
                    int selectedItem1 = selectedItem & 0xff;
                    int selectedItem2 = (selectedItem >> 8) & 0x01;
                    charDataStruct.get(charName)[24] = selectedItem1;
                    if (selectedItem2 == 1)//if it's selected
                    {
                        if ((charDataStruct.get(charName)[25] & 0x01) != 0x01)
                        {//and if data struct doesn't reflect that it's selected
                            charDataStruct.get(charName)[25] |= 0x01;
                        }
                    }
                    else //if it's not selected
                    {
                        if ((charDataStruct.get(charName)[25] & 0x01) == 0x01)
                        {//and if data struct doesn't reflect that
                            charDataStruct.get(charName)[25] -= 0x01;
                        }
                    }

                }
            });
        equippedSkillsPanel.add(skillSlot1);

        skillSlot2 = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        skillSlot2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)skillSlot2.getSelectedItem();
                    String str2 = str1.substring(0,3);
                    int selectedItem = Integer.parseInt(str2,16);
                    int selectedItem1 = selectedItem & 0xff;
                    int selectedItem2 = (selectedItem >> 8) & 0x01;
                    charDataStruct.get(charName)[26] = selectedItem1;
                    if (selectedItem2 == 1)//if it's selected
                    {
                        if ((charDataStruct.get(charName)[27] & 0x01) != 0x01)
                        {//and if data struct doesn't reflect that it's selected
                            charDataStruct.get(charName)[27] |= 0x01;
                        }
                    }
                    else //if it's not selected
                    {
                        if ((charDataStruct.get(charName)[27] & 0x01) == 0x01)
                        {//and if data struct doesn't reflect that
                            charDataStruct.get(charName)[27] -= 0x01;
                        }
                    }

                }
            });
        equippedSkillsPanel.add(skillSlot2);

        skillSlot3 = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        skillSlot3.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)skillSlot3.getSelectedItem();
                    String str2 = str1.substring(0,3);
                    int selectedItem = Integer.parseInt(str2,16);
                    int selectedItem1 = selectedItem & 0xff;
                    int selectedItem2 = (selectedItem >> 8) & 0x01;
                    charDataStruct.get(charName)[28] = selectedItem1;
                    if (selectedItem2 == 1)//if it's selected
                    {
                        if ((charDataStruct.get(charName)[29] & 0x01) != 0x01)
                        {//and if data struct doesn't reflect that it's selected
                            charDataStruct.get(charName)[29] |= 0x01;
                        }
                    }
                    else //if it's not selected
                    {
                        if ((charDataStruct.get(charName)[29] & 0x01) == 0x01)
                        {//and if data struct doesn't reflect that
                            charDataStruct.get(charName)[29] -= 0x01;
                        }
                    }

                }
            });
        equippedSkillsPanel.add(skillSlot3);

        skillSlot4 = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        skillSlot4.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)skillSlot4.getSelectedItem();
                    String str2 = str1.substring(0,3);
                    int selectedItem = Integer.parseInt(str2,16);
                    int selectedItem1 = selectedItem & 0xff;
                    int selectedItem2 = (selectedItem >> 8) & 0x01;
                    charDataStruct.get(charName)[30] = selectedItem1;
                    if (selectedItem2 == 1)//if it's selected
                    {
                        if ((charDataStruct.get(charName)[31] & 0x01) != 0x01)
                        {//and if data struct doesn't reflect that it's selected
                            charDataStruct.get(charName)[31] |= 0x01;
                        }
                    }
                    else //if it's not selected
                    {
                        if ((charDataStruct.get(charName)[31] & 0x01) == 0x01)
                        {//and if data struct doesn't reflect that
                            charDataStruct.get(charName)[31] -= 0x01;
                        }
                    }

                }
            });
        equippedSkillsPanel.add(skillSlot4);

        skillSlot5 = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        skillSlot5.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)skillSlot5.getSelectedItem();
                    String str2 = str1.substring(0,3);
                    int selectedItem = Integer.parseInt(str2,16);
                    int selectedItem1 = selectedItem & 0xff;
                    int selectedItem2 = (selectedItem >> 8) & 0x01;
                    charDataStruct.get(charName)[32] = selectedItem1;
                    if (selectedItem2 == 1)//if it's selected
                    {
                        if ((charDataStruct.get(charName)[33] & 0x01) != 0x01)
                        {//and if data struct doesn't reflect that it's selected
                            charDataStruct.get(charName)[33] |= 0x01;
                        }
                    }
                    else //if it's not selected
                    {
                        if ((charDataStruct.get(charName)[33] & 0x01) == 0x01)
                        {//and if data struct doesn't reflect that
                            charDataStruct.get(charName)[33] -= 0x01;
                        }
                    }

                }
            });
        equippedSkillsPanel.add(skillSlot5);

        skillSlot6 = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        skillSlot6.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)skillSlot6.getSelectedItem();
                    String str2 = str1.substring(0,3);
                    int selectedItem = Integer.parseInt(str2,16);
                    int selectedItem1 = selectedItem & 0xff;
                    int selectedItem2 = (selectedItem >> 8) & 0x01;
                    charDataStruct.get(charName)[34] = selectedItem1;
                    if (selectedItem2 == 1)//if it's selected
                    {
                        if ((charDataStruct.get(charName)[35] & 0x01) != 0x01)
                        {//and if data struct doesn't reflect that it's selected
                            charDataStruct.get(charName)[35] |= 0x01;
                        }
                    }
                    else //if it's not selected
                    {
                        if ((charDataStruct.get(charName)[35] & 0x01) == 0x01)
                        {//and if data struct doesn't reflect that
                            charDataStruct.get(charName)[35] -= 0x01;
                        }
                    }

                }
            });
        equippedSkillsPanel.add(skillSlot6);

        skillSlot7 = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        skillSlot7.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)skillSlot7.getSelectedItem();
                    String str2 = str1.substring(0,3);
                    int selectedItem = Integer.parseInt(str2,16);
                    int selectedItem1 = selectedItem & 0xff;
                    int selectedItem2 = (selectedItem >> 8) & 0x01;
                    charDataStruct.get(charName)[36] = selectedItem1;
                    if (selectedItem2 == 1)//if it's selected
                    {
                        if ((charDataStruct.get(charName)[37] & 0x01) != 0x01)
                        {//and if data struct doesn't reflect that it's selected
                            charDataStruct.get(charName)[37] |= 0x01;
                        }
                    }
                    else //if it's not selected
                    {
                        if ((charDataStruct.get(charName)[37] & 0x01) == 0x01)
                        {//and if data struct doesn't reflect that
                            charDataStruct.get(charName)[37] -= 0x01;
                        }
                    }

                }
            });
        equippedSkillsPanel.add(skillSlot7);

        skillSlot8 = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        skillSlot8.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)skillSlot8.getSelectedItem();
                    String str2 = str1.substring(0,3);
                    int selectedItem = Integer.parseInt(str2,16);
                    int selectedItem1 = selectedItem & 0xff;
                    int selectedItem2 = (selectedItem >> 8) & 0x01;
                    charDataStruct.get(charName)[38] = selectedItem1;
                    if (selectedItem2 == 1)//if it's selected
                    {
                        if ((charDataStruct.get(charName)[39] & 0x01) != 0x01)
                        {//and if data struct doesn't reflect that it's selected
                            charDataStruct.get(charName)[39] |= 0x01;
                        }
                    }
                    else //if it's not selected
                    {
                        if ((charDataStruct.get(charName)[39] & 0x01) == 0x01)
                        {//and if data struct doesn't reflect that
                            charDataStruct.get(charName)[39] -= 0x01;
                        }
                    }

                }
            });
        equippedSkillsPanel.add(skillSlot8);
    }

    private void setupMysticAbsorbsArea()
    {
        mysticAbsorbsBox = new Box(BoxLayout.Y_AXIS);
        mysticAbsorbsBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Mystic Absorbs", TitledBorder.CENTER, TitledBorder.CENTER));
        fourthBox.add(mysticAbsorbsBox);

        Box topHalfMS = new Box(BoxLayout.X_AXIS);
        mysticAbsorbsBox.add(topHalfMS);

        JPanel leftPanelMS = new JPanel(new GridLayout(2,1,1,1));
        topHalfMS.add(leftPanelMS);

        JPanel rightPanelMS = new JPanel(new GridLayout(2,1,1,1));
        topHalfMS.add(rightPanelMS);

        mysticSwordLabel = new JLabel("Sword");
        leftPanelMS.add(mysticSwordLabel);

        mysticSword = new JComboBox<String>(DataHandler.ARRAY_STRING_ENEMIES);
        mysticSword.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)mysticSword.getSelectedItem();
                    String str2 = str1.substring(0,2);
                    int selectedItem = Integer.parseInt(str2,16);
                    charDataStruct.get(charName)[124] = selectedItem;
                }
            });
        rightPanelMS.add(mysticSword);

        statAmountMSLabel = new JLabel("Amount");
        leftPanelMS.add(statAmountMSLabel);

        statAmountMS = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        statAmountMS.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[130] = (Integer)statAmountMS.getSelectedItem();
                }
            });
        rightPanelMS.add(statAmountMS);

        JPanel statsAffectedMSPanel = new JPanel(new GridLayout(4,2,1,1));
        mysticAbsorbsBox.add(statsAffectedMSPanel);

        strMS = new JCheckBox("Str");
        strMS.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (strMS.isSelected())
                    {
                        charDataStruct.get(charName)[127] |= 0x01;
                    }
                    else
                    {
                        charDataStruct.get(charName)[127] -= 0x01;
                    }
                }
            });
        statsAffectedMSPanel.add(strMS);

        quiMS = new JCheckBox("Qui");
        quiMS.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (quiMS.isSelected())
                    {
                        charDataStruct.get(charName)[127] |= 0x02;
                    }
                    else
                    {
                        charDataStruct.get(charName)[127] -= 0x02;
                    }
                }
            });
        statsAffectedMSPanel.add(quiMS);

        intMS = new JCheckBox("Int");
        intMS.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (intMS.isSelected())
                    {
                        charDataStruct.get(charName)[127] |= 0x04;
                    }
                    else
                    {
                        charDataStruct.get(charName)[127] -= 0x04;
                    }
                }
            });
        statsAffectedMSPanel.add(intMS);

        wilMS = new JCheckBox("Wil");
        wilMS.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (wilMS.isSelected())
                    {
                        charDataStruct.get(charName)[127] |= 0x08;
                    }
                    else
                    {
                        charDataStruct.get(charName)[127] -= 0x08;
                    }
                }
            });
        statsAffectedMSPanel.add(wilMS);

        psyMS = new JCheckBox("Psy");
        psyMS.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (psyMS.isSelected())
                    {
                        charDataStruct.get(charName)[127] |= 0x10;
                    }
                    else
                    {
                        charDataStruct.get(charName)[127] -= 0x10;
                    }
                }
            });
        statsAffectedMSPanel.add(psyMS);

        vitMS = new JCheckBox("Vit");
        vitMS.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (vitMS.isSelected())
                    {
                        charDataStruct.get(charName)[127] |= 0x20;
                    }
                    else
                    {
                        charDataStruct.get(charName)[127] -= 0x20;
                    }
                }
            });
        statsAffectedMSPanel.add(vitMS);

        chaMS = new JCheckBox("Cha");
        chaMS.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (chaMS.isSelected())
                    {
                        charDataStruct.get(charName)[127] |= 0x40;
                    }
                    else
                    {
                        charDataStruct.get(charName)[127] -= 0x40;
                    }
                }
            });
        statsAffectedMSPanel.add(chaMS);

        hpMS = new JCheckBox("HP");
        hpMS.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (hpMS.isSelected())
                    {
                        charDataStruct.get(charName)[127] |= 0x80;
                    }
                    else
                    {
                        charDataStruct.get(charName)[127] -= 0x80;
                    }
                }
            });
        statsAffectedMSPanel.add(hpMS);

        Box topHalfMG = new Box(BoxLayout.X_AXIS);
        mysticAbsorbsBox.add(topHalfMG);

        JPanel leftPanelMG = new JPanel(new GridLayout(2,1,1,1));
        topHalfMG.add(leftPanelMG);

        JPanel rightPanelMG = new JPanel(new GridLayout(2,1,1,1));
        topHalfMG.add(rightPanelMG);

        mysticGlovesLabel = new JLabel("Gloves");
        leftPanelMG.add(mysticGlovesLabel);

        mysticGloves = new JComboBox<String>(DataHandler.ARRAY_STRING_ENEMIES);
        mysticGloves.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)mysticGloves.getSelectedItem();
                    String str2 = str1.substring(0,2);
                    int selectedItem = Integer.parseInt(str2,16);
                    charDataStruct.get(charName)[125] = selectedItem;
                }
            });
        rightPanelMG.add(mysticGloves);

        statAmountMGLabel = new JLabel("Amount");
        leftPanelMG.add(statAmountMGLabel);

        statAmountMG = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        statAmountMG.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[131] = (Integer)statAmountMG.getSelectedItem();
                }
            });
        rightPanelMG.add(statAmountMG);

        JPanel statsAffectedMGPanel = new JPanel(new GridLayout(4,2,1,1));
        mysticAbsorbsBox.add(statsAffectedMGPanel);

        strMG = new JCheckBox("Str");
        strMG.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (strMG.isSelected())
                    {
                        charDataStruct.get(charName)[128] |= 0x01;
                    }
                    else
                    {
                        charDataStruct.get(charName)[128] -= 0x01;
                    }
                }
            });
        statsAffectedMGPanel.add(strMG);

        quiMG = new JCheckBox("Qui");
        quiMG.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (quiMG.isSelected())
                    {
                        charDataStruct.get(charName)[128] |= 0x02;
                    }
                    else
                    {
                        charDataStruct.get(charName)[128] -= 0x02;
                    }
                }
            });
        statsAffectedMGPanel.add(quiMG);

        intMG = new JCheckBox("Int");
        intMG.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (intMG.isSelected())
                    {
                        charDataStruct.get(charName)[128] |= 0x04;
                    }
                    else
                    {
                        charDataStruct.get(charName)[128] -= 0x04;
                    }
                }
            });
        statsAffectedMGPanel.add(intMG);

        wilMG = new JCheckBox("Wil");
        wilMG.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (wilMG.isSelected())
                    {
                        charDataStruct.get(charName)[128] |= 0x08;
                    }
                    else
                    {
                        charDataStruct.get(charName)[128] -= 0x08;
                    }
                }
            });
        statsAffectedMGPanel.add(wilMG);

        psyMG = new JCheckBox("Psy");
        psyMG.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (psyMG.isSelected())
                    {
                        charDataStruct.get(charName)[128] |= 0x10;
                    }
                    else
                    {
                        charDataStruct.get(charName)[128] -= 0x10;
                    }
                }
            });
        statsAffectedMGPanel.add(psyMG);

        vitMG = new JCheckBox("Vit");
        vitMG.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (vitMG.isSelected())
                    {
                        charDataStruct.get(charName)[128] |= 0x20;
                    }
                    else
                    {
                        charDataStruct.get(charName)[128] -= 0x20;
                    }
                }
            });
        statsAffectedMGPanel.add(vitMG);

        chaMG = new JCheckBox("Cha");
        chaMG.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (chaMG.isSelected())
                    {
                        charDataStruct.get(charName)[128] |= 0x40;
                    }
                    else
                    {
                        charDataStruct.get(charName)[128] -= 0x40;
                    }
                }
            });
        statsAffectedMGPanel.add(chaMG);

        hpMG = new JCheckBox("HP");
        hpMG.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (hpMG.isSelected())
                    {
                        charDataStruct.get(charName)[128] |= 0x80;
                    }
                    else
                    {
                        charDataStruct.get(charName)[128] -= 0x80;
                    }
                }
            });
        statsAffectedMGPanel.add(hpMG);

        Box topHalfMB = new Box(BoxLayout.X_AXIS);
        mysticAbsorbsBox.add(topHalfMB);

        JPanel leftPanelMB = new JPanel(new GridLayout(2,1,1,1));
        topHalfMB.add(leftPanelMB);

        JPanel rightPanelMB = new JPanel(new GridLayout(2,1,1,1));
        topHalfMB.add(rightPanelMB);

        mysticBootsLabel = new JLabel("Boots");
        leftPanelMB.add(mysticBootsLabel);

        mysticBoots = new JComboBox<String>(DataHandler.ARRAY_STRING_ENEMIES);
        mysticBoots.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    String str1 = (String)mysticBoots.getSelectedItem();
                    String str2 = str1.substring(0,2);
                    int selectedItem = Integer.parseInt(str2,16);
                    charDataStruct.get(charName)[126] = selectedItem;
                }
            });
        rightPanelMB.add(mysticBoots);

        statAmountMBLabel = new JLabel("Amount");
        leftPanelMB.add(statAmountMBLabel);

        statAmountMB = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        statAmountMB.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[132] = (Integer)statAmountMB.getSelectedItem();
                }
            });
        rightPanelMB.add(statAmountMB);

        JPanel statsAffectedMBPanel = new JPanel(new GridLayout(4,2,1,1));
        mysticAbsorbsBox.add(statsAffectedMBPanel);

        strMB = new JCheckBox("Str");
        strMB.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (strMB.isSelected())
                    {
                        charDataStruct.get(charName)[129] |= 0x01;
                    }
                    else
                    {
                        charDataStruct.get(charName)[129] -= 0x01;
                    }
                }
            });
        statsAffectedMBPanel.add(strMB);

        quiMB = new JCheckBox("Qui");
        quiMB.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (quiMB.isSelected())
                    {
                        charDataStruct.get(charName)[129] |= 0x02;
                    }
                    else
                    {
                        charDataStruct.get(charName)[129] -= 0x02;
                    }
                }
            });
        statsAffectedMBPanel.add(quiMB);

        intMB = new JCheckBox("Int");
        intMB.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (intMB.isSelected())
                    {
                        charDataStruct.get(charName)[129] |= 0x04;
                    }
                    else
                    {
                        charDataStruct.get(charName)[129] -= 0x04;
                    }
                }
            });
        statsAffectedMBPanel.add(intMB);

        wilMB = new JCheckBox("Wil");
        wilMB.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (wilMB.isSelected())
                    {
                        charDataStruct.get(charName)[129] |= 0x08;
                    }
                    else
                    {
                        charDataStruct.get(charName)[129] -= 0x08;
                    }
                }
            });
        statsAffectedMBPanel.add(wilMB);

        psyMB = new JCheckBox("Psy");
        psyMB.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (psyMB.isSelected())
                    {
                        charDataStruct.get(charName)[129] |= 0x10;
                    }
                    else
                    {
                        charDataStruct.get(charName)[129] -= 0x10;
                    }
                }
            });
        statsAffectedMBPanel.add(psyMB);

        vitMB = new JCheckBox("Vit");
        vitMB.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (vitMB.isSelected())
                    {
                        charDataStruct.get(charName)[129] |= 0x20;
                    }
                    else
                    {
                        charDataStruct.get(charName)[129] -= 0x20;
                    }
                }
            });
        statsAffectedMBPanel.add(vitMB);

        chaMB = new JCheckBox("Cha");
        chaMB.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (chaMB.isSelected())
                    {
                        charDataStruct.get(charName)[129] |= 0x40;
                    }
                    else
                    {
                        charDataStruct.get(charName)[129] -= 0x40;
                    }
                }
            });
        statsAffectedMBPanel.add(chaMB);

        hpMB = new JCheckBox("HP");
        hpMB.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    if (hpMB.isSelected())
                    {
                        charDataStruct.get(charName)[129] |= 0x80;
                    }
                    else
                    {
                        charDataStruct.get(charName)[129] -= 0x80;
                    }
                }
            });
        statsAffectedMBPanel.add(hpMB);
    }

    private void setupMonsterHPArea()
    {
        monsterHPPanel = new JPanel(new GridLayout(2,2,1,1));
        monsterHPPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Monster Base HP", TitledBorder.CENTER, TitledBorder.CENTER));
        fourthBox.add(monsterHPPanel);

        monsterHP1Label = new JLabel("Base HP 1");
        monsterHP1Label.setToolTipText("Monster base HP, 0x00??, in base 10. Also used by mecs?");
        monsterHPPanel.add(monsterHP1Label);

        monsterHP1 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        monsterHP1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[122] = (Integer)monsterHP1.getSelectedItem();
                }
            });
        monsterHPPanel.add(monsterHP1);

        monsterHP2Label = new JLabel("Base HP 2");
        monsterHP2Label.setToolTipText("Monster base HP, 0x??00, in base 10");
        monsterHPPanel.add(monsterHP2Label);

        monsterHP2 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        monsterHP2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String charName = (String)charSelector.getSelectedValue();
                    charDataStruct.get(charName)[123] = (Integer)monsterHP2.getSelectedItem();
                }
            });
        monsterHPPanel.add(monsterHP2);
    }

    private void setupLearnedSkills()
    {
        learnedSkillsPanel = new JPanel(new GridLayout(0,16,0,0));
        learnedSkillsPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Learned Skills", TitledBorder.CENTER, TitledBorder.CENTER));
        fifthBox.add(learnedSkillsPanel);

        int i = 0;
        checkBoxes = new JCheckBox[512];
        for (JCheckBox box : checkBoxes)
        {
            String str1 = DataHandler.ARRAY_STRING_ABILITIES[i];
            str1 = str1.substring(5,str1.length());
            box = new JCheckBox(str1);
            int writeVal = 0;

            if ((i == 0) || ((i % 8) == 0))// bit 7, 0x80
            {
                writeVal = 0x80;
            }
            if ((i == 0) || ((i % 8) == 1))// bit 6, 0x40
            {
                writeVal = 0x40;
            }
            if ((i == 0) || ((i % 8) == 1))// bit 6, 0x40
            {
                writeVal = 0x40;
            }
            if ((i == 0) || ((i % 8) == 2))// bit 5, 0x20
            {
                writeVal = 0x20;
            }
            if ((i == 0) || ((i % 8) == 3))// bit 4, 0x10
            {
                writeVal = 0x10;
            }
            if ((i == 0) || ((i % 8) == 4))// bit 3, 0x08
            {
                writeVal = 0x08;
            }
            if ((i == 0) || ((i % 8) == 5))// bit 2, 0x04
            {
                writeVal = 0x04;
            }
            if ((i == 0) || ((i % 8) == 6))// bit 1, 0x02
            {
                writeVal = 0x02;
            }
            if ((i == 0) || ((i % 8) == 7))// bit 1, 0x01
            {
                writeVal = 0x01;
            }
            
            final JCheckBox tempBox = box;
            final int tempi = i;
            final int tempwriteVal = writeVal;//other than i, box and writeVal could be final... maybe not writeVal, but probably box

            box.addActionListener(new ActionListener()
                {
                    public void actionPerformed(ActionEvent evt)
                    {
                        String charName = (String)charSelector.getSelectedValue();
                        if (tempBox.isSelected())
                        {
                            charDataStruct.get(charName)[(tempi / 8) + 56] |= tempwriteVal;
                        }
                        else
                        {
                            charDataStruct.get(charName)[(tempi / 8) + 56] |= tempwriteVal;
                        }
                    }
                });

            checkBoxes[i] = box;
            learnedSkillsPanel.add(box);
            i++;
        }
    }

    private void initializeCharacters()
    {
        //misc area
        name.setSelectedItem(currentEntryArray[0]);
        sprite.setSelectedItem(currentEntryArray[1]);
        sparkTalents.setSelectedItem(currentEntryArray[23]);
        monsterFormMecType.setSelectedItem(currentEntryArray[120]);
        //magic gifts area
        if ((currentEntryArray[21] & 0x01) == 0x01)
        {
            giftLight.setSelected(true);
        }
        else
        {
            giftLight.setSelected(false);
        }
        if ((currentEntryArray[21] & 0x02) == 0x02)
        {
            giftShadow.setSelected(true);
        }
        else
        {
            giftShadow.setSelected(false);
        }
        if ((currentEntryArray[21] & 0x04) == 0x04)
        {
            giftRealm.setSelected(true);
        }
        else
        {
            giftRealm.setSelected(false);
        }
        if ((currentEntryArray[21] & 0x08) == 0x08)
        {
            giftMystic.setSelected(true);
        }
        else
        {
            giftMystic.setSelected(false);
        }
        if ((currentEntryArray[21] & 0x10) == 0x10)
        {
            giftMind.setSelected(true);
        }
        else
        {
            giftMind.setSelected(false);
        }
        if ((currentEntryArray[21] & 0x20) == 0x20)
        {
            giftEvil.setSelected(true);
        }
        else
        {
            giftEvil.setSelected(false);
        }
        if ((currentEntryArray[21] & 0x40) == 0x40)
        {
            giftArcane.setSelected(true);
        }
        else
        {
            giftArcane.setSelected(false);
        }
        if ((currentEntryArray[21] & 0x80) == 0x80)
        {
            giftRune.setSelected(true);
        }
        else
        {
            giftRune.setSelected(false);
        }
        //race and gender area
        if ((currentEntryArray[22] & 0x01) == 0x01)
        {
            human.setSelected(true);
        }
        else
        {
            human.setSelected(false);
        }
        if ((currentEntryArray[22] & 0x02) == 0x02)
        {
            mystic.setSelected(true);
        }
        else
        {
            mystic.setSelected(false);
        }
        if ((currentEntryArray[22] & 0x04) == 0x04)
        {
            mec.setSelected(true);
        }
        else
        {
            mec.setSelected(false);
        }
        if ((currentEntryArray[22] & 0x08) == 0x08)
        {
            monster.setSelected(true);
        }
        else
        {
            monster.setSelected(false);
        }
        if ((currentEntryArray[22] & 0x10) == 0x10)
        {
            unknown.setSelected(true);
        }
        else
        {
            unknown.setSelected(false);
        }
        if ((currentEntryArray[22] & 0x20) == 0x20)
        {
            unused.setSelected(true);
        }
        else
        {
            unused.setSelected(false);
        }
        if ((currentEntryArray[22] & 0x40) == 0x40)
        {
            female.setSelected(true);
        }
        else
        {
            female.setSelected(false);
        }
        if ((currentEntryArray[22] & 0x80) == 0x80)
        {
            male.setSelected(true);
        }
        else
        {
            male.setSelected(false);
        }
        //above code: write helper method w/ params for index, checkbox, and int to reduce code.

        //starting stats area
        hp1.setSelectedItem(currentEntryArray[4]);
        hp2.setSelectedItem(currentEntryArray[5]);
        lp.setSelectedItem(currentEntryArray[7]);
        wp.setSelectedItem(currentEntryArray[9]);
        jp.setSelectedItem(currentEntryArray[11]);
        str.setSelectedItem(currentEntryArray[14]);
        qui.setSelectedItem(currentEntryArray[15]);
        intelligence.setSelectedItem(currentEntryArray[16]);
        wil.setSelectedItem(currentEntryArray[17]);
        psy.setSelectedItem(currentEntryArray[18]);
        vit.setSelectedItem(currentEntryArray[19]);
        cha.setSelectedItem(currentEntryArray[20]);
        //stat talents area
        talentStr.setSelectedItem(currentEntryArray[48]);
        talentQui.setSelectedItem(currentEntryArray[49]);
        talentInt.setSelectedItem(currentEntryArray[50]);
        talentWil.setSelectedItem(currentEntryArray[51]);
        talentPsy.setSelectedItem(currentEntryArray[52]);
        talentVit.setSelectedItem(currentEntryArray[53]);
        talentCha.setSelectedItem(currentEntryArray[54]);
        talentHP.setSelectedItem(currentEntryArray[55]);
        //equipment area
        gearSlot1.setSelectedItem(DataHandler.ARRAY_STRING_ITEMS[currentEntryArray[40]]);
        gearSlot2.setSelectedItem(DataHandler.ARRAY_STRING_ITEMS[currentEntryArray[41]]);
        gearSlot3.setSelectedItem(DataHandler.ARRAY_STRING_ITEMS[currentEntryArray[42]]);
        gearSlot4.setSelectedItem(DataHandler.ARRAY_STRING_ITEMS[currentEntryArray[43]]);
        gearSlot5.setSelectedItem(DataHandler.ARRAY_STRING_ITEMS[currentEntryArray[44]]);
        gearSlot6.setSelectedItem(DataHandler.ARRAY_STRING_ITEMS[currentEntryArray[45]]);
        gearSlot7.setSelectedItem(DataHandler.ARRAY_STRING_ITEMS[currentEntryArray[46]]);
        gearSlot8.setSelectedItem(DataHandler.ARRAY_STRING_ITEMS[currentEntryArray[47]]);
        //equipped skills area
        skillSlot1.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[currentEntryArray[24] | ((currentEntryArray[25] & 0x01) << 8)]);
        skillSlot2.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[currentEntryArray[26] | ((currentEntryArray[27] & 0x01) << 8)]);
        skillSlot3.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[currentEntryArray[28] | ((currentEntryArray[29] & 0x01) << 8)]);
        skillSlot4.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[currentEntryArray[30] | ((currentEntryArray[31] & 0x01) << 8)]);
        skillSlot5.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[currentEntryArray[32] | ((currentEntryArray[33] & 0x01) << 8)]);
        skillSlot6.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[currentEntryArray[34] | ((currentEntryArray[35] & 0x01) << 8)]);
        skillSlot7.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[currentEntryArray[36] | ((currentEntryArray[37] & 0x01) << 8)]);
        skillSlot8.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[currentEntryArray[38] | ((currentEntryArray[39] & 0x01) << 8)]);
        //mystic absorbs area
        mysticSword.setSelectedItem(DataHandler.ARRAY_STRING_ENEMIES[currentEntryArray[124]]);
        statAmountMS.setSelectedItem(currentEntryArray[130]);
        if ((currentEntryArray[127] & 0x01) == 0x01)
        {
            strMS.setSelected(true);
        }
        else
        {
            strMS.setSelected(false);
        }
        if ((currentEntryArray[127] & 0x02) == 0x02)
        {
            quiMS.setSelected(true);
        }
        else
        {
            quiMS.setSelected(false);
        }
        if ((currentEntryArray[127] & 0x04) == 0x04)
        {
            intMS.setSelected(true);
        }
        else
        {
            intMS.setSelected(false);
        }
        if ((currentEntryArray[127] & 0x08) == 0x08)
        {
            wilMS.setSelected(true);
        }
        else
        {
            wilMS.setSelected(false);
        }
        if ((currentEntryArray[127] & 0x10) == 0x10)
        {
            psyMS.setSelected(true);
        }
        else
        {
            psyMS.setSelected(false);
        }
        if ((currentEntryArray[127] & 0x20) == 0x20)
        {
            vitMS.setSelected(true);
        }
        else
        {
            vitMS.setSelected(false);
        }
        if ((currentEntryArray[127] & 0x40) == 0x40)
        {
            chaMS.setSelected(true);
        }
        else
        {
            chaMS.setSelected(false);
        }
        if ((currentEntryArray[127] & 0x80) == 0x80)
        {
            hpMS.setSelected(true);
        }
        else
        {
            hpMS.setSelected(false);
        }

        mysticGloves.setSelectedItem(DataHandler.ARRAY_STRING_ENEMIES[currentEntryArray[125]]);
        statAmountMG.setSelectedItem(currentEntryArray[131]);
        if ((currentEntryArray[128] & 0x01) == 0x01)
        {
            strMG.setSelected(true);
        }
        else
        {
            strMG.setSelected(false);
        }
        if ((currentEntryArray[128] & 0x02) == 0x02)
        {
            quiMG.setSelected(true);
        }
        else
        {
            quiMG.setSelected(false);
        }
        if ((currentEntryArray[128] & 0x04) == 0x04)
        {
            intMG.setSelected(true);
        }
        else
        {
            intMG.setSelected(false);
        }
        if ((currentEntryArray[128] & 0x08) == 0x08)
        {
            wilMG.setSelected(true);
        }
        else
        {
            wilMG.setSelected(false);
        }
        if ((currentEntryArray[128] & 0x10) == 0x10)
        {
            psyMG.setSelected(true);
        }
        else
        {
            psyMG.setSelected(false);
        }
        if ((currentEntryArray[128] & 0x20) == 0x20)
        {
            vitMG.setSelected(true);
        }
        else
        {
            vitMG.setSelected(false);
        }
        if ((currentEntryArray[128] & 0x40) == 0x40)
        {
            chaMG.setSelected(true);
        }
        else
        {
            chaMG.setSelected(false);
        }
        if ((currentEntryArray[128] & 0x80) == 0x80)
        {
            hpMG.setSelected(true);
        }
        else
        {
            hpMG.setSelected(false);
        }

        mysticBoots.setSelectedItem(DataHandler.ARRAY_STRING_ENEMIES[currentEntryArray[126]]);
        statAmountMB.setSelectedItem(currentEntryArray[132]);
        if ((currentEntryArray[129] & 0x01) == 0x01)
        {
            strMB.setSelected(true);
        }
        else
        {
            strMB.setSelected(false);
        }
        if ((currentEntryArray[129] & 0x02) == 0x02)
        {
            quiMB.setSelected(true);
        }
        else
        {
            quiMB.setSelected(false);
        }
        if ((currentEntryArray[129] & 0x04) == 0x04)
        {
            intMB.setSelected(true);
        }
        else
        {
            intMB.setSelected(false);
        }
        if ((currentEntryArray[129] & 0x08) == 0x08)
        {
            wilMB.setSelected(true);
        }
        else
        {
            wilMB.setSelected(false);
        }
        if ((currentEntryArray[129] & 0x10) == 0x10)
        {
            psyMB.setSelected(true);
        }
        else
        {
            psyMB.setSelected(false);
        }
        if ((currentEntryArray[129] & 0x20) == 0x20)
        {
            vitMB.setSelected(true);
        }
        else
        {
            vitMB.setSelected(false);
        }
        if ((currentEntryArray[129] & 0x40) == 0x40)
        {
            chaMB.setSelected(true);
        }
        else
        {
            chaMB.setSelected(false);
        }
        if ((currentEntryArray[129] & 0x80) == 0x80)
        {
            hpMB.setSelected(true);
        }
        else
        {
            hpMB.setSelected(false);
        }
        //monster base hp area
        monsterHP1.setSelectedItem(currentEntryArray[122]);
        monsterHP2.setSelectedItem(currentEntryArray[123]);
        //learned skills area
        int i = 0;
        int bitValue = 0;
        for (JCheckBox box : checkBoxes)
        {
            if ((i == 0) || ((i % 8) == 0))// bit 7, 0x80
            {
                bitValue = 0x80;
            }
            else if ((i % 8) == 1)// bit 6, 0x40
            {
                bitValue = 0x40;
            }
            else if ((i % 8) == 2)// bit 5, 0x20
            {
                bitValue = 0x20;
            }
            else if ((i % 8) == 3)// bit 4, 0x10
            {
                bitValue = 0x10;
            }
            else if ((i % 8) == 4)// bit 3, 0x08
            {
                bitValue = 0x08;
            }
            else if ((i % 8) == 5)// bit 2, 0x04
            {
                bitValue = 0x04;
            }
            else if ((i % 8) == 6)// bit 1, 0x02
            {
                bitValue = 0x02;
            }
            else if ((i % 8) == 7)// bit 0, 0x01
            {
                bitValue = 0x01;
            }
            if ((currentEntryArray[(i / 8) + 56] & bitValue) == bitValue)
            {
                box.setSelected(true);
            }
            else
            {
                box.setSelected(false);
            }
            i++;
        }
    }
}
