import java.awt.*;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.*;
import java.io.*;
import java.lang.String.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.BoxLayout;
import javax.swing.event.*;
import java.text.*;
import javax.swing.border.*;
import java.util.HashMap;
/**
 * SnakeOil (c) 2015 - 2019
 * https://bitbucket.org/MysticLord/
 */
public class MagicLearning extends JFrame
{
    //local references to static fields
    private HashMap<String, Integer[]> magicDataStruct;
    private Integer[] currentEntryArray;

    //misc class fields
    private String currentEntryName;

    //container area
    private JScrollPane magicScrollPane;
    private Box FrameBox;
    private JPanel BorderPanel;
    private JPanel FlowPanel;
    
    //secondary container area
    private Box firstBox;
    private Box secondBox;

    //skill selector area
    private Box magicSelectorBox;
    private JList<String> magicSelector;
    private JScrollPane magicSelectorScrollPane;

    //skill area
    private Box factorBox;
    private JLabel factorLabel;
    private JComboBox<Integer> factor;

    public MagicLearning()
    {
        super("Magic Learning Difficulty Factors");

        for (FixedSizeDataTable dataTable : DataHandler.dataTables)
        {
            if (dataTable.getTableName().equals("magicLearning"))
            {//never entering this point..., check data handler
                //find and link local reference
                magicDataStruct = dataTable.data;
                break;//quit when you find it - no reason to keep searching.
            }
        }
        
        setupContainers();
        setupSelector();
        setupFactorArea();
        
        currentEntryArray = magicDataStruct.get("100: SunRay");
        
        initializeAndUpdate();
        pack();
        magicSelector.setSelectedIndex(0);
        setVisible(true);
    }

    private void setupContainers()
    {
        //essential, do not modify
        BorderPanel = new JPanel(new BorderLayout());
        FlowPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        FrameBox = new Box(BoxLayout.X_AXIS);

        BorderPanel.add(FrameBox, BorderLayout.NORTH);
        FlowPanel.add(BorderPanel);

        magicScrollPane = new JScrollPane(FlowPanel, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        getContentPane().add(magicScrollPane);
        
        firstBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(firstBox);
        
        secondBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(secondBox);
    }
    
    private void setupSelector()
    {
        //form selector area
        magicSelectorBox = new Box(BoxLayout.Y_AXIS);
        magicSelectorBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED),"Spells", TitledBorder.CENTER, TitledBorder.CENTER));
        firstBox.add(magicSelectorBox);
        
        magicSelector = new JList<String>(DataHandler.ARRAY_STRING_MAGIC);
        magicSelector.setVisibleRowCount(8);
        magicSelector.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        magicSelector.addListSelectionListener(new ListSelectionListener()
            {
                public void valueChanged(ListSelectionEvent e)
                {
                    currentEntryName = (String)magicSelector.getSelectedValue();
                    currentEntryArray = magicDataStruct.get(currentEntryName);
                    initializeAndUpdate();
                }
            });
        
        magicSelectorScrollPane = new JScrollPane(magicSelector, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        magicSelectorBox.add(magicSelectorScrollPane);
    }
    
    private void setupFactorArea()
    {
        factorBox = new Box(BoxLayout.X_AXIS);
        factorBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED),"Factor", TitledBorder.CENTER, TitledBorder.CENTER));
        secondBox.add(factorBox);
        
        JPanel leftPanel = new JPanel(new GridLayout(6,1,1,1));
        factorBox.add(leftPanel);
        
        JPanel rightPanel = new JPanel(new GridLayout(6,1,1,1));
        factorBox.add(rightPanel);
        
        factorLabel = new JLabel("Difficulty");
        leftPanel.add(factorLabel);
        
        factor = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        factor.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[0] = factor.getSelectedIndex();
                }
            });
        rightPanel.add(factor);
    }
    
    private void initializeAndUpdate()
    {
        factor.setSelectedItem(currentEntryArray[0]);
    }
}