import java.awt.*;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.*;
import java.io.*;
import java.lang.String.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.BoxLayout;
import javax.swing.event.*;
import java.text.*;
import javax.swing.border.*;
import java.util.HashMap;
/**
 * SnakeOil (c) 2015 - 2019
 * https://bitbucket.org/MysticLord/
 */
public class ActionGrowths extends JFrame
{
    //local references to static fields
    private HashMap<String, Integer[]> actionsDataStruct;
    private Integer[] currentEntryArray;

    //misc class fields
    private String currentEntryName;

    //container area
    private JScrollPane actionsScrollPane;
    private Box FrameBox;
    private JPanel BorderPanel;
    private JPanel FlowPanel;
    
    //secondary container area
    private Box firstBox;
    private Box secondBox;

    //diffs table selector area
    private Box actionsSelectorBox;
    private JList<String> actionsSelector;

    //diffs entry area
    private JPanel entryPanel;
    private JLabel labelStr;
    private JComboBox<Integer> str;
    private JLabel labelQui;
    private JComboBox<Integer> qui;
    private JLabel labelInt;
    private JComboBox<Integer> intelligence;
    private JLabel labelWil;
    private JComboBox<Integer> wil;
    private JLabel labelPsy;
    private JComboBox<Integer> psy;
    private JLabel labelVit;
    private JComboBox<Integer> vit;
    private JLabel labelCha;
    private JComboBox<Integer> cha;
    private JLabel labelWP;
    private JComboBox<Integer> WP;
    private JLabel labelJP;
    private JComboBox<Integer> JP;
    private JLabel labelHP;
    private JComboBox<Integer> HP;

    public ActionGrowths()
    {
        super("Action Growth Factors");

        for (FixedSizeDataTable dataTable : DataHandler.dataTables)
        {
            if (dataTable.getTableName().equals("actionGrowths"))
            {//never entering this point..., check data handler
                //find and link local reference
                actionsDataStruct = dataTable.data;
                break;//quit when you find it - no reason to keep searching.
            }
        }
        
        setupContainers();
        setupSelector();
        setupEntryArea();
        
        currentEntryArray = actionsDataStruct.get("00: Sword");
        
        initializeAndUpdate();
        pack();
        actionsSelector.setSelectedIndex(0);
        setVisible(true);
    }

    private void setupContainers()
    {
        //essential, do not modify
        BorderPanel = new JPanel(new BorderLayout());
        FlowPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        FrameBox = new Box(BoxLayout.X_AXIS);

        BorderPanel.add(FrameBox, BorderLayout.NORTH);
        FlowPanel.add(BorderPanel);

        actionsScrollPane = new JScrollPane(FlowPanel, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        getContentPane().add(actionsScrollPane);
        
        firstBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(firstBox);
        
        secondBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(secondBox);
    }
    
    private void setupSelector()
    {
        //gun tech selector area
        actionsSelectorBox = new Box(BoxLayout.Y_AXIS);
        actionsSelectorBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED),"Actions", TitledBorder.CENTER, TitledBorder.CENTER));
        firstBox.add(actionsSelectorBox);
        
        actionsSelector = new JList<String>(DataHandler.ARRAY_STRING_ACTIONS);
        actionsSelector.setVisibleRowCount(5);
        actionsSelector.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        actionsSelector.addListSelectionListener(new ListSelectionListener()
            {
                public void valueChanged(ListSelectionEvent e)
                {
                    currentEntryName = (String)actionsSelector.getSelectedValue();
                    currentEntryArray = actionsDataStruct.get(currentEntryName);
                    initializeAndUpdate();
                }
            });
        actionsSelectorBox.add(actionsSelector);
    }
    
    private void setupEntryArea()
    {
        entryPanel = new JPanel(new GridLayout(2,10,1,20));
        entryPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED),"Growth Factors", TitledBorder.CENTER, TitledBorder.CENTER));
        secondBox.add(entryPanel);
        
        labelStr = new JLabel("Str");
        entryPanel.add(labelStr);
        
        str = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        str.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[0] = str.getSelectedIndex();
                }
            });
        entryPanel.add(str);
        
        labelQui = new JLabel("Qui");
        entryPanel.add(labelQui);
        
        qui = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        qui.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[1] = qui.getSelectedIndex();
                }
            });
        entryPanel.add(qui);
        
        labelInt = new JLabel("Int");
        entryPanel.add(labelInt);
        
        intelligence = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        intelligence.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[2] = intelligence.getSelectedIndex();
                }
            });
        entryPanel.add(intelligence);
        
        labelWil = new JLabel("Wil");
        entryPanel.add(labelWil);
        
        wil = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        wil.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[3] = wil.getSelectedIndex();
                }
            });
        entryPanel.add(wil);
        
        labelPsy = new JLabel("Psy");
        entryPanel.add(labelPsy);
        
        psy = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        psy.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[4] = psy.getSelectedIndex();
                }
            });
        entryPanel.add(psy);
        
        labelVit = new JLabel("Vit");
        entryPanel.add(labelVit);
        
        vit = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        vit.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[5] = vit.getSelectedIndex();
                }
            });
        entryPanel.add(vit);
        
        labelCha = new JLabel("Cha");
        entryPanel.add(labelCha);
        
        cha = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        cha.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[6] = cha.getSelectedIndex();
                }
            });
        entryPanel.add(cha);
        
        labelWP = new JLabel("WP");
        entryPanel.add(labelWP);
        
        WP = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        WP.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[7] = WP.getSelectedIndex();
                }
            });
        entryPanel.add(WP);
        
        labelJP = new JLabel("JP");
        entryPanel.add(labelJP);
        
        JP = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        JP.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[8] = JP.getSelectedIndex();
                }
            });
        entryPanel.add(JP);
        
        labelHP = new JLabel("HP");
        entryPanel.add(labelHP);
        
        HP = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        HP.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[9] = HP.getSelectedIndex();
                }
            });
        entryPanel.add(HP);
    }
    
    private void initializeAndUpdate()
    {
        str.setSelectedItem(currentEntryArray[0]);
        qui.setSelectedItem(currentEntryArray[1]);
        intelligence.setSelectedItem(currentEntryArray[2]);
        wil.setSelectedItem(currentEntryArray[3]);
        psy.setSelectedItem(currentEntryArray[4]);
        vit.setSelectedItem(currentEntryArray[5]);
        cha.setSelectedItem(currentEntryArray[6]);
        WP.setSelectedItem(currentEntryArray[7]);
        JP.setSelectedItem(currentEntryArray[8]);
        HP.setSelectedItem(currentEntryArray[9]);
    }
}
