import java.awt.*;
import java.awt.BorderLayout;
import java.awt.event.*;
import java.io.*;
import java.lang.String.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.BoxLayout;
import javax.swing.event.*;
import java.text.*;
import javax.swing.border.*;
import java.util.HashMap;
/**
 * Class to handle editing item data for saga frontier.
 * SnakeOil (c) 2015 - 2019
 * https://bitbucket.org/MysticLord/
 */
public class Items extends JFrame
{
    //local references to static fields
    private HashMap<String,Integer[]> itemDataStruct;
    private Integer[] currentEntryArray;

    //Menu area
    private JMenuBar itemMenuBar;
    private JMenu itemMiscMenu;
    private JMenuItem itemDisplayPreview;
    private JMenuItem itemInfo;
    private JFrame itemsPreviewFrame;
    private Box itemsPreviewBox;
    private JTextArea itemsPreviewTextArea;
    private JFrame itemsInfoFrame;
    private Box itemsInfoBox;
    private JTextArea itemsInfoTextArea;

    //Container area
    private JScrollPane ItemScrollPane;
    private Box FrameBox;
    private JPanel FramePanel;
    private JPanel FramePanel2;

    //top most containers
    private Box MajorLeftBox;   //Item selection area
    private Box MajorCenterBox; //Misc, Immunities, Attributes
    private Box MajorRightBox;  //All the rest

    //top is skills, bottom is rest
    private Box MajorRightTopBox;       //Skills and Skill Triggers
    private Box MajorRightBottomBox;    //All the rest

    //skills and skill triggers
    private Box MajorRightTopBoxSkillsBox;      //Skills
    private Box MajorRightTopBoxTriggersBox;    //Skill triggers

    //defense and stat boosts
    private Box MajorRightBottomBoxDefenseBox;  //defenses
    private Box MajorRightBottomBoxStatBox;     //stat boosts
    //end Container area

    // Item selection area
    private Box itemSelectorBox;
    private JScrollPane itemSelectorScrollPane;
    private JList<String> itemSelector;

    //Item misc area
    private Box itemMiscBox;

    private JPanel itemMiscTopPanel;
    private JLabel itemIDLabel;
    private JComboBox<Integer> itemID;
    private JLabel itemWeightLabel;
    private JComboBox<Integer> itemWeight;
    private JLabel basePowerLabel;
    private JComboBox<Integer> basePower;
    private JLabel maxAmmoLabel;
    private JComboBox<Integer> maxAmmo;
    private JLabel accuracyLabel;
    private JComboBox<Integer> accuracyModifier;

    private JPanel itemMiscBottomPanel;
    private JCheckBox unremovable;

    // Status immunities area
    private JPanel statusImmuPanel;
    private BoxLayout statusImmuPanelOuterLayout;
    private JPanel statusImmuPanelInner;
    private GridLayout statusImmuInnerLayout;
    private JCheckBox itemStatusImmuByteABit0;
    private JCheckBox itemStatusImmuByteABit1;
    private JCheckBox itemStatusImmuByteABit2;
    private JCheckBox itemStatusImmuByteABit3;
    private JCheckBox itemStatusImmuByteABit4;
    private JCheckBox itemStatusImmuByteABit5;
    private JCheckBox itemStatusImmuBlindness;
    private JCheckBox itemStatusImmuPetrify;
    private JCheckBox itemStatusImmuPoison;

    private JCheckBox itemStatusImmuFaint;
    private JCheckBox itemStatusImmuStun;
    private JCheckBox itemStatusImmuKnockback;
    private JCheckBox itemStatusImmuPsychout;
    private JCheckBox itemStatusImmuSleep;
    private JCheckBox itemStatusImmuPalsy;
    private JCheckBox itemStatusImmuByteBBit7;

    // Special attributes area
    private JPanel attributesPanel;
    private JButton attributeNotesButton;
    private JLabel itemAttrLabel;
    private JCheckBox itemAttrAntiAir;
    private JCheckBox itemAttrBit1;
    private JCheckBox itemAttrContact;
    private JCheckBox itemAttrLiquid;
    private JCheckBox itemAttrNonContact;
    private JCheckBox itemAttrSonic;
    private JCheckBox itemAttrGaze;
    private JCheckBox itemAttrGround;

    // Stat boost 1 area
    private Box statBoostBox1;

    private JPanel racePanel1;
    private JLabel race1;
    private JRadioButton mec1;
    private JRadioButton other1;
    private ButtonGroup mecOrNot1;

    private JPanel amountPanel1;
    private JLabel statAmountLabel1;
    private JComboBox<Integer> statAmount1;

    private JPanel statPanel1;
    private JCheckBox strButton1;
    private JCheckBox quiButton1;
    private JCheckBox vitButton1;
    private JCheckBox HPButton1;
    private JCheckBox intButton1;
    private JCheckBox wilButton1;
    private JCheckBox psyButton1;
    private JCheckBox chaButton1;

    // Stat boost 2 area
    private Box statBoostBox2;

    private JPanel racePanel2;
    private JLabel race2;
    private JRadioButton mec2;
    private JRadioButton other2;
    private ButtonGroup mecOrNot2;

    private JPanel statAmountPanel2;
    private JLabel statAmountLabel2;
    private JComboBox<Integer> statAmount2;

    private JPanel statsPanel2;
    private JCheckBox strButton2;
    private JCheckBox quiButton2;
    private JCheckBox vitButton2;
    private JCheckBox HPButton2;
    private JCheckBox intButton2;
    private JCheckBox wilButton2;
    private JCheckBox psyButton2;
    private JCheckBox chaButton2;

    // Elemental defense/evasion modifier 1 area
    private JPanel eleDefMod1Panel;
    private JLabel eleDefMod1Label;
    private JComboBox<Integer> eleDefMod1Amount;
    private JLabel eleDefMod1Affected;
    private JCheckBox eleDefMod1Status;
    private JCheckBox eleDefMod1Force;
    private JCheckBox eleDefMod1Electric;
    private JCheckBox eleDefMod1Cold;
    private JCheckBox eleDefMod1Heat;
    private JCheckBox eleDefMod1Blunt;
    private JCheckBox eleDefMod1Pierce;
    private JCheckBox eleDefMod1Slash;

    // Elemental defense/evasion modifier 2 area
    private JPanel eleDefMod2Panel;
    private JLabel eleDefMod2Label;
    private JComboBox<Integer> eleDefMod2Amount;
    private JLabel eleDefMod2Affected;
    private JCheckBox eleDefMod2Status;
    private JCheckBox eleDefMod2Force;
    private JCheckBox eleDefMod2Electric;
    private JCheckBox eleDefMod2Cold;
    private JCheckBox eleDefMod2Heat;
    private JCheckBox eleDefMod2Blunt;
    private JCheckBox eleDefMod2Pierce;
    private JCheckBox eleDefMod2Slash;

    // Item ability slot 1 area
    private Box itemTech1Box;
    private JComboBox<String> itemAbilitySlot1;

    private JCheckBox byte11Bit7Button;

    private JPanel itemTech1BitsPanel;
    private JCheckBox byte11Bit1Button;
    private JCheckBox byte11Bit2Button;
    private JCheckBox byte11Bit3Button;
    private JCheckBox byte11Bit4Button;
    private JCheckBox byte11Bit5Button;
    private JCheckBox byte11Bit6Button;

    // Item ability slot 2 area
    private Box itemTech2Box;
    private JComboBox<String> itemAbilitySlot2;

    private JCheckBox byte13Bit7Button;

    private JPanel itemTech2BitsPanel;
    private JCheckBox byte13Bit1Button;
    private JCheckBox byte13Bit2Button;
    private JCheckBox byte13Bit3Button;
    private JCheckBox byte13Bit4Button;
    private JCheckBox byte13Bit5Button;
    private JCheckBox byte13Bit6Button;

    // Item ability slot 3 area
    private Box itemTech3Box;
    private JComboBox<String> itemAbilitySlot3;

    private JCheckBox byte15Bit7Button;

    private JPanel itemTech3BitsPanel;
    private JCheckBox byte15Bit1Button;
    private JCheckBox byte15Bit2Button;
    private JCheckBox byte15Bit3Button;
    private JCheckBox byte15Bit4Button;
    private JCheckBox byte15Bit5Button;
    private JCheckBox byte15Bit6Button;

    // Item ability slot 1 trigger area
    private Box itemTech1TriggerBox;
    private JComboBox<String> itemAbilitySlot1Trigger;

    private JCheckBox byte17Bit7Button;

    private JPanel itemTech1TriggerBitsPanel;
    private JCheckBox byte17Bit1Button;
    private JCheckBox byte17Bit2Button;
    private JCheckBox byte17Bit3Button;
    private JCheckBox byte17Bit4Button;
    private JCheckBox byte17Bit5Button;
    private JCheckBox byte17Bit6Button;

    // Item ability slot 2 trigger area
    private Box itemTech2TriggerBox;
    private JComboBox<String> itemAbilitySlot2Trigger;

    private JCheckBox byte19Bit7Button;

    private JPanel itemTech2TriggerBitsPanel;
    private JCheckBox byte19Bit1Button;
    private JCheckBox byte19Bit2Button;
    private JCheckBox byte19Bit3Button;
    private JCheckBox byte19Bit4Button;
    private JCheckBox byte19Bit5Button;
    private JCheckBox byte19Bit6Button;

    // Item ability slot 3 trigger area
    private Box itemTech3TriggerBox;
    private JComboBox<String> itemAbilitySlot3Trigger;

    private JCheckBox byte1BBit7Button;

    private JPanel itemTech3TriggerBitsPanel;
    private JCheckBox byte1BBit1Button;
    private JCheckBox byte1BBit2Button;
    private JCheckBox byte1BBit3Button;
    private JCheckBox byte1BBit4Button;
    private JCheckBox byte1BBit5Button;
    private JCheckBox byte1BBit6Button;

    /**
     * Constructor for objects of class Items
     */
    public Items()
    {
        super("Items");

        for (FixedSizeDataTable dataTable : DataHandler.dataTables)
        {
            if (dataTable.getTableName().equals("items1"))
            {
                itemDataStruct = dataTable.data;//Local reference to static variable
                break;//quit when you find what you're looking for - it's faster
            }
        }

        //setPreferredSize(new Dimension(1024,600));
        //setPreferredSize(new Dimension(1280,800));
        //setMinimumSize(new Dimension(800,800));
        //setLayout(new BorderLayout());

        makeItemMenu();

        //first troubleshoot the jlist selection area, and then
        //move the framebox stuff to setup containers later
        //issue is that jlist is added before the framebox.
        setupContainers();

        setupItemSelectionArea();

        setupItemMiscArea();
        setupStatusImmuArea();
        setupAttributesArea();

        setupStatBoost1Area();
        setupStatBoost2Area();
        setupElemDefArea1();
        setupElemDefArea2();
        setupItemAbilitiesSlot1();
        setupItemAbilitiesSlot2();
        setupItemAbilitiesSlot3();
        setupItemAbilitiesSlot1TriggerArea();
        setupItemAbilitiesSlot2TriggerArea();
        setupItemAbilitiesSlot3TriggerArea();

        Dimension maxSize = new Dimension(FrameBox.getPreferredSize());
        FrameBox.setMaximumSize(maxSize);
        FrameBox.setPreferredSize(maxSize);
        FrameBox.setSize(maxSize);
        FrameBox.revalidate();

        maxSize = new Dimension(FramePanel.getPreferredSize());
        FramePanel.setMaximumSize(maxSize);
        FramePanel.setPreferredSize(maxSize);
        FramePanel.setSize(maxSize);
        FramePanel.revalidate();

        pack();
        itemSelector.setSelectedIndex(0);
        String selectedItemConstructor = (String)itemSelector.getSelectedValue();
        currentEntryArray = itemDataStruct.get(selectedItemConstructor);
        initializeItems();
        setVisible(true);
    }

    /* Above is the constructor.
     * Below are methods to setup DataHandler components and logic */

    private void makeItemMenu()
    {//0
        itemMenuBar = new JMenuBar();
        setJMenuBar(itemMenuBar);

        itemMiscMenu = new JMenu("Misc");
        itemMenuBar.add(itemMiscMenu);

        itemDisplayPreview = new JMenuItem("Display Previews");
        itemMiscMenu.add(itemDisplayPreview);

        //issue w/ below is race condition
        //need to move this code after the rest of the GUI is updated in GUI update method,
        //or reference the int[] directly (probably simpler, will take some thought though).
        //nonetheless, good job.
        itemDisplayPreview.addActionListener(new ActionListener()
            {//1
                public void actionPerformed(ActionEvent evt)
                {//2
                    itemsPreviewFrame = new JFrame("Preview");

                    itemsPreviewBox = new Box(BoxLayout.Y_AXIS);
                    itemsPreviewFrame.add(itemsPreviewBox);

                    //defense preview
                    String defStr;
                    if ((Integer)itemID.getSelectedItem() >= 128)
                    {//3  I'm pretty sure this includes key items... no one's perfect, and they're unequippable anyways.
                        int[] defArr = {0,0,0,0,0,0,0,0};
                        //load base defense into array
                        for (int i = 0; i < 8; i++)
                        {//4
                            defArr[i] = (Integer)basePower.getSelectedItem();
                        }//a
                        if (eleDefMod1Status.isSelected())
                        {//calculate total status defense
                            defArr[0] += (Integer)eleDefMod1Amount.getSelectedItem();
                        }
                        if (eleDefMod2Status.isSelected())
                        {
                            defArr[0] += (Integer)eleDefMod2Amount.getSelectedItem();
                        }
                        if (eleDefMod1Force.isSelected())
                        {//calculate total force defense
                            defArr[1] += (Integer)eleDefMod1Amount.getSelectedItem();
                        }
                        if (eleDefMod2Force.isSelected())
                        {
                            defArr[1] += (Integer)eleDefMod2Amount.getSelectedItem();
                        }
                        if (eleDefMod1Electric.isSelected())
                        {//calculate total electric defense
                            defArr[2] += (Integer)eleDefMod1Amount.getSelectedItem();
                        }
                        if (eleDefMod2Electric.isSelected())
                        {
                            defArr[2] += (Integer)eleDefMod2Amount.getSelectedItem();
                        }
                        if (eleDefMod1Cold.isSelected())
                        {//calculate total cold defense
                            defArr[3] += (Integer)eleDefMod1Amount.getSelectedItem();
                        }
                        if (eleDefMod2Cold.isSelected())
                        {
                            defArr[3] += (Integer)eleDefMod2Amount.getSelectedItem();
                        }
                        if (eleDefMod1Heat.isSelected())
                        {//calculate total heat defense
                            defArr[4] += (Integer)eleDefMod1Amount.getSelectedItem();
                        }
                        if (eleDefMod2Heat.isSelected())
                        {
                            defArr[4] += (Integer)eleDefMod2Amount.getSelectedItem();
                        }
                        if (eleDefMod1Blunt.isSelected())
                        {//calculate total blunt defense
                            defArr[5] += (Integer)eleDefMod1Amount.getSelectedItem();
                        }
                        if (eleDefMod2Blunt.isSelected())
                        {
                            defArr[5] += (Integer)eleDefMod2Amount.getSelectedItem();
                        }
                        if (eleDefMod1Pierce.isSelected())
                        {//calculate total pierce defense
                            defArr[6] += (Integer)eleDefMod1Amount.getSelectedItem();
                        }
                        if (eleDefMod2Pierce.isSelected())
                        {
                            defArr[6] += (Integer)eleDefMod2Amount.getSelectedItem();
                        }
                        if (eleDefMod1Slash.isSelected())
                        {//calculate total slash defense
                            defArr[7] += (Integer)eleDefMod1Amount.getSelectedItem();
                        }
                        if (eleDefMod2Slash.isSelected())
                        {
                            defArr[7] += (Integer)eleDefMod2Amount.getSelectedItem();
                        }
                        //print total defense
                        defStr = new String("Elemental Defense" +
                            "\nSla:\t"+defArr[7]+
                            "\nPie:\t"+defArr[6]+
                            "\nBlu:\t"+defArr[5]+
                            "\nHea:\t"+defArr[4]+
                            "\nCol:\t"+defArr[3]+
                            "\nEle:\t"+defArr[2]+
                            "\nFor:\t"+defArr[1]+
                            "\nSta:\t"+defArr[0] + "\n");
                    }//b
                    else// it's not an armor or key item
                    {//5
                        defStr = new String("Elemental Defense" +
                            "\nSla:\tnull"+
                            "\nPie:\tnull"+
                            "\nBlu:\tnull"+
                            "\nHea:\tnull"+
                            "\nCol:\tnull"+
                            "\nEle:\tnull"+
                            "\nFor:\tnull"+
                            "\nSta:\tnull\n");
                    }//c
                    String evaStr;
                    if ((Integer)itemID.getSelectedItem() == 32)
                    {//6  it's a shield
                        int[] evaArr = {0,0,0,0,0,0,0,0};
                        int evaElementByte = (Integer)eleDefMod1Amount.getSelectedItem();
                        int evaAmount = (Integer)maxAmmo.getSelectedItem();
                        //need to determine the elements that get the boost
                        if (evaElementByte >= 128)
                        {//calculate total slash evasion
                            evaArr[7] = (Integer)maxAmmo.getSelectedItem();
                            evaElementByte -= 128;
                        }
                        if (evaElementByte >= 64)
                        {//calculate total pierce evasion
                            evaArr[6] = (Integer)maxAmmo.getSelectedItem();
                            evaElementByte -= 64;
                        }
                        if (evaElementByte >= 32)
                        {//calculate total blunt evasion
                            evaArr[5] = (Integer)maxAmmo.getSelectedItem();
                            evaElementByte -= 32;
                        }
                        if (evaElementByte >= 16)
                        {//calculate total heat evasion
                            evaArr[4] = (Integer)maxAmmo.getSelectedItem();
                            evaElementByte -= 16;
                        }
                        if (evaElementByte >= 8)
                        {//calculate total cold evasion
                            evaArr[3] = (Integer)maxAmmo.getSelectedItem();
                            evaElementByte -= 8;
                        }
                        if (evaElementByte >= 4)
                        {//calculate total electric evasion
                            evaArr[2] = (Integer)maxAmmo.getSelectedItem();
                            evaElementByte -= 4;
                        }
                        if (evaElementByte >= 2)
                        {//calculate total force evasion
                            evaArr[1] = (Integer)maxAmmo.getSelectedItem();
                            evaElementByte -= 2;
                        }
                        if (evaElementByte >= 1)
                        {//calculate total status evasion
                            evaArr[0] = (Integer)maxAmmo.getSelectedItem();
                            evaElementByte -= 1;
                        }
                        evaStr = new String("\nElemental Evasion" +
                            "\nSla:\t" + evaArr[7] +
                            "\nPie:\t" + evaArr[6] +
                            "\nBlu:\t" + evaArr[5] +
                            "\nHea:\t" + evaArr[4] +
                            "\nCol:\t" + evaArr[3] +
                            "\nEle:\t" + evaArr[2] +
                            "\nFor:\t" + evaArr[1] +
                            "\nSta:\t" + evaArr[0] + "\n"
                        );
                    }//d
                    else //not a shield
                    {
                        evaStr = new String("\nElemental Evasion" +
                            "\nSla:\tnull" +
                            "\nPie:\tnull" +
                            "\nBlu:\tnull" +
                            "\nHea:\tnull" +
                            "\nCol:\tnull" +
                            "\nEle:\tnull" +
                            "\nFor:\tnull" +
                            "\nSta:\tnull\n"
                        );
                    }

                    int[] totalMecStats = {0,0,0,0,0,0,0,0};
                    int[] totalOtherStats = {0,0,0,0,0,0,0,0};
                    if (mec1.isSelected())
                    {
                        if (strButton1.isSelected())
                        {
                            totalMecStats[0] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (quiButton1.isSelected())
                        {
                            totalMecStats[1] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (intButton1.isSelected())
                        {
                            totalMecStats[2] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (wilButton1.isSelected())
                        {
                            totalMecStats[3] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (psyButton1.isSelected())
                        {
                            totalMecStats[4] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (vitButton1.isSelected())
                        {
                            totalMecStats[5] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (chaButton1.isSelected())
                        {
                            totalMecStats[6] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (HPButton1.isSelected())
                        {
                            totalMecStats[7] += (Integer)statAmount1.getSelectedItem() * 5;
                        }
                    }
                    else if (other1.isSelected())
                    {
                        if (strButton1.isSelected())
                        {
                            totalOtherStats[0] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (quiButton1.isSelected())
                        {
                            totalOtherStats[1] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (intButton1.isSelected())
                        {
                            totalOtherStats[2] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (wilButton1.isSelected())
                        {
                            totalOtherStats[3] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (psyButton1.isSelected())
                        {
                            totalOtherStats[4] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (vitButton1.isSelected())
                        {
                            totalOtherStats[5] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (chaButton1.isSelected())
                        {
                            totalOtherStats[6] += (Integer)statAmount1.getSelectedItem();
                        }
                        if (HPButton1.isSelected())
                        {
                            totalOtherStats[7] += (Integer)statAmount1.getSelectedItem() * 5;
                        }
                    }
                    if (mec2.isSelected())
                    {
                        if (strButton2.isSelected())
                        {
                            totalMecStats[0] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (quiButton2.isSelected())
                        {
                            totalMecStats[1] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (intButton2.isSelected())
                        {
                            totalMecStats[2] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (wilButton2.isSelected())
                        {
                            totalMecStats[3] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (psyButton2.isSelected())
                        {
                            totalMecStats[4] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (vitButton2.isSelected())
                        {
                            totalMecStats[5] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (chaButton2.isSelected())
                        {
                            totalMecStats[6] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (HPButton2.isSelected())
                        {
                            totalMecStats[7] += (Integer)statAmount2.getSelectedItem() * 5;
                        }
                    }
                    else if (other2.isSelected())
                    {
                        if (strButton2.isSelected())
                        {
                            totalOtherStats[0] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (quiButton2.isSelected())
                        {
                            totalOtherStats[1] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (intButton2.isSelected())
                        {
                            totalOtherStats[2] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (wilButton2.isSelected())
                        {
                            totalOtherStats[3] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (psyButton2.isSelected())
                        {
                            totalOtherStats[4] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (vitButton2.isSelected())
                        {
                            totalOtherStats[5] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (chaButton2.isSelected())
                        {
                            totalOtherStats[6] += (Integer)statAmount2.getSelectedItem();
                        }
                        if (HPButton2.isSelected())
                        {
                            totalOtherStats[7] += (Integer)statAmount2.getSelectedItem() * 5;
                        }
                    }
                    String statStr = new String("\nBonuses - Mecs"+
                            "\nStr:\t"+totalMecStats[0]+
                            "\nQui:\t"+totalMecStats[1]+
                            "\nInt:\t"+totalMecStats[2]+
                            "\nWil:\t"+totalMecStats[3]+
                            "\nPsy:\t"+totalMecStats[4]+
                            "\nVit:\t"+totalMecStats[5]+
                            "\nCha:\t"+totalMecStats[6]+
                            "\nHP:\t"+totalMecStats[7]+ "\n" +
                            "\nBonuses - Other"+
                            "\nStr:\t"+totalOtherStats[0]+
                            "\nQui:\t"+totalOtherStats[1]+
                            "\nInt:\t"+totalOtherStats[2]+
                            "\nWil:\t"+totalOtherStats[3]+
                            "\nPsy:\t"+totalOtherStats[4]+
                            "\nVit:\t"+totalOtherStats[5]+
                            "\nCha:\t"+totalOtherStats[6]+
                            "\nHP:\t"+totalOtherStats[7]
                        );
                    itemsPreviewTextArea = new JTextArea(defStr + evaStr + statStr);
                    itemsPreviewTextArea.setEditable(false);
                    //itemsPreviewTextArea.setFont(Font.MONOSPACED);
                    //need a way to get the system defined monospaced font.
                    itemsPreviewBox.add(itemsPreviewTextArea);

                    itemsPreviewFrame.pack();
                    itemsPreviewFrame.setVisible(true);
                }//e
            });//f

        itemInfo = new JMenuItem("Information");
        itemMiscMenu.add(itemInfo);

        itemInfo.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    itemsInfoFrame = new JFrame("Information");

                    itemsInfoBox = new Box(BoxLayout.Y_AXIS);
                    itemsInfoFrame.add(itemsInfoBox);

                    String infoStr = new String(
                            "Stat boosts greater than 64 don't display properly in the menu, but they seem to work." +
                            "\nThe visible stat boost seems to roll over and start at 1 for 65, but HP diplays properly.\n" +
                            "\nBoth elemental defense entries are used by all armors.\n" +
                            "\nShields use the combo box in Defense Area 1 to determine the elements that get evasion.  Use this list:" +
                            "\nStatus: 1" +
                            "\nForce: 2" +
                            "\nElectric: 4" +
                            "\nCold: 8" +
                            "\nHeat: 16" +
                            "\nBlunt: 32" +
                            "\nPierce: 64" +
                            "\nSlash: 128" +
                            "\nAdd the elements you want evasion for together and input the result into the combo box.\n" +
                            "\nDefense Area 1 always has all options unselected for shields, no idea why.  Experiment with it.\n" +
                            "\nThe amount of elemental evasion is determined by Max Ammo, Unreloadable, and Evasion b7." +
                            "\nI'm pretty sure it's a signed byte in that context but for now the elemental evasion preview won't reflect that.\n" +
                            "\nLet me know if you discover anything or if anything doesn't work.  This is a work in progress, expect rough edges.");

                    itemsInfoTextArea = new JTextArea(infoStr);
                    itemsInfoTextArea.setEditable(false);
                    itemsInfoBox.add(itemsInfoTextArea);

                    itemsInfoFrame.pack();
                    itemsInfoFrame.setVisible(true);
                }
            });

    }//g

    /**
     * Setup top level containers.
     */
    private void setupContainers()
    {
        FramePanel = new JPanel(new BorderLayout());
        FramePanel2 = new JPanel(new FlowLayout(FlowLayout.LEFT));

        FrameBox = new Box(BoxLayout.X_AXIS);
        FramePanel.add(FrameBox, BorderLayout.NORTH);
        FramePanel2.add(FramePanel);

        ItemScrollPane = new JScrollPane(FramePanel2, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        getContentPane().add(ItemScrollPane);

        //item selection area
        MajorLeftBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(MajorLeftBox);

        //misc, immunities, attributes
        MajorCenterBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(MajorCenterBox);

        //all the rest
        MajorRightBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(MajorRightBox);

        //skills and skill triggers containers container
        MajorRightTopBox = new Box(BoxLayout.Y_AXIS);
        MajorRightBox.add(MajorRightTopBox);

        //defenses and stat boosts containers container
        MajorRightBottomBox = new Box(BoxLayout.X_AXIS);
        MajorRightBox.add(MajorRightBottomBox);

        //skills and skill triggers containers
        MajorRightTopBoxSkillsBox = new Box(BoxLayout.X_AXIS);
        MajorRightTopBox.add(MajorRightTopBoxSkillsBox);
        MajorRightTopBoxTriggersBox = new Box(BoxLayout.X_AXIS);
        MajorRightTopBox.add(MajorRightTopBoxTriggersBox);

        //defense and stat boost containers
        MajorRightBottomBoxDefenseBox = new Box(BoxLayout.Y_AXIS);
        MajorRightBottomBox.add(MajorRightBottomBoxDefenseBox);
        MajorRightBottomBoxStatBox = new Box(BoxLayout.Y_AXIS);
        MajorRightBottomBox.add(MajorRightBottomBoxStatBox);
    }

    /**
     * Setup item selection gui components.

     */
    private void setupItemSelectionArea()
    {
        //Item selection area
        itemSelectorBox = new Box(BoxLayout.Y_AXIS);
        itemSelectorBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Selector", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorLeftBox.add(itemSelectorBox);

        itemSelector = new JList<String>(DataHandler.ARRAY_STRING_ITEMS);
        itemSelector.setVisibleRowCount(32);
        itemSelector.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        itemSelector.addListSelectionListener(new ListSelectionListener()
            {
                public void valueChanged(ListSelectionEvent e)
                {
                    String selectedItem = (String)itemSelector.getSelectedValue();
                    currentEntryArray = itemDataStruct.get(selectedItem);
                    initializeItems();
                }
            });
        itemSelectorScrollPane = new JScrollPane(itemSelector, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        itemSelectorBox.add(itemSelectorScrollPane);
    }

    /**
     * Setup misc item gui components.
     */
    private void setupItemMiscArea()
    {
        //Item ID area
        itemMiscBox = new Box(BoxLayout.Y_AXIS);
        itemMiscBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Misc", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorCenterBox.add(itemMiscBox);

        itemMiscTopPanel = new JPanel(new GridLayout(5,2));
        itemMiscBox.add(itemMiscTopPanel);

        itemIDLabel = new JLabel("ID");
        itemIDLabel.setToolTipText("Unknown if item ID is determined by this byte, hardcoded, or a mix of both.");
        itemMiscTopPanel.add(itemIDLabel);

        itemID = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        itemID.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[0] = (Integer)itemID.getSelectedIndex();
                }
            });
        itemMiscTopPanel.add(itemID);

        itemWeightLabel = new JLabel("Weight");
        itemMiscTopPanel.add(itemWeightLabel);

        itemWeight = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        itemWeight.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[1] = (Integer)itemWeight.getSelectedIndex();
                }
            });
        itemMiscTopPanel.add(itemWeight);

        basePowerLabel = new JLabel("Power");
        basePowerLabel.setToolTipText("Attack or Base Defense");
        itemMiscTopPanel.add(basePowerLabel);

        basePower = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_HALF_BYTE);
        basePower.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    if(unremovable.isSelected())
                    {
                        currentEntryArray[6] = (Integer)basePower.getSelectedItem() + 128;
                    }
                    else
                    {
                        currentEntryArray[6] = (Integer)basePower.getSelectedItem();
                    }                }
            });
        itemMiscTopPanel.add(basePower);

        maxAmmoLabel = new JLabel("Max Ammo");
        maxAmmoLabel.setToolTipText("If bit 0x40 is set item is unreloadable.  No idea what bit 0x80 does. Also is shield evasion byte, max Evasion is 99.");
        itemMiscTopPanel.add(maxAmmoLabel);

        maxAmmo = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        maxAmmo.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[7] = (Integer)maxAmmo.getSelectedIndex();
                }
            });
        itemMiscTopPanel.add(maxAmmo);

        accuracyLabel = new JLabel("Accuracy");
        itemMiscTopPanel.add(accuracyLabel);

        accuracyModifier = new JComboBox<Integer>(DataHandler.ARRAY_SIGNED_BYTE);
        accuracyModifier.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    if ((Integer)accuracyModifier.getSelectedItem() >=0)
                    {
                        currentEntryArray[8] = (Integer)accuracyModifier.getSelectedItem();
                    }
                    else if ((Integer)accuracyModifier.getSelectedItem() < 0)
                    {
                        currentEntryArray[8] = (Integer)accuracyModifier.getSelectedItem() + 256;
                    }
                }
            });
        itemMiscTopPanel.add(accuracyModifier);

        itemMiscBottomPanel = new JPanel();
        itemMiscBottomPanel.setLayout(new GridLayout(1,2));
        itemMiscBox.add(itemMiscBottomPanel);

        unremovable = new JCheckBox("Unremovable", false);
        unremovable.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    if(unremovable.isSelected())
                    {
                        currentEntryArray[6] = (Integer)basePower.getSelectedItem() + 128;
                    }
                    else
                    {
                        currentEntryArray[6] = (Integer)basePower.getSelectedItem();
                    }
                }
            });
        itemMiscBottomPanel.add(unremovable);
    }

    /**
     * Setup DataHandler components and logic for Status Immunities Area.
     */
    private void setupStatusImmuArea()
    {
        // Status immunities area
        statusImmuPanel = new JPanel();
        statusImmuPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Immunities", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorCenterBox.add(statusImmuPanel);

        statusImmuPanelOuterLayout = new BoxLayout(statusImmuPanel, BoxLayout.PAGE_AXIS);

        statusImmuPanel.setLayout(statusImmuPanelOuterLayout);

        statusImmuPanelInner = new JPanel();
        statusImmuInnerLayout = new GridLayout(8,2,0,0);
        //        statusImmuPanel.setLayout(new GridLayout(2,9,10,10));
        statusImmuPanelInner.setLayout(statusImmuInnerLayout);
        //statusImmuPanelInner.setBorder(new LineBorder(Color.RED));
        statusImmuPanelInner.setAlignmentX(Component.CENTER_ALIGNMENT);
        statusImmuPanel.add(statusImmuPanelInner);

        itemStatusImmuByteABit0 = new JCheckBox("?");
        itemStatusImmuByteABit0.setToolTipText("Byte 10, bit 0");
        itemStatusImmuByteABit1 = new JCheckBox("?");
        itemStatusImmuByteABit1.setToolTipText("Byte 10, bit 1");
        itemStatusImmuByteABit2 = new JCheckBox("?");
        itemStatusImmuByteABit2.setToolTipText("Byte 10, bit 2");
        itemStatusImmuByteABit3 = new JCheckBox("?");
        itemStatusImmuByteABit3.setToolTipText("Byte 10, bit 3");
        itemStatusImmuByteABit4 = new JCheckBox("?");
        itemStatusImmuByteABit4.setToolTipText("Byte 10, bit 4");
        itemStatusImmuByteABit5 = new JCheckBox("?");
        itemStatusImmuByteABit5.setToolTipText("Byte 10, bit 5");
        itemStatusImmuBlindness = new JCheckBox("Blind");
        itemStatusImmuPetrify = new JCheckBox("Stone");
        itemStatusImmuPoison = new JCheckBox("Poison");
        itemStatusImmuFaint = new JCheckBox("Faint");
        itemStatusImmuFaint.setToolTipText("Not sure if KO or LP Break");
        itemStatusImmuStun = new JCheckBox("Stun");
        itemStatusImmuKnockback = new JCheckBox("Push");
        itemStatusImmuPsychout = new JCheckBox("Mess");
        itemStatusImmuPsychout.setToolTipText("Blue, Yellow, and Red Mess");
        itemStatusImmuSleep = new JCheckBox("Sleep");
        itemStatusImmuPalsy = new JCheckBox("Palsy");
        itemStatusImmuByteBBit7 = new JCheckBox("?");
        itemStatusImmuByteBBit7.setToolTipText("Byte 11, bit 7");

        itemStatusImmuByteABit0.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[10] = eightBitToggles(itemStatusImmuByteABit0, itemStatusImmuByteABit1, itemStatusImmuByteABit2, itemStatusImmuByteABit3, itemStatusImmuByteABit4, itemStatusImmuByteABit5, itemStatusImmuBlindness, itemStatusImmuPetrify);
                }
            });
        itemStatusImmuByteABit1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[10] = eightBitToggles(itemStatusImmuByteABit0, itemStatusImmuByteABit1, itemStatusImmuByteABit2, itemStatusImmuByteABit3, itemStatusImmuByteABit4, itemStatusImmuByteABit5, itemStatusImmuBlindness, itemStatusImmuPetrify);
                }
            });
        itemStatusImmuByteABit2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[10] = eightBitToggles(itemStatusImmuByteABit0, itemStatusImmuByteABit1, itemStatusImmuByteABit2, itemStatusImmuByteABit3, itemStatusImmuByteABit4, itemStatusImmuByteABit5, itemStatusImmuBlindness, itemStatusImmuPetrify);
                }
            });
        itemStatusImmuByteABit3.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[10] = eightBitToggles(itemStatusImmuByteABit0, itemStatusImmuByteABit1, itemStatusImmuByteABit2, itemStatusImmuByteABit3, itemStatusImmuByteABit4, itemStatusImmuByteABit5, itemStatusImmuBlindness, itemStatusImmuPetrify);
                }
            });
        itemStatusImmuByteABit4.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[10] = eightBitToggles(itemStatusImmuByteABit0, itemStatusImmuByteABit1, itemStatusImmuByteABit2, itemStatusImmuByteABit3, itemStatusImmuByteABit4, itemStatusImmuByteABit5, itemStatusImmuBlindness, itemStatusImmuPetrify);
                }
            });
        itemStatusImmuByteABit5.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[10] = eightBitToggles(itemStatusImmuByteABit0, itemStatusImmuByteABit1, itemStatusImmuByteABit2, itemStatusImmuByteABit3, itemStatusImmuByteABit4, itemStatusImmuByteABit5, itemStatusImmuBlindness, itemStatusImmuPetrify);
                }
            });
        itemStatusImmuBlindness.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[10] = eightBitToggles(itemStatusImmuByteABit0, itemStatusImmuByteABit1, itemStatusImmuByteABit2, itemStatusImmuByteABit3, itemStatusImmuByteABit4, itemStatusImmuByteABit5, itemStatusImmuBlindness, itemStatusImmuPetrify);
                }
            });
        itemStatusImmuPetrify.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[10] = eightBitToggles(itemStatusImmuByteABit0, itemStatusImmuByteABit1, itemStatusImmuByteABit2, itemStatusImmuByteABit3, itemStatusImmuByteABit4, itemStatusImmuByteABit5, itemStatusImmuBlindness, itemStatusImmuPetrify);
                }
            });

        itemStatusImmuPoison.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[11] = eightBitToggles(itemStatusImmuPoison, itemStatusImmuFaint, itemStatusImmuStun, itemStatusImmuKnockback, itemStatusImmuPsychout, itemStatusImmuSleep, itemStatusImmuPalsy, itemStatusImmuByteBBit7);
                }
            });
        itemStatusImmuFaint.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[11] = eightBitToggles(itemStatusImmuPoison, itemStatusImmuFaint, itemStatusImmuStun, itemStatusImmuKnockback, itemStatusImmuPsychout, itemStatusImmuSleep, itemStatusImmuPalsy, itemStatusImmuByteBBit7);
                }
            });
        itemStatusImmuStun.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[11] = eightBitToggles(itemStatusImmuPoison, itemStatusImmuFaint, itemStatusImmuStun, itemStatusImmuKnockback, itemStatusImmuPsychout, itemStatusImmuSleep, itemStatusImmuPalsy, itemStatusImmuByteBBit7);
                }
            });
        itemStatusImmuKnockback.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[11] = eightBitToggles(itemStatusImmuPoison, itemStatusImmuFaint, itemStatusImmuStun, itemStatusImmuKnockback, itemStatusImmuPsychout, itemStatusImmuSleep, itemStatusImmuPalsy, itemStatusImmuByteBBit7);
                }
            });
        itemStatusImmuPsychout.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[11] = eightBitToggles(itemStatusImmuPoison, itemStatusImmuFaint, itemStatusImmuStun, itemStatusImmuKnockback, itemStatusImmuPsychout, itemStatusImmuSleep, itemStatusImmuPalsy, itemStatusImmuByteBBit7);
                }
            });
        itemStatusImmuSleep.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[11] = eightBitToggles(itemStatusImmuPoison, itemStatusImmuFaint, itemStatusImmuStun, itemStatusImmuKnockback, itemStatusImmuPsychout, itemStatusImmuSleep, itemStatusImmuPalsy, itemStatusImmuByteBBit7);
                }
            });
        itemStatusImmuPalsy.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[11] = eightBitToggles(itemStatusImmuPoison, itemStatusImmuFaint, itemStatusImmuStun, itemStatusImmuKnockback, itemStatusImmuPsychout, itemStatusImmuSleep, itemStatusImmuPalsy, itemStatusImmuByteBBit7);
                }
            });
        itemStatusImmuByteBBit7.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[11] = eightBitToggles(itemStatusImmuPoison, itemStatusImmuFaint, itemStatusImmuStun, itemStatusImmuKnockback, itemStatusImmuPsychout, itemStatusImmuSleep, itemStatusImmuPalsy, itemStatusImmuByteBBit7);
                }
            });

        statusImmuPanelInner.add(itemStatusImmuByteABit0);
        statusImmuPanelInner.add(itemStatusImmuByteABit1);
        statusImmuPanelInner.add(itemStatusImmuByteABit2);
        statusImmuPanelInner.add(itemStatusImmuByteABit3);
        statusImmuPanelInner.add(itemStatusImmuByteABit4);
        statusImmuPanelInner.add(itemStatusImmuByteABit5);
        statusImmuPanelInner.add(itemStatusImmuBlindness);
        statusImmuPanelInner.add(itemStatusImmuPetrify);
        statusImmuPanelInner.add(itemStatusImmuPoison);
        statusImmuPanelInner.add(itemStatusImmuFaint);
        statusImmuPanelInner.add(itemStatusImmuStun);
        statusImmuPanelInner.add(itemStatusImmuKnockback);
        statusImmuPanelInner.add(itemStatusImmuPsychout);
        statusImmuPanelInner.add(itemStatusImmuSleep);
        statusImmuPanelInner.add(itemStatusImmuPalsy);
        statusImmuPanelInner.add(itemStatusImmuByteBBit7);
    }

    /**
     * Private method to set up DataHandler components and
     * logic for Special Attributes area.
     */
    private void setupAttributesArea()
    {
        // Special attributes area
        attributesPanel = new JPanel(new GridLayout(4,2));
        attributesPanel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Attributes", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorCenterBox.add(attributesPanel);

        itemAttrAntiAir = new JCheckBox("Anti-Air");
        itemAttrAntiAir.setToolTipText("Weakness to Anti-Air attacks");
        itemAttrBit1 = new JCheckBox("?");
        itemAttrBit1.setToolTipText("Byte 9, bit 1");
        itemAttrContact = new JCheckBox("Contact");
        itemAttrContact.setToolTipText("Not sure how Contact works");
        itemAttrLiquid = new JCheckBox("Liquid");
        itemAttrLiquid.setToolTipText("Immunity to Liquid attacks");
        itemAttrNonContact = new JCheckBox("!Contact");
        itemAttrNonContact.setToolTipText("Not sure how Non-Contact works; ! is the symbol for \"not\"");
        itemAttrSonic = new JCheckBox("Sonic");
        itemAttrSonic.setToolTipText("Immunity to Sonic attacks");
        itemAttrGaze = new JCheckBox("Gaze");
        itemAttrGaze.setToolTipText("Immunity to Gaze attacks");
        itemAttrGround = new JCheckBox("Ground");
        itemAttrGround.setToolTipText("Immunity to Ground attacks");

        itemAttrAntiAir.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[9] = eightBitToggles(itemAttrAntiAir, itemAttrBit1, itemAttrContact, itemAttrLiquid, itemAttrNonContact, itemAttrSonic, itemAttrGaze, itemAttrGround);
                }
            });
        itemAttrBit1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[9] = eightBitToggles(itemAttrAntiAir, itemAttrBit1, itemAttrContact, itemAttrLiquid, itemAttrNonContact, itemAttrSonic, itemAttrGaze, itemAttrGround);
                }
            });
        itemAttrContact.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[9] = eightBitToggles(itemAttrAntiAir, itemAttrBit1, itemAttrContact, itemAttrLiquid, itemAttrNonContact, itemAttrSonic, itemAttrGaze, itemAttrGround);
                }
            });
        itemAttrLiquid.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[9] = eightBitToggles(itemAttrAntiAir, itemAttrBit1, itemAttrContact, itemAttrLiquid, itemAttrNonContact, itemAttrSonic, itemAttrGaze, itemAttrGround);
                }
            });
        itemAttrNonContact.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[9] = eightBitToggles(itemAttrAntiAir, itemAttrBit1, itemAttrContact, itemAttrLiquid, itemAttrNonContact, itemAttrSonic, itemAttrGaze, itemAttrGround);
                }
            });
        itemAttrSonic.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[9] = eightBitToggles(itemAttrAntiAir, itemAttrBit1, itemAttrContact, itemAttrLiquid, itemAttrNonContact, itemAttrSonic, itemAttrGaze, itemAttrGround);
                }
            });
        itemAttrGaze.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[9] = eightBitToggles(itemAttrAntiAir, itemAttrBit1, itemAttrContact, itemAttrLiquid, itemAttrNonContact, itemAttrSonic, itemAttrGaze, itemAttrGround);
                }
            });
        itemAttrGround.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[9] = eightBitToggles(itemAttrAntiAir, itemAttrBit1, itemAttrContact, itemAttrLiquid, itemAttrNonContact, itemAttrSonic, itemAttrGaze, itemAttrGround);
                }
            });

        attributesPanel.add(itemAttrAntiAir);
        attributesPanel.add(itemAttrBit1);
        attributesPanel.add(itemAttrContact);
        attributesPanel.add(itemAttrLiquid);
        attributesPanel.add(itemAttrNonContact);
        attributesPanel.add(itemAttrSonic);
        attributesPanel.add(itemAttrGaze);
        attributesPanel.add(itemAttrGround);
    }

    /**
     * Setup DataHandler components for stat boost 1 area, including event logic.
     */
    private void setupStatBoost1Area()
    {
        statBoostBox1 = new Box(BoxLayout.Y_AXIS);
        //statBoostBox1.setBorder(new BevelBorder(BevelBorder.RAISED));
        statBoostBox1.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Stat Boosts, Part 1", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorRightBottomBoxStatBox.add(statBoostBox1);

        //race selection area
        racePanel1 = new JPanel(new FlowLayout());
        statBoostBox1.add(racePanel1);

        race1 = new JLabel("Race");
        racePanel1.add(race1);

        mec1 = new JRadioButton("Mec", true);
        mec1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    if ((mec1.isSelected() == true) && (currentEntryArray[2] >= 128))
                    {
                        currentEntryArray[2] -= 128;
                    }
                }
            });
        other1 = new JRadioButton("Other", false);
        other1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    if ((other1.isSelected() == true) && (currentEntryArray[2] < 128))
                    {
                        currentEntryArray[2] += 128;
                    }
                }
            });
        racePanel1.add(mec1);
        racePanel1.add(other1);

        mecOrNot1 = new ButtonGroup();
        mecOrNot1.add(mec1);
        mecOrNot1.add(other1);

        //stat amount area
        JPanel statAmountPanel1 = new JPanel(new FlowLayout());
        statBoostBox1.add(statAmountPanel1);

        statAmountLabel1 = new JLabel("Boost");
        statAmountLabel1.setToolTipText("Stat boosts greather than 64 don't display correctly");
        statAmountPanel1.add(statAmountLabel1);

        statAmount1 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_HALF_BYTE);
        statAmount1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    if (currentEntryArray[2] != (Integer)statAmount1.getSelectedItem())
                    {
                        if (mec1.isSelected() == true)
                        {
                            currentEntryArray[2] = (Integer)statAmount1.getSelectedItem();
                        }
                        if (other1.isSelected() == true)
                        {
                            currentEntryArray[2] = (Integer)statAmount1.getSelectedItem() + 128;
                        }
                    }
                }
            });
        statAmountPanel1.add(statAmount1);

        //stat selection area
        JPanel statCheckboxesPanel1 = new JPanel(new GridLayout(2,4));
        statBoostBox1.add(statCheckboxesPanel1);

        strButton1 = new JCheckBox("Str", false);
        quiButton1 = new JCheckBox("Qui", false);
        vitButton1 = new JCheckBox("Vit", false);
        HPButton1 = new JCheckBox("HP", false);
        HPButton1.setToolTipText("HP boosts are multiplied by 5 and visible only in battle");
        intButton1 = new JCheckBox("Int", false);
        wilButton1 = new JCheckBox("Wil", false);
        psyButton1 = new JCheckBox("Psy", false);
        chaButton1 = new JCheckBox("Cha", false);
        strButton1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[3] = eightBitToggles(strButton1,quiButton1,intButton1,wilButton1,psyButton1,vitButton1,chaButton1,HPButton1);
                }
            });
        quiButton1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[3] = eightBitToggles(strButton1,quiButton1,intButton1,wilButton1,psyButton1,vitButton1,chaButton1,HPButton1);
                }
            });
        vitButton1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[3] = eightBitToggles(strButton1,quiButton1,intButton1,wilButton1,psyButton1,vitButton1,chaButton1,HPButton1);
                }
            });
        HPButton1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[3] = eightBitToggles(strButton1,quiButton1,intButton1,wilButton1,psyButton1,vitButton1,chaButton1,HPButton1);
                }
            });
        intButton1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[3] = eightBitToggles(strButton1,quiButton1,intButton1,wilButton1,psyButton1,vitButton1,chaButton1,HPButton1);
                }
            });
        wilButton1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[3] = eightBitToggles(strButton1,quiButton1,intButton1,wilButton1,psyButton1,vitButton1,chaButton1,HPButton1);
                }
            });
        psyButton1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[3] = eightBitToggles(strButton1,quiButton1,intButton1,wilButton1,psyButton1,vitButton1,chaButton1,HPButton1);
                }
            });
        chaButton1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[3] = eightBitToggles(strButton1,quiButton1,intButton1,wilButton1,psyButton1,vitButton1,chaButton1,HPButton1);
                }
            });
        statCheckboxesPanel1.add(strButton1);
        statCheckboxesPanel1.add(quiButton1);
        statCheckboxesPanel1.add(vitButton1);
        statCheckboxesPanel1.add(HPButton1);
        statCheckboxesPanel1.add(intButton1);
        statCheckboxesPanel1.add(wilButton1);
        statCheckboxesPanel1.add(psyButton1);
        statCheckboxesPanel1.add(chaButton1);
    }

    /**
     * Set up gui components for Stat Boost Area 2
     */
    private void setupStatBoost2Area()
    {
        //Stat boost 2 area
        statBoostBox2 = new Box(BoxLayout.Y_AXIS);
        statBoostBox2.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Stat Boosts, Part 2", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorRightBottomBoxStatBox.add(statBoostBox2);

        //race selection area
        racePanel2 = new JPanel(new FlowLayout());
        statBoostBox2.add(racePanel2);

        race2 = new JLabel("Race");
        racePanel2.add(race2);

        mec2 = new JRadioButton("Mec", true);
        mec2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    if ((mec2.isSelected() == true) && (currentEntryArray[4] >= 128))
                    {
                        currentEntryArray[4] -= 128;
                    }
                }
            });
        other2 = new JRadioButton("Other", false);
        other2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    if ((other2.isSelected() == true) && (currentEntryArray[4] < 128))
                    {
                        currentEntryArray[4] += 128;
                    }
                }
            });
        racePanel2.add(mec2);
        racePanel2.add(other2);

        mecOrNot2 = new ButtonGroup();
        mecOrNot2.add(mec2);
        mecOrNot2.add(other2);

        //stat amount area
        statAmountPanel2 = new JPanel(new FlowLayout());
        statBoostBox2.add(statAmountPanel2);

        statAmountLabel2 = new JLabel("Boost");
        statAmountLabel2.setToolTipText("Stat boosts greather than 64 don't display correctly");
        statAmountPanel2.add(statAmountLabel2);

        statAmount2 = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_HALF_BYTE);
        statAmount2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    if (currentEntryArray[4]!=(Integer)statAmount2.getSelectedItem())
                    {
                        if (mec2.isSelected()==true)
                        {
                            currentEntryArray[4] = (Integer)statAmount2.getSelectedItem();
                        }
                        if (other2.isSelected()==true)
                        {
                            currentEntryArray[4] = (Integer)statAmount2.getSelectedItem() + 128;
                        }
                    }
                }
            });
        statAmountPanel2.add(statAmount2);

        //stat selection area
        JPanel statCheckboxesPanel2 = new JPanel (new GridLayout(2,4));
        statBoostBox2.add(statCheckboxesPanel2);

        strButton2 = new JCheckBox("Str", false);
        quiButton2 = new JCheckBox("Qui", false);
        vitButton2 = new JCheckBox("Vit", false);
        HPButton2 = new JCheckBox("HP", false);
        HPButton2.setToolTipText("HP boosts are multiplied by 5 and visible only in battle");
        intButton2 = new JCheckBox("Int", false);
        wilButton2 = new JCheckBox("Wil", false);
        psyButton2 = new JCheckBox("Psy", false);
        chaButton2 = new JCheckBox("Cha", false);

        strButton2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[5] = eightBitToggles(strButton2,quiButton2,intButton2,wilButton2,psyButton2,vitButton2,chaButton2,HPButton2);
                }
            });
        quiButton2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[5] = eightBitToggles(strButton2,quiButton2,intButton2,wilButton2,psyButton2,vitButton2,chaButton2,HPButton2);
                }
            });
        vitButton2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[5] = eightBitToggles(strButton2,quiButton2,intButton2,wilButton2,psyButton2,vitButton2,chaButton2,HPButton2);
                }
            });
        HPButton2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[5] = eightBitToggles(strButton2,quiButton2,intButton2,wilButton2,psyButton2,vitButton2,chaButton2,HPButton2);
                }
            });
        intButton2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[5] = eightBitToggles(strButton2,quiButton2,intButton2,wilButton2,psyButton2,vitButton2,chaButton2,HPButton2);
                }
            });
        wilButton2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[5] = eightBitToggles(strButton2,quiButton2,intButton2,wilButton2,psyButton2,vitButton2,chaButton2,HPButton2);
                }
            });
        psyButton2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[5] = eightBitToggles(strButton2,quiButton2,intButton2,wilButton2,psyButton2,vitButton2,chaButton2,HPButton2);
                }
            });
        chaButton2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[5] = eightBitToggles(strButton2,quiButton2,intButton2,wilButton2,psyButton2,vitButton2,chaButton2,HPButton2);
                }
            });

        statCheckboxesPanel2.add(strButton2);
        statCheckboxesPanel2.add(quiButton2);
        statCheckboxesPanel2.add(vitButton2);
        statCheckboxesPanel2.add(HPButton2);
        statCheckboxesPanel2.add(intButton2);
        statCheckboxesPanel2.add(wilButton2);
        statCheckboxesPanel2.add(psyButton2);
        statCheckboxesPanel2.add(chaButton2);
    }

    /**
     * Setup gui components and logic for first elemental defense area.
     */
    private void setupElemDefArea1()
    {
        // Elemental defense/evasion modifier 1 area
        eleDefMod1Panel = new JPanel(new GridLayout(5,2));
        eleDefMod1Panel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Defense Area 1", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorRightBottomBoxDefenseBox.add(eleDefMod1Panel);

        eleDefMod1Label = new JLabel("Defense");
        eleDefMod1Label.setToolTipText("Power is added to these values, max Defense is 99; also this byte selects elements for shield evasion");
        eleDefMod1Panel.add(eleDefMod1Label);

        eleDefMod1Amount = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_AND_SIGNED_BYTE);
        eleDefMod1Amount.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    if ((Integer)eleDefMod1Amount.getSelectedItem() >=0)
                    {
                        currentEntryArray[12] = (Integer)eleDefMod1Amount.getSelectedItem();
                    }
                    else if ((Integer)eleDefMod1Amount.getSelectedItem() < 0)
                    {
                        currentEntryArray[12] = (Integer)eleDefMod1Amount.getSelectedItem() + 256;
                    }
                }
            });
        eleDefMod1Panel.add(eleDefMod1Amount);

        eleDefMod1Status = new JCheckBox("Status");
        eleDefMod1Force = new JCheckBox("Force");
        eleDefMod1Electric = new JCheckBox("Electric");
        eleDefMod1Cold = new JCheckBox("Cold");
        eleDefMod1Heat = new JCheckBox("Heat");
        eleDefMod1Blunt = new JCheckBox("Blunt");
        eleDefMod1Pierce = new JCheckBox("Pierce");
        eleDefMod1Slash = new JCheckBox("Slash");

        eleDefMod1Status.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[13] = eightBitToggles(eleDefMod1Status, eleDefMod1Force, eleDefMod1Electric, eleDefMod1Cold, eleDefMod1Heat, eleDefMod1Blunt, eleDefMod1Pierce, eleDefMod1Slash);
                }
            });
        eleDefMod1Force.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[13] = eightBitToggles(eleDefMod1Status, eleDefMod1Force, eleDefMod1Electric, eleDefMod1Cold, eleDefMod1Heat, eleDefMod1Blunt, eleDefMod1Pierce, eleDefMod1Slash);
                }
            });
        eleDefMod1Electric.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[13] = eightBitToggles(eleDefMod1Status, eleDefMod1Force, eleDefMod1Electric, eleDefMod1Cold, eleDefMod1Heat, eleDefMod1Blunt, eleDefMod1Pierce, eleDefMod1Slash);
                }
            });
        eleDefMod1Cold.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[13] = eightBitToggles(eleDefMod1Status, eleDefMod1Force, eleDefMod1Electric, eleDefMod1Cold, eleDefMod1Heat, eleDefMod1Blunt, eleDefMod1Pierce, eleDefMod1Slash);
                }
            });
        eleDefMod1Heat.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[13] = eightBitToggles(eleDefMod1Status, eleDefMod1Force, eleDefMod1Electric, eleDefMod1Cold, eleDefMod1Heat, eleDefMod1Blunt, eleDefMod1Pierce, eleDefMod1Slash);
                }
            });
        eleDefMod1Blunt.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[13] = eightBitToggles(eleDefMod1Status, eleDefMod1Force, eleDefMod1Electric, eleDefMod1Cold, eleDefMod1Heat, eleDefMod1Blunt, eleDefMod1Pierce, eleDefMod1Slash);
                }
            });
        eleDefMod1Pierce.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[13] = eightBitToggles(eleDefMod1Status, eleDefMod1Force, eleDefMod1Electric, eleDefMod1Cold, eleDefMod1Heat, eleDefMod1Blunt, eleDefMod1Pierce, eleDefMod1Slash);
                }
            });
        eleDefMod1Slash.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[13] = eightBitToggles(eleDefMod1Status, eleDefMod1Force, eleDefMod1Electric, eleDefMod1Cold, eleDefMod1Heat, eleDefMod1Blunt, eleDefMod1Pierce, eleDefMod1Slash);
                }
            });

        eleDefMod1Panel.add(eleDefMod1Status);
        eleDefMod1Panel.add(eleDefMod1Force);
        eleDefMod1Panel.add(eleDefMod1Electric);
        eleDefMod1Panel.add(eleDefMod1Cold);
        eleDefMod1Panel.add(eleDefMod1Heat);
        eleDefMod1Panel.add(eleDefMod1Blunt);
        eleDefMod1Panel.add(eleDefMod1Pierce);
        eleDefMod1Panel.add(eleDefMod1Slash);
    }

    /**
     * Setup gui and logic for elemental defense area 2.
     */
    private void setupElemDefArea2()
    {
        // Elemental defense/evasion modifier 2 area
        eleDefMod2Panel = new JPanel(new GridLayout(5,2));
        eleDefMod2Panel.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Defense Area 2", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorRightBottomBoxDefenseBox.add(eleDefMod2Panel);

        eleDefMod2Label = new JLabel("Defense");
        eleDefMod2Label.setToolTipText("Power is added to these values, max Defense is 99");
        eleDefMod2Panel.add(eleDefMod2Label);

        eleDefMod2Amount = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_AND_SIGNED_BYTE);
        eleDefMod2Amount.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    if ((Integer)eleDefMod2Amount.getSelectedItem() >= 0)
                    {
                        currentEntryArray[14] = (Integer)eleDefMod2Amount.getSelectedItem();
                    }
                    else if ((Integer)eleDefMod2Amount.getSelectedItem() < 0)
                    {
                        currentEntryArray[14] = (Integer)eleDefMod2Amount.getSelectedItem() + 256;
                    }
                    //System.out.println(itemDataStruct.get(itemName)[14]);
                }
            });
        eleDefMod2Panel.add(eleDefMod2Amount);

        eleDefMod2Status = new JCheckBox("Status");
        eleDefMod2Force = new JCheckBox("Force");
        eleDefMod2Electric = new JCheckBox("Electric");
        eleDefMod2Cold = new JCheckBox("Cold");
        eleDefMod2Heat = new JCheckBox("Heat");
        eleDefMod2Blunt = new JCheckBox("Blunt");
        eleDefMod2Pierce = new JCheckBox("Pierce");
        eleDefMod2Slash = new JCheckBox("Slash");

        eleDefMod2Status.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[15] = eightBitToggles(eleDefMod2Status, eleDefMod2Force, eleDefMod2Electric, eleDefMod2Cold, eleDefMod2Heat, eleDefMod2Blunt, eleDefMod2Pierce, eleDefMod2Slash);
                }
            });
        eleDefMod2Force.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[15] = eightBitToggles(eleDefMod2Status, eleDefMod2Force, eleDefMod2Electric, eleDefMod2Cold, eleDefMod2Heat, eleDefMod2Blunt, eleDefMod2Pierce, eleDefMod2Slash);
                }
            });
        eleDefMod2Electric.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[15] = eightBitToggles(eleDefMod2Status, eleDefMod2Force, eleDefMod2Electric, eleDefMod2Cold, eleDefMod2Heat, eleDefMod2Blunt, eleDefMod2Pierce, eleDefMod2Slash);
                }
            });
        eleDefMod2Cold.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[15] = eightBitToggles(eleDefMod2Status, eleDefMod2Force, eleDefMod2Electric, eleDefMod2Cold, eleDefMod2Heat, eleDefMod2Blunt, eleDefMod2Pierce, eleDefMod2Slash);
                }
            });
        eleDefMod2Heat.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[15] = eightBitToggles(eleDefMod2Status, eleDefMod2Force, eleDefMod2Electric, eleDefMod2Cold, eleDefMod2Heat, eleDefMod2Blunt, eleDefMod2Pierce, eleDefMod2Slash);
                }
            });
        eleDefMod2Blunt.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[15] = eightBitToggles(eleDefMod2Status, eleDefMod2Force, eleDefMod2Electric, eleDefMod2Cold, eleDefMod2Heat, eleDefMod2Blunt, eleDefMod2Pierce, eleDefMod2Slash);
                }
            });
        eleDefMod2Pierce.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[15] = eightBitToggles(eleDefMod2Status, eleDefMod2Force, eleDefMod2Electric, eleDefMod2Cold, eleDefMod2Heat, eleDefMod2Blunt, eleDefMod2Pierce, eleDefMod2Slash);
                }
            });
        eleDefMod2Slash.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[15] = eightBitToggles(eleDefMod2Status, eleDefMod2Force, eleDefMod2Electric, eleDefMod2Cold, eleDefMod2Heat, eleDefMod2Blunt, eleDefMod2Pierce, eleDefMod2Slash);
                }
            });

        eleDefMod2Panel.add(eleDefMod2Status);
        eleDefMod2Panel.add(eleDefMod2Force);
        eleDefMod2Panel.add(eleDefMod2Electric);
        eleDefMod2Panel.add(eleDefMod2Cold);
        eleDefMod2Panel.add(eleDefMod2Heat);
        eleDefMod2Panel.add(eleDefMod2Blunt);
        eleDefMod2Panel.add(eleDefMod2Pierce);
        eleDefMod2Panel.add(eleDefMod2Slash);
    }

    /**
     * Setup gui components and logic for item abilities, slot 1.
     */
    private void setupItemAbilitiesSlot1()
    {
        //Item ability slot 1 area

        itemTech1Box = new Box(BoxLayout.Y_AXIS);
        itemTech1Box.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Skill 1", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorRightTopBoxSkillsBox.add(itemTech1Box);

        itemAbilitySlot1 = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        itemTech1Box.add(itemAbilitySlot1);

        byte11Bit7Button = new JCheckBox("Use item name");
        byte11Bit7Button.setAlignmentX(0.5f);
        itemTech1Box.add(byte11Bit7Button);

        itemTech1BitsPanel = new JPanel(new GridLayout(2,3));
        itemTech1Box.add(itemTech1BitsPanel);

        byte11Bit1Button = new JCheckBox("?");
        byte11Bit2Button = new JCheckBox("?");
        byte11Bit3Button = new JCheckBox("?");
        byte11Bit4Button = new JCheckBox("?");
        byte11Bit5Button = new JCheckBox("?");
        byte11Bit6Button = new JCheckBox("?");

        byte11Bit1Button.setToolTipText("Byte 17, bit 1");
        byte11Bit2Button.setToolTipText("Byte 17, bit 2");
        byte11Bit3Button.setToolTipText("Byte 17, bit 3");
        byte11Bit4Button.setToolTipText("Byte 17, bit 4");
        byte11Bit5Button.setToolTipText("Byte 17, bit 5");
        byte11Bit6Button.setToolTipText("Byte 17, bit 6");

        itemAbilitySlot1.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String selectedItem = itemAbilitySlot1.getSelectedItem().toString();
                    char testValue= '1';
                    if (selectedItem.charAt(0) == testValue)
                    {
                        currentEntryArray[16] = itemAbilitySlot1.getSelectedIndex() - 256;
                        if((Integer)currentEntryArray[17] % 2 != 1)
                        {
                            currentEntryArray[17] += 1;
                        }
                    }
                    else
                    {
                        currentEntryArray[16] = itemAbilitySlot1.getSelectedIndex();
                        if((Integer)currentEntryArray[17] % 2 == 1)
                        {
                            currentEntryArray[17] -= 1;
                        }
                    }
                }
            });
        byte11Bit7Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[17] = itemAbilityHelper((Integer)currentEntryArray[17], byte11Bit1Button, byte11Bit2Button, byte11Bit3Button, byte11Bit4Button, byte11Bit5Button, byte11Bit6Button, byte11Bit7Button);
                }
            });
        byte11Bit1Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[17] = itemAbilityHelper((Integer)currentEntryArray[17], byte11Bit1Button, byte11Bit2Button, byte11Bit3Button, byte11Bit4Button, byte11Bit5Button, byte11Bit6Button, byte11Bit7Button);
                }
            });
        byte11Bit2Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[17] = itemAbilityHelper((Integer)currentEntryArray[17], byte11Bit1Button, byte11Bit2Button, byte11Bit3Button, byte11Bit4Button, byte11Bit5Button, byte11Bit6Button, byte11Bit7Button);
                }
            });
        byte11Bit3Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[17] = itemAbilityHelper((Integer)currentEntryArray[17], byte11Bit1Button, byte11Bit2Button, byte11Bit3Button, byte11Bit4Button, byte11Bit5Button, byte11Bit6Button, byte11Bit7Button);
                }
            });
        byte11Bit4Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[17] = itemAbilityHelper((Integer)currentEntryArray[17], byte11Bit1Button, byte11Bit2Button, byte11Bit3Button, byte11Bit4Button, byte11Bit5Button, byte11Bit6Button, byte11Bit7Button);
                }
            });
        byte11Bit5Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[17] = itemAbilityHelper((Integer)currentEntryArray[17], byte11Bit1Button, byte11Bit2Button, byte11Bit3Button, byte11Bit4Button, byte11Bit5Button, byte11Bit6Button, byte11Bit7Button);
                }
            });
        byte11Bit6Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[17] = itemAbilityHelper((Integer)currentEntryArray[17], byte11Bit1Button, byte11Bit2Button, byte11Bit3Button, byte11Bit4Button, byte11Bit5Button, byte11Bit6Button, byte11Bit7Button);
                }
            });

        itemTech1BitsPanel.add(byte11Bit1Button);
        itemTech1BitsPanel.add(byte11Bit2Button);
        itemTech1BitsPanel.add(byte11Bit3Button);
        itemTech1BitsPanel.add(byte11Bit4Button);
        itemTech1BitsPanel.add(byte11Bit5Button);
        itemTech1BitsPanel.add(byte11Bit6Button);
    }

    /**
     * Setup gui components and logic for item ability, slot 2 area.
     */
    private void setupItemAbilitiesSlot2()
    {
        //Item ability slot 2 area
        itemTech2Box = new Box(BoxLayout.Y_AXIS);
        itemTech2Box.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Skill 2", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorRightTopBoxSkillsBox.add(itemTech2Box);

        itemAbilitySlot2 = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        itemTech2Box.add(itemAbilitySlot2);

        byte13Bit7Button = new JCheckBox("Use item name");
        byte13Bit7Button.setAlignmentX(0.5f);
        itemTech2Box.add(byte13Bit7Button);

        itemTech2BitsPanel = new JPanel(new GridLayout(2,3));
        itemTech2Box.add(itemTech2BitsPanel);

        byte13Bit1Button = new JCheckBox("?");
        byte13Bit2Button = new JCheckBox("?");
        byte13Bit3Button = new JCheckBox("?");
        byte13Bit4Button = new JCheckBox("?");
        byte13Bit5Button = new JCheckBox("?");
        byte13Bit6Button = new JCheckBox("?");

        byte13Bit1Button.setToolTipText("Byte 19, bit 1");
        byte13Bit2Button.setToolTipText("Byte 19, bit 2");
        byte13Bit3Button.setToolTipText("Byte 19, bit 3");
        byte13Bit4Button.setToolTipText("Byte 19, bit 4");
        byte13Bit5Button.setToolTipText("Byte 19, bit 5");
        byte13Bit6Button.setToolTipText("Byte 19, bit 6");

        itemAbilitySlot2.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String selectedItem = itemAbilitySlot2.getSelectedItem().toString();
                    char testValue= '1';
                    if (selectedItem.charAt(0) == testValue)
                    {
                        currentEntryArray[18] = itemAbilitySlot2.getSelectedIndex() - 256;
                        if((Integer)currentEntryArray[19] % 2 != 1)
                        {
                            currentEntryArray[19] += 1;
                        }
                    }
                    else
                    {
                        currentEntryArray[18] = itemAbilitySlot2.getSelectedIndex();
                        if((Integer)currentEntryArray[19] % 2 == 1)
                        {
                            currentEntryArray[19] -= 1;
                        }
                    }
                }
            });
        byte13Bit7Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[19] = itemAbilityHelper((Integer)currentEntryArray[19], byte13Bit1Button, byte13Bit2Button, byte13Bit3Button, byte13Bit4Button, byte13Bit5Button, byte13Bit6Button, byte13Bit7Button);
                }
            });
        byte13Bit1Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[19] = itemAbilityHelper((Integer)currentEntryArray[19], byte13Bit1Button, byte13Bit2Button, byte13Bit3Button, byte13Bit4Button, byte13Bit5Button, byte13Bit6Button, byte13Bit7Button);
                }
            });
        byte13Bit2Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[19] = itemAbilityHelper((Integer)currentEntryArray[19], byte13Bit1Button, byte13Bit2Button, byte13Bit3Button, byte13Bit4Button, byte13Bit5Button, byte13Bit6Button, byte13Bit7Button);
                }
            });
        byte13Bit3Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[19] = itemAbilityHelper((Integer)currentEntryArray[19], byte13Bit1Button, byte13Bit2Button, byte13Bit3Button, byte13Bit4Button, byte13Bit5Button, byte13Bit6Button, byte13Bit7Button);
                }
            });
        byte13Bit4Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[19] = itemAbilityHelper((Integer)currentEntryArray[19], byte13Bit1Button, byte13Bit2Button, byte13Bit3Button, byte13Bit4Button, byte13Bit5Button, byte13Bit6Button, byte13Bit7Button);
                }
            });
        byte13Bit5Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[19] = itemAbilityHelper((Integer)currentEntryArray[19], byte13Bit1Button, byte13Bit2Button, byte13Bit3Button, byte13Bit4Button, byte13Bit5Button, byte13Bit6Button, byte13Bit7Button);
                }
            });
        byte13Bit6Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[19] = itemAbilityHelper((Integer)currentEntryArray[19], byte13Bit1Button, byte13Bit2Button, byte13Bit3Button, byte13Bit4Button, byte13Bit5Button, byte13Bit6Button, byte13Bit7Button);
                }
            });

        itemTech2BitsPanel.add(byte13Bit1Button);
        itemTech2BitsPanel.add(byte13Bit2Button);
        itemTech2BitsPanel.add(byte13Bit3Button);
        itemTech2BitsPanel.add(byte13Bit4Button);
        itemTech2BitsPanel.add(byte13Bit5Button);
        itemTech2BitsPanel.add(byte13Bit6Button);
    }

    /**
     * Setup gui components and logic for item ability, slot 3 area.
     */
    private void setupItemAbilitiesSlot3()
    {
        //Item ability slot 3 area
        itemTech3Box = new Box(BoxLayout.Y_AXIS);
        itemTech3Box.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Skill 3", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorRightTopBoxSkillsBox.add(itemTech3Box);

        itemAbilitySlot3 = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        itemTech3Box.add(itemAbilitySlot3);

        byte15Bit7Button = new JCheckBox("Use item name");
        byte15Bit7Button.setAlignmentX(0.5f);
        itemTech3Box.add(byte15Bit7Button);

        itemTech3BitsPanel = new JPanel(new GridLayout(2,3));
        itemTech3Box.add(itemTech3BitsPanel);

        byte15Bit1Button = new JCheckBox("?");
        byte15Bit2Button = new JCheckBox("?");
        byte15Bit3Button = new JCheckBox("?");
        byte15Bit4Button = new JCheckBox("?");
        byte15Bit5Button = new JCheckBox("?");
        byte15Bit6Button = new JCheckBox("?");

        byte15Bit1Button.setToolTipText("Byte 17, bit 1");
        byte15Bit2Button.setToolTipText("Byte 17, bit 2");
        byte15Bit3Button.setToolTipText("Byte 17, bit 3");
        byte15Bit4Button.setToolTipText("Byte 17, bit 4");
        byte15Bit5Button.setToolTipText("Byte 17, bit 5");
        byte15Bit6Button.setToolTipText("Byte 17, bit 6");

        itemAbilitySlot3.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String selectedItem = itemAbilitySlot3.getSelectedItem().toString();
                    char testValue= '1';
                    if (selectedItem.charAt(0) == testValue)
                    {
                        currentEntryArray[20] = itemAbilitySlot3.getSelectedIndex() - 256;
                        if((Integer)currentEntryArray[21] % 2 != 1)
                        {
                            currentEntryArray[21] += 1;
                        }
                    }
                    else
                    {
                        currentEntryArray[20] = itemAbilitySlot3.getSelectedIndex();
                        if((Integer)currentEntryArray[21] % 2 == 1)
                        {
                            currentEntryArray[21] -= 1;
                        }
                    }
                }
            });
        byte15Bit7Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[21] = itemAbilityHelper((Integer)currentEntryArray[21], byte15Bit1Button, byte15Bit2Button, byte15Bit3Button, byte15Bit4Button, byte15Bit5Button, byte15Bit6Button, byte15Bit7Button);
                }
            });
        byte15Bit1Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[21] = itemAbilityHelper((Integer)currentEntryArray[21], byte15Bit1Button, byte15Bit2Button, byte15Bit3Button, byte15Bit4Button, byte15Bit5Button, byte15Bit6Button, byte15Bit7Button);
                }
            });
        byte15Bit2Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[21] = itemAbilityHelper((Integer)currentEntryArray[21], byte15Bit1Button, byte15Bit2Button, byte15Bit3Button, byte15Bit4Button, byte15Bit5Button, byte15Bit6Button, byte15Bit7Button);
                }
            });
        byte15Bit3Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[21] = itemAbilityHelper((Integer)currentEntryArray[21], byte15Bit1Button, byte15Bit2Button, byte15Bit3Button, byte15Bit4Button, byte15Bit5Button, byte15Bit6Button, byte15Bit7Button);
                }
            });
        byte15Bit4Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[21] = itemAbilityHelper((Integer)currentEntryArray[21], byte15Bit1Button, byte15Bit2Button, byte15Bit3Button, byte15Bit4Button, byte15Bit5Button, byte15Bit6Button, byte15Bit7Button);
                }
            });
        byte15Bit5Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[21] = itemAbilityHelper((Integer)currentEntryArray[21], byte15Bit1Button, byte15Bit2Button, byte15Bit3Button, byte15Bit4Button, byte15Bit5Button, byte15Bit6Button, byte15Bit7Button);
                }
            });
        byte15Bit6Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[21] = itemAbilityHelper((Integer)currentEntryArray[21], byte15Bit1Button, byte15Bit2Button, byte15Bit3Button, byte15Bit4Button, byte15Bit5Button, byte15Bit6Button, byte15Bit7Button);
                }
            });

        itemTech3BitsPanel.add(byte15Bit1Button);
        itemTech3BitsPanel.add(byte15Bit2Button);
        itemTech3BitsPanel.add(byte15Bit3Button);
        itemTech3BitsPanel.add(byte15Bit4Button);
        itemTech3BitsPanel.add(byte15Bit5Button);
        itemTech3BitsPanel.add(byte15Bit6Button);
    }

    /**
     * Setup gui components and logic for item ability, slot 1 trigger area.
     */
    private void setupItemAbilitiesSlot1TriggerArea()
    {
        // Item ability slot 1 trigger area
        itemTech1TriggerBox = new Box(BoxLayout.Y_AXIS);
        itemTech1TriggerBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Skill 1 Trigger", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorRightTopBoxTriggersBox.add(itemTech1TriggerBox);

        itemAbilitySlot1Trigger = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        itemTech1TriggerBox.add(itemAbilitySlot1Trigger);

        itemTech1TriggerBitsPanel = new JPanel(new GridLayout(2,4));
        itemTech1TriggerBox.add(itemTech1TriggerBitsPanel);

        byte17Bit1Button = new JCheckBox("?");
        byte17Bit2Button = new JCheckBox("?");
        byte17Bit3Button = new JCheckBox("?");
        byte17Bit4Button = new JCheckBox("?");
        byte17Bit5Button = new JCheckBox("?");
        byte17Bit6Button = new JCheckBox("?");
        byte17Bit7Button = new JCheckBox("?");

        byte17Bit1Button.setToolTipText("Byte 23, bit 1");
        byte17Bit2Button.setToolTipText("Byte 23, bit 2");
        byte17Bit3Button.setToolTipText("Byte 23, bit 3");
        byte17Bit4Button.setToolTipText("Byte 23, bit 4");
        byte17Bit5Button.setToolTipText("Byte 23, bit 5");
        byte17Bit6Button.setToolTipText("Byte 23, bit 6");
        byte17Bit7Button.setToolTipText("Byte 23, bit 7");

        itemAbilitySlot1Trigger.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String selectedItem = itemAbilitySlot1Trigger.getSelectedItem().toString();
                    char testValue= '1';
                    if (selectedItem.charAt(0) == testValue)
                    {
                        currentEntryArray[22] = itemAbilitySlot1Trigger.getSelectedIndex() - 256;
                        if((Integer)currentEntryArray[23] % 2 != 1)
                        {
                            currentEntryArray[23] += 1;
                        }
                    }
                    else
                    {
                        currentEntryArray[22] = itemAbilitySlot1Trigger.getSelectedIndex();
                        if((Integer)currentEntryArray[23] % 2 == 1)
                        {
                            currentEntryArray[23] -= 1;
                        }
                    }
                }
            });
        byte17Bit1Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[23] = itemAbilityHelper((Integer)currentEntryArray[23], byte17Bit1Button, byte17Bit2Button, byte17Bit3Button, byte17Bit4Button, byte17Bit5Button, byte17Bit6Button, byte17Bit7Button);
                }
            });
        byte17Bit2Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[23] = itemAbilityHelper((Integer)currentEntryArray[23], byte17Bit1Button, byte17Bit2Button, byte17Bit3Button, byte17Bit4Button, byte17Bit5Button, byte17Bit6Button, byte17Bit7Button);
                }
            });
        byte17Bit3Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[23] = itemAbilityHelper((Integer)currentEntryArray[23], byte17Bit1Button, byte17Bit2Button, byte17Bit3Button, byte17Bit4Button, byte17Bit5Button, byte17Bit6Button, byte17Bit7Button);
                }
            });
        byte17Bit4Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[23] = itemAbilityHelper((Integer)currentEntryArray[23], byte17Bit1Button, byte17Bit2Button, byte17Bit3Button, byte17Bit4Button, byte17Bit5Button, byte17Bit6Button, byte17Bit7Button);
                }
            });
        byte17Bit5Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[23] = itemAbilityHelper((Integer)currentEntryArray[23], byte17Bit1Button, byte17Bit2Button, byte17Bit3Button, byte17Bit4Button, byte17Bit5Button, byte17Bit6Button, byte17Bit7Button);
                }
            });
        byte17Bit6Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[23] = itemAbilityHelper((Integer)currentEntryArray[23], byte17Bit1Button, byte17Bit2Button, byte17Bit3Button, byte17Bit4Button, byte17Bit5Button, byte17Bit6Button, byte17Bit7Button);
                }
            });
        byte17Bit7Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[23] = itemAbilityHelper((Integer)currentEntryArray[23], byte17Bit1Button, byte17Bit2Button, byte17Bit3Button, byte17Bit4Button, byte17Bit5Button, byte17Bit6Button, byte17Bit7Button);
                }
            });

        itemTech1TriggerBitsPanel.add(byte17Bit1Button);
        itemTech1TriggerBitsPanel.add(byte17Bit2Button);
        itemTech1TriggerBitsPanel.add(byte17Bit3Button);
        itemTech1TriggerBitsPanel.add(byte17Bit4Button);
        itemTech1TriggerBitsPanel.add(byte17Bit5Button);
        itemTech1TriggerBitsPanel.add(byte17Bit6Button);
        itemTech1TriggerBitsPanel.add(byte17Bit7Button);
    }

    /**
     * Setup gui components and logic for item ability, slot 2 trigger area.
     */
    private void setupItemAbilitiesSlot2TriggerArea()
    {
        // Item ability slot 2 trigger area
        itemTech2TriggerBox = new Box(BoxLayout.Y_AXIS);
        itemTech2TriggerBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Skill 2 Trigger", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorRightTopBoxTriggersBox.add(itemTech2TriggerBox);

        itemAbilitySlot2Trigger = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        itemTech2TriggerBox.add(itemAbilitySlot2Trigger);

        itemTech2TriggerBitsPanel = new JPanel(new GridLayout(2,4));
        itemTech2TriggerBox.add(itemTech2TriggerBitsPanel);

        byte19Bit1Button = new JCheckBox("?");
        byte19Bit2Button = new JCheckBox("?");
        byte19Bit3Button = new JCheckBox("?");
        byte19Bit4Button = new JCheckBox("?");
        byte19Bit5Button = new JCheckBox("?");
        byte19Bit6Button = new JCheckBox("?");
        byte19Bit7Button = new JCheckBox("?");

        byte19Bit1Button.setToolTipText("Byte 25, bit 1");
        byte19Bit2Button.setToolTipText("Byte 25, bit 2");
        byte19Bit3Button.setToolTipText("Byte 25, bit 3");
        byte19Bit4Button.setToolTipText("Byte 25, bit 4");
        byte19Bit5Button.setToolTipText("Byte 25, bit 5");
        byte19Bit6Button.setToolTipText("Byte 25, bit 6");
        byte19Bit7Button.setToolTipText("Byte 25, bit 7");

        itemAbilitySlot2Trigger.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String selectedItem = itemAbilitySlot2Trigger.getSelectedItem().toString();
                    char testValue= '1';
                    if (selectedItem.charAt(0) == testValue)
                    {
                        currentEntryArray[24] = itemAbilitySlot2Trigger.getSelectedIndex() - 256;
                        if((Integer)currentEntryArray[25] % 2 != 1)
                        {
                            currentEntryArray[25] += 1;
                        }
                    }
                    else
                    {
                        currentEntryArray[24] = itemAbilitySlot2Trigger.getSelectedIndex();
                        if((Integer)currentEntryArray[25] % 2 == 1)
                        {
                            currentEntryArray[25] -= 1;
                        }
                    }
                }
            });
        byte19Bit1Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[25] = itemAbilityHelper((Integer)currentEntryArray[25], byte19Bit1Button, byte19Bit2Button, byte19Bit3Button, byte19Bit4Button, byte19Bit5Button, byte19Bit6Button, byte19Bit7Button);
                }
            });
        byte19Bit2Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[25] = itemAbilityHelper((Integer)currentEntryArray[25], byte19Bit1Button, byte19Bit2Button, byte19Bit3Button, byte19Bit4Button, byte19Bit5Button, byte19Bit6Button, byte19Bit7Button);
                }
            });
        byte19Bit3Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[25] = itemAbilityHelper((Integer)currentEntryArray[25], byte19Bit1Button, byte19Bit2Button, byte19Bit3Button, byte19Bit4Button, byte19Bit5Button, byte19Bit6Button, byte19Bit7Button);
                }
            });
        byte19Bit4Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[25] = itemAbilityHelper((Integer)currentEntryArray[25], byte19Bit1Button, byte19Bit2Button, byte19Bit3Button, byte19Bit4Button, byte19Bit5Button, byte19Bit6Button, byte19Bit7Button);
                }
            });
        byte19Bit5Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[25] = itemAbilityHelper((Integer)currentEntryArray[25], byte19Bit1Button, byte19Bit2Button, byte19Bit3Button, byte19Bit4Button, byte19Bit5Button, byte19Bit6Button, byte19Bit7Button);
                }
            });
        byte19Bit6Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[25] = itemAbilityHelper((Integer)currentEntryArray[25], byte19Bit1Button, byte19Bit2Button, byte19Bit3Button, byte19Bit4Button, byte19Bit5Button, byte19Bit6Button, byte19Bit7Button);
                }
            });
        byte19Bit7Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[25] = itemAbilityHelper((Integer)currentEntryArray[25], byte19Bit1Button, byte19Bit2Button, byte19Bit3Button, byte19Bit4Button, byte19Bit5Button, byte19Bit6Button, byte19Bit7Button);
                }
            });

        itemTech2TriggerBitsPanel.add(byte19Bit1Button);
        itemTech2TriggerBitsPanel.add(byte19Bit2Button);
        itemTech2TriggerBitsPanel.add(byte19Bit3Button);
        itemTech2TriggerBitsPanel.add(byte19Bit4Button);
        itemTech2TriggerBitsPanel.add(byte19Bit5Button);
        itemTech2TriggerBitsPanel.add(byte19Bit6Button);
        itemTech2TriggerBitsPanel.add(byte19Bit7Button);
    }

    /**
     * Setup gui components and logic for item ability, slot 2 trigger area.
     */
    private void setupItemAbilitiesSlot3TriggerArea()
    {
        // Item ability slot 3 trigger area
        itemTech3TriggerBox = new Box(BoxLayout.Y_AXIS);
        itemTech3TriggerBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Skill 3 Trigger", TitledBorder.CENTER, TitledBorder.CENTER));
        MajorRightTopBoxTriggersBox.add(itemTech3TriggerBox);

        itemAbilitySlot3Trigger = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        itemTech3TriggerBox.add(itemAbilitySlot3Trigger);

        itemTech3TriggerBitsPanel = new JPanel(new GridLayout(2,4));
        itemTech3TriggerBox.add(itemTech3TriggerBitsPanel);

        byte1BBit1Button = new JCheckBox("?");
        byte1BBit2Button = new JCheckBox("?");
        byte1BBit3Button = new JCheckBox("?");
        byte1BBit4Button = new JCheckBox("?");
        byte1BBit5Button = new JCheckBox("?");
        byte1BBit6Button = new JCheckBox("?");
        byte1BBit7Button = new JCheckBox("?");

        byte1BBit1Button.setToolTipText("Byte 27, bit 1");
        byte1BBit2Button.setToolTipText("Byte 27, bit 2");
        byte1BBit3Button.setToolTipText("Byte 27, bit 3");
        byte1BBit4Button.setToolTipText("Byte 27, bit 4");
        byte1BBit5Button.setToolTipText("Byte 27, bit 5");
        byte1BBit6Button.setToolTipText("Byte 27, bit 6");
        byte1BBit7Button.setToolTipText("Byte 27, bit 7");

        itemAbilitySlot3Trigger.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    String selectedItem = itemAbilitySlot3Trigger.getSelectedItem().toString();
                    char testValue= '1';
                    if (selectedItem.charAt(0) == testValue)
                    {
                        currentEntryArray[26] = itemAbilitySlot3Trigger.getSelectedIndex() - 256;
                        if((Integer)currentEntryArray[27] % 2 != 1)
                        {
                            currentEntryArray[27] += 1;
                        }
                    }
                    else
                    {
                        currentEntryArray[26] = itemAbilitySlot3Trigger.getSelectedIndex();
                        if((Integer)currentEntryArray[27] % 2 == 1)
                        {
                            currentEntryArray[27] -= 1;
                        }
                    }
                }
            });
        byte1BBit1Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[27] = itemAbilityHelper((Integer)currentEntryArray[27], byte1BBit1Button, byte1BBit2Button, byte1BBit3Button, byte1BBit4Button, byte1BBit5Button, byte1BBit6Button, byte1BBit7Button);
                }
            });
        byte1BBit2Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[27] = itemAbilityHelper((Integer)currentEntryArray[27], byte1BBit1Button, byte1BBit2Button, byte1BBit3Button, byte1BBit4Button, byte1BBit5Button, byte1BBit6Button, byte1BBit7Button);
                }
            });
        byte1BBit3Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[27] = itemAbilityHelper((Integer)currentEntryArray[27], byte1BBit1Button, byte1BBit2Button, byte1BBit3Button, byte1BBit4Button, byte1BBit5Button, byte1BBit6Button, byte1BBit7Button);
                }
            });
        byte1BBit4Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[27] = itemAbilityHelper((Integer)currentEntryArray[27], byte1BBit1Button, byte1BBit2Button, byte1BBit3Button, byte1BBit4Button, byte1BBit5Button, byte1BBit6Button, byte1BBit7Button);
                }
            });
        byte1BBit5Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[27] = itemAbilityHelper((Integer)currentEntryArray[27], byte1BBit1Button, byte1BBit2Button, byte1BBit3Button, byte1BBit4Button, byte1BBit5Button, byte1BBit6Button, byte1BBit7Button);
                }
            });
        byte1BBit6Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[27] = itemAbilityHelper((Integer)currentEntryArray[27], byte1BBit1Button, byte1BBit2Button, byte1BBit3Button, byte1BBit4Button, byte1BBit5Button, byte1BBit6Button, byte1BBit7Button);
                }
            });
        byte1BBit7Button.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[27] = itemAbilityHelper((Integer)currentEntryArray[27], byte1BBit1Button, byte1BBit2Button, byte1BBit3Button, byte1BBit4Button, byte1BBit5Button, byte1BBit6Button, byte1BBit7Button);
                }
            });

        itemTech3TriggerBitsPanel.add(byte1BBit1Button);
        itemTech3TriggerBitsPanel.add(byte1BBit2Button);
        itemTech3TriggerBitsPanel.add(byte1BBit3Button);
        itemTech3TriggerBitsPanel.add(byte1BBit4Button);
        itemTech3TriggerBitsPanel.add(byte1BBit5Button);
        itemTech3TriggerBitsPanel.add(byte1BBit6Button);
        itemTech3TriggerBitsPanel.add(byte1BBit7Button);
    }

    // This is the end of the logic setup methods.
    // Below is the method to initialize objects.

    /**
     * Initializes state of DataHandler objects to match first item in itemSelector.
     */
    private void initializeItems()
    {
        //Set item ID area
        itemID.setSelectedItem(currentEntryArray[0]);
        //Set item weight area
        itemWeight.setSelectedItem(currentEntryArray[1]);
        //Set stat boost area
        if (currentEntryArray[2]>=128)
        {
            mec1.setSelected(false);
            other1.setSelected(true);
            statAmount1.setSelectedItem(currentEntryArray[2] - 128);
        }
        else if (currentEntryArray[2]<128)
        {
            mec1.setSelected(true);
            other1.setSelected(false);
            statAmount1.setSelectedItem(currentEntryArray[2]);
        }
        int byte3Int = currentEntryArray[3];
        boolean[] byte3Bools = {false, false, false, false, false, false, false, false};
        if (byte3Int >= 128)
        {
            byte3Int -= 128;
            byte3Bools[7] = true;
        }
        if (byte3Int >= 64)
        {
            byte3Int -= 64;
            byte3Bools[6] = true;
        }
        if (byte3Int >= 32)
        {
            byte3Int -= 32;
            byte3Bools[5] = true;
        }
        if (byte3Int >= 16)
        {
            byte3Int -= 16;
            byte3Bools[4] = true;
        }
        if (byte3Int >= 8)
        {
            byte3Int -= 8;
            byte3Bools[3] = true;
        }
        if (byte3Int >=4)
        {
            byte3Int -=4;
            byte3Bools[2] = true;
        }
        if (byte3Int >= 2)
        {
            byte3Int -= 2;
            byte3Bools[1] = true;
        }
        if (byte3Int >= 1)
        {
            byte3Int -= 1;
            byte3Bools[0] = true;
        }
        strButton1.setSelected(byte3Bools[0]);
        quiButton1.setSelected(byte3Bools[1]);
        intButton1.setSelected(byte3Bools[2]);
        wilButton1.setSelected(byte3Bools[3]);
        psyButton1.setSelected(byte3Bools[4]);
        vitButton1.setSelected(byte3Bools[5]);
        chaButton1.setSelected(byte3Bools[6]);
        HPButton1.setSelected(byte3Bools[7]);
        if (currentEntryArray[4]>=128)
        {
            mec2.setSelected(false);
            other2.setSelected(true);
            statAmount2.setSelectedItem(currentEntryArray[4] - 128);
        }
        else if (currentEntryArray[4]<128)
        {
            mec2.setSelected(true);
            other2.setSelected(false);
            statAmount2.setSelectedItem(currentEntryArray[4]);
        }
        int byte5Int = currentEntryArray[5];
        boolean[] byte5Bools = {false, false, false, false, false, false, false, false};
        if (byte5Int >= 128)
        {
            byte5Int -= 128;
            byte5Bools[7] = true;
        }
        if (byte5Int >= 64)
        {
            byte5Int -= 64;
            byte5Bools[6] = true;
        }
        if (byte5Int >= 32)
        {
            byte5Int -= 32;
            byte5Bools[5] = true;
        }
        if (byte5Int >= 16)
        {
            byte5Int -= 16;
            byte5Bools[4] = true;
        }
        if (byte5Int >= 8)
        {
            byte5Int -= 8;
            byte5Bools[3] = true;
        }
        if (byte5Int >=4)
        {
            byte5Int -=4;
            byte5Bools[2] = true;
        }
        if (byte5Int >= 2)
        {
            byte5Int -= 2;
            byte5Bools[1] = true;
        }
        if (byte5Int >= 1)
        {
            byte5Int -= 1;
            byte5Bools[0] = true;
        }
        strButton2.setSelected(byte5Bools[0]);
        quiButton2.setSelected(byte5Bools[1]);
        intButton2.setSelected(byte5Bools[2]);
        wilButton2.setSelected(byte5Bools[3]);
        psyButton2.setSelected(byte5Bools[4]);
        vitButton2.setSelected(byte5Bools[5]);
        chaButton2.setSelected(byte5Bools[6]);
        HPButton2.setSelected(byte5Bools[7]);
        // Set unremovable and base power
        if (currentEntryArray[6] >= 128)
        {
            unremovable.setSelected(true);
            basePower.setSelectedItem(currentEntryArray[6] - 128);
        }
        else if (currentEntryArray[6] < 128)
        {
            unremovable.setSelected(false);
            basePower.setSelectedItem(currentEntryArray[6]);
        }
        //Set ammo
        maxAmmo.setSelectedItem(currentEntryArray[7]);
        //Set accuracy modifier
        if (currentEntryArray[8] < 128)
        {
            accuracyModifier.setSelectedItem(currentEntryArray[8]);
        }
        else if (currentEntryArray[8] >= 128)
        {
            accuracyModifier.setSelectedItem(currentEntryArray[8] - 256);
        }
        //Set special attributes.
        boolean[] byte9Bools = {false, false, false, false, false, false, false, false};
        int byte9Int = currentEntryArray[9];
        if (byte9Int >= 128)
        {
            byte9Bools[0] = true;
            byte9Int -= 128;
        }
        if (byte9Int >= 64)
        {
            byte9Bools[1] = true;
            byte9Int -= 64;
        }
        if (byte9Int >= 32)
        {
            byte9Bools[2] = true;
            byte9Int -= 32;
        }
        if (byte9Int >= 16)
        {
            byte9Bools[3] = true;
            byte9Int -= 16;
        }
        if (byte9Int >= 8)
        {
            byte9Bools[4] = true;
            byte9Int -= 8;
        }
        if (byte9Int >= 4)
        {
            byte9Bools[5] = true;
            byte9Int -= 4;
        }
        if (byte9Int >= 2)
        {
            byte9Bools[6] = true;
            byte9Int -= 2;
        }
        if (byte9Int >= 1)
        {
            byte9Bools[7] = true;
            byte9Int -= 1;
        }
        itemAttrGround.setSelected(byte9Bools[0]);
        itemAttrGaze.setSelected(byte9Bools[1]);
        itemAttrSonic.setSelected(byte9Bools[2]);
        itemAttrNonContact.setSelected(byte9Bools[3]);
        itemAttrLiquid.setSelected(byte9Bools[4]);
        itemAttrContact.setSelected(byte9Bools[5]);
        itemAttrBit1.setSelected(byte9Bools[6]);
        itemAttrAntiAir.setSelected(byte9Bools[7]);
        //Set status Immunities
        boolean[] byteABools = {false,false,false,false,false,false,false,false};
        int byteAInt = currentEntryArray[10];
        if (byteAInt >= 128)
        {
            byteABools[7] = true;
            byteAInt -= 128;
        }
        if (byteAInt >= 64)
        {
            byteABools[6] = true;
            byteAInt -= 64;
        }
        if (byteAInt >= 32)
        {
            byteABools[5] = true;
            byteAInt -= 32;
        }
        if (byteAInt >= 16)
        {
            byteABools[4] = true;
            byteAInt -= 16;
        }
        if (byteAInt >= 8)
        {
            byteABools[3] = true;
            byteAInt -= 4;
        }
        if (byteAInt >= 4)
        {
            byteABools[2] = true;
            byteAInt -= 4;
        }
        if (byteAInt >= 2)
        {
            byteABools[1] = true;
            byteAInt -= 2;
        }
        if (byteAInt >= 1)
        {
            byteABools[0] = true;
            byteAInt -= 1;
        }
        boolean[] byteBBools = {false,false,false,false,false,false,false,false};
        int byteBInt = currentEntryArray[11];
        if (byteBInt >= 128)
        {
            byteBBools[7] = true;
            byteBInt -= 128;
        }
        if (byteBInt >= 64)
        {
            byteBBools[6] = true;
            byteBInt -= 64;
        }
        if (byteBInt >= 32)
        {
            byteBBools[5] = true;
            byteBInt -= 32;
        }
        if (byteBInt >= 16)
        {
            byteBBools[4] = true;
            byteBInt -= 16;
        }
        if (byteBInt >= 8)
        {
            byteBBools[3] = true;
            byteBInt -= 4;
        }
        if (byteBInt >= 4)
        {
            byteBBools[2] = true;
            byteBInt -= 4;
        }
        if (byteBInt >= 2)
        {
            byteBBools[1] = true;
            byteBInt -= 2;
        }
        if (byteBInt >= 1)
        {
            byteBBools[0] = true;
            byteBInt -= 1;
        }
        itemStatusImmuByteABit0.setSelected(byteABools[0]);
        itemStatusImmuByteABit1.setSelected(byteABools[1]);
        itemStatusImmuByteABit2.setSelected(byteABools[2]);
        itemStatusImmuByteABit3.setSelected(byteABools[3]);
        itemStatusImmuByteABit4.setSelected(byteABools[4]);
        itemStatusImmuByteABit5.setSelected(byteABools[5]);
        itemStatusImmuBlindness.setSelected(byteABools[6]);
        itemStatusImmuPetrify.setSelected(byteABools[7]);
        itemStatusImmuPoison.setSelected(byteBBools[0]);
        itemStatusImmuFaint.setSelected(byteBBools[1]);
        itemStatusImmuStun.setSelected(byteBBools[2]);
        itemStatusImmuKnockback.setSelected(byteBBools[3]);
        itemStatusImmuPsychout.setSelected(byteBBools[4]);
        itemStatusImmuSleep.setSelected(byteBBools[5]);
        itemStatusImmuPalsy.setSelected(byteBBools[6]);
        itemStatusImmuByteBBit7.setSelected(byteBBools[7]);
        // Elemental Defense area
        // Modifier 1
        if ((Integer)itemID.getSelectedItem() < 128)
        {
            eleDefMod1Amount.setSelectedItem(currentEntryArray[12]);
        }
        else if ((Integer)itemID.getSelectedItem() >= 128)
        {
            if (currentEntryArray[12] < 128)
            {
                eleDefMod1Amount.setSelectedItem(currentEntryArray[12]);
            }
            else if (currentEntryArray[12] >= 128)
            {
                eleDefMod1Amount.setSelectedItem(currentEntryArray[12] - 256);
            }
        }
        int byteDInt = currentEntryArray[13];
        boolean[] byteDBools = {false, false, false, false, false, false, false, false};
        if (byteDInt >= 128)
        {
            byteDBools[7] = true;
            byteDInt -= 128;
        }
        if (byteDInt >= 64)
        {
            byteDBools[6] = true;
            byteDInt -= 64;
        }
        if (byteDInt >= 32)
        {
            byteDBools[5] = true;
            byteDInt -= 32;
        }
        if (byteDInt >= 16)
        {
            byteDBools[4] = true;
            byteDInt -= 16;
        }
        if (byteDInt >= 8)
        {
            byteDBools[3] = true;
            byteDInt -= 8;
        }
        if (byteDInt >= 4)
        {
            byteDBools[2] = true;
            byteDInt -= 4;
        }
        if (byteDInt >= 2)
        {
            byteDBools[1] = true;
            byteDInt -= 2;
        }
        if (byteDInt >= 1)
        {
            byteDBools[0] = true;
            byteDInt -= 1;
        }
        eleDefMod1Status.setSelected(byteDBools[0]);
        eleDefMod1Force.setSelected(byteDBools[1]);
        eleDefMod1Electric.setSelected(byteDBools[2]);
        eleDefMod1Cold.setSelected(byteDBools[3]);
        eleDefMod1Heat.setSelected(byteDBools[4]);
        eleDefMod1Blunt.setSelected(byteDBools[5]);
        eleDefMod1Pierce.setSelected(byteDBools[6]);
        eleDefMod1Slash.setSelected(byteDBools[7]);
        //element defense area 2
        if ((Integer)itemID.getSelectedItem() < 128)
        {
            eleDefMod2Amount.setSelectedItem(currentEntryArray[14]);
        }
        else if ((Integer)itemID.getSelectedItem() >= 128)
        {
            if (currentEntryArray[14] < 128)
            {
                eleDefMod2Amount.setSelectedItem(currentEntryArray[14]);
            }
            else if (currentEntryArray[14] >= 128)
            {
                eleDefMod2Amount.setSelectedItem(currentEntryArray[14] - 256);
            }
        }
        int byteFInt = currentEntryArray[15];
        boolean[] byteFBools = {false, false, false, false, false, false, false, false};
        if (byteFInt >= 128)
        {
            byteFBools[7] = true;
            byteFInt -= 128;
        }
        if (byteFInt >= 64)
        {
            byteFBools[6] = true;
            byteFInt -= 64;
        }
        if (byteFInt >= 32)
        {
            byteFBools[5] = true;
            byteFInt -= 32;
        }
        if (byteFInt >= 16)
        {
            byteFBools[4] = true;
            byteFInt -= 16;
        }
        if (byteFInt >= 8)
        {
            byteFBools[3] = true;
            byteFInt -= 8;
        }
        if (byteFInt >= 4)
        {
            byteFBools[2] = true;
            byteFInt -= 4;
        }
        if (byteFInt >= 2)
        {
            byteFBools[1] = true;
            byteFInt -= 2;
        }
        if (byteFInt >= 1)
        {
            byteFBools[0] = true;
            byteFInt -= 1;
        }
        eleDefMod2Status.setSelected(byteFBools[0]);
        eleDefMod2Force.setSelected(byteFBools[1]);
        eleDefMod2Electric.setSelected(byteFBools[2]);
        eleDefMod2Cold.setSelected(byteFBools[3]);
        eleDefMod2Heat.setSelected(byteFBools[4]);
        eleDefMod2Blunt.setSelected(byteFBools[5]);
        eleDefMod2Pierce.setSelected(byteFBools[6]);
        eleDefMod2Slash.setSelected(byteFBools[7]);
        //Ability slot 1 area
        int byte0x10Int = currentEntryArray[16];
        int byte0x11Int = currentEntryArray[17];
        boolean[] byte0x11Bools = {false,false,false,false,false,false,false,false};
        if (byte0x11Int >= 128)
        {
            byte0x11Bools[7] = true;
            byte0x11Int -= 128;
        }
        if (byte0x11Int >= 64)
        {
            byte0x11Bools[6] = true;
            byte0x11Int -= 64;
        }
        if (byte0x11Int >= 32)
        {
            byte0x11Bools[5] = true;
            byte0x11Int -= 32;
        }
        if (byte0x11Int >= 16)
        {
            byte0x11Bools[4] = true;
            byte0x11Int -= 16;
        }
        if (byte0x11Int >= 8)
        {
            byte0x11Bools[3] = true;
            byte0x11Int -= 8;
        }
        if (byte0x11Int >= 4)
        {
            byte0x11Bools[2] = true;
            byte0x11Int -= 4;
        }
        if (byte0x11Int >= 2)
        {
            byte0x11Bools[1] = true;
            byte0x11Int -= 2;
        }
        if (byte0x11Int >= 1)
        {
            byte0x11Bools[0] = true;
            byte0x11Int -= 1;
            byte0x10Int += 256;
        }
        itemAbilitySlot1.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[byte0x10Int]);
        byte11Bit1Button.setSelected(byte0x11Bools[1]);
        byte11Bit2Button.setSelected(byte0x11Bools[2]);
        byte11Bit3Button.setSelected(byte0x11Bools[3]);
        byte11Bit4Button.setSelected(byte0x11Bools[4]);
        byte11Bit5Button.setSelected(byte0x11Bools[5]);
        byte11Bit6Button.setSelected(byte0x11Bools[6]);
        byte11Bit7Button.setSelected(byte0x11Bools[7]);

        //Ability slot 2 area
        int byte0x12Int = currentEntryArray[18];
        int byte0x13Int = currentEntryArray[19];
        boolean[] byte0x13Bools = {false,false,false,false,false,false,false,false};
        if (byte0x13Int >= 128)
        {
            byte0x13Bools[7] = true;
            byte0x13Int -= 128;
        }
        if (byte0x13Int >= 64)
        {
            byte0x13Bools[6] = true;
            byte0x13Int -= 64;
        }
        if (byte0x13Int >= 32)
        {
            byte0x13Bools[5] = true;
            byte0x13Int -= 32;
        }
        if (byte0x13Int >= 16)
        {
            byte0x13Bools[4] = true;
            byte0x13Int -= 16;
        }
        if (byte0x13Int >= 8)
        {
            byte0x13Bools[3] = true;
            byte0x13Int -= 8;
        }
        if (byte0x13Int >= 4)
        {
            byte0x13Bools[2] = true;
            byte0x13Int -= 4;
        }
        if (byte0x13Int >= 2)
        {
            byte0x13Bools[1] = true;
            byte0x13Int -= 2;
        }
        if (byte0x13Int >= 1)
        {
            byte0x13Bools[0] = true;
            byte0x13Int -= 1;
            byte0x12Int += 256;
        }
        itemAbilitySlot2.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[byte0x12Int]);
        byte13Bit1Button.setSelected(byte0x13Bools[1]);
        byte13Bit2Button.setSelected(byte0x13Bools[2]);
        byte13Bit3Button.setSelected(byte0x13Bools[3]);
        byte13Bit4Button.setSelected(byte0x13Bools[4]);
        byte13Bit5Button.setSelected(byte0x13Bools[5]);
        byte13Bit6Button.setSelected(byte0x13Bools[6]);
        byte13Bit7Button.setSelected(byte0x13Bools[7]);

        //Ability slot 3 area
        int byte0x14Int = currentEntryArray[20];
        int byte0x15Int = currentEntryArray[21];
        boolean[] byte0x15Bools = {false,false,false,false,false,false,false,false};
        if (byte0x15Int >= 128)
        {
            byte0x15Bools[7] = true;
            byte0x15Int -= 128;
        }
        if (byte0x15Int >= 64)
        {
            byte0x15Bools[6] = true;
            byte0x15Int -= 64;
        }
        if (byte0x15Int >= 32)
        {
            byte0x15Bools[5] = true;
            byte0x15Int -= 32;
        }
        if (byte0x15Int >= 16)
        {
            byte0x15Bools[4] = true;
            byte0x15Int -= 16;
        }
        if (byte0x15Int >= 8)
        {
            byte0x15Bools[3] = true;
            byte0x15Int -= 8;
        }
        if (byte0x15Int >= 4)
        {
            byte0x15Bools[2] = true;
            byte0x15Int -= 4;
        }
        if (byte0x15Int >= 2)
        {
            byte0x15Bools[1] = true;
            byte0x13Int -= 2;
        }
        if (byte0x15Int >= 1)
        {
            byte0x15Bools[0] = true;
            byte0x15Int -= 1;
            byte0x14Int += 256;
        }
        itemAbilitySlot3.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[byte0x14Int]);
        byte15Bit1Button.setSelected(byte0x15Bools[1]);
        byte15Bit2Button.setSelected(byte0x15Bools[2]);
        byte15Bit3Button.setSelected(byte0x15Bools[3]);
        byte15Bit4Button.setSelected(byte0x15Bools[4]);
        byte15Bit5Button.setSelected(byte0x15Bools[5]);
        byte15Bit6Button.setSelected(byte0x15Bools[6]);
        byte15Bit7Button.setSelected(byte0x15Bools[7]);

        //Trigger ability slot 1 area
        int byte0x16Int = currentEntryArray[22];
        int byte0x17Int = currentEntryArray[23];
        boolean[] byte0x17Bools = {false,false,false,false,false,false,false,false};
        if (byte0x17Int >= 128)
        {
            byte0x17Bools[7] = true;
            byte0x17Int -= 128;
        }
        if (byte0x17Int >= 64)
        {
            byte0x17Bools[6] = true;
            byte0x17Int -= 64;
        }
        if (byte0x17Int >= 32)
        {
            byte0x17Bools[5] = true;
            byte0x17Int -= 32;
        }
        if (byte0x17Int >= 16)
        {
            byte0x17Bools[4] = true;
            byte0x17Int -= 16;
        }
        if (byte0x17Int >= 8)
        {
            byte0x17Bools[3] = true;
            byte0x17Int -= 8;
        }
        if (byte0x17Int >= 4)
        {
            byte0x17Bools[2] = true;
            byte0x17Int -= 4;
        }
        if (byte0x17Int >= 2)
        {
            byte0x17Bools[1] = true;
            byte0x17Int -= 2;
        }
        if (byte0x17Int >= 1)
        {
            byte0x17Bools[0] = true;
            byte0x17Int -= 1;
            byte0x16Int += 256;
        }
        itemAbilitySlot1Trigger.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[byte0x16Int]);
        byte17Bit1Button.setSelected(byte0x17Bools[1]);
        byte17Bit2Button.setSelected(byte0x17Bools[2]);
        byte17Bit3Button.setSelected(byte0x17Bools[3]);
        byte17Bit4Button.setSelected(byte0x17Bools[4]);
        byte17Bit5Button.setSelected(byte0x17Bools[5]);
        byte17Bit6Button.setSelected(byte0x17Bools[6]);
        byte17Bit7Button.setSelected(byte0x17Bools[7]);

        //Trigger ability slot 2 area
        int byte0x18Int = currentEntryArray[24];
        int byte0x19Int = currentEntryArray[25];
        boolean[] byte0x19Bools = {false,false,false,false,false,false,false,false};
        if (byte0x19Int >= 128)
        {
            byte0x19Bools[7] = true;
            byte0x19Int -= 128;
        }
        if (byte0x19Int >= 64)
        {
            byte0x19Bools[6] = true;
            byte0x19Int -= 64;
        }
        if (byte0x19Int >= 32)
        {
            byte0x19Bools[5] = true;
            byte0x19Int -= 32;
        }
        if (byte0x19Int >= 16)
        {
            byte0x19Bools[4] = true;
            byte0x19Int -= 16;
        }
        if (byte0x19Int >= 8)
        {
            byte0x19Bools[3] = true;
            byte0x19Int -= 8;
        }
        if (byte0x19Int >= 4)
        {
            byte0x19Bools[2] = true;
            byte0x19Int -= 4;
        }
        if (byte0x19Int >= 2)
        {
            byte0x19Bools[1] = true;
            byte0x19Int -= 2;
        }
        if (byte0x19Int >= 1)
        {
            byte0x19Bools[0] = true;
            byte0x19Int -= 1;
            byte0x18Int += 256;
        }
        itemAbilitySlot2Trigger.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[byte0x18Int]);
        byte19Bit1Button.setSelected(byte0x19Bools[1]);
        byte19Bit2Button.setSelected(byte0x19Bools[2]);
        byte19Bit3Button.setSelected(byte0x19Bools[3]);
        byte19Bit4Button.setSelected(byte0x19Bools[4]);
        byte19Bit5Button.setSelected(byte0x19Bools[5]);
        byte19Bit6Button.setSelected(byte0x19Bools[6]);
        byte19Bit7Button.setSelected(byte0x19Bools[7]);

        //Trigger ability slot 3 area
        int byte0x1AInt = currentEntryArray[26];
        int byte0x1BInt = currentEntryArray[27];
        boolean[] byte0x1BBools = {false,false,false,false,false,false,false,false};
        if (byte0x1BInt >= 128)
        {
            byte0x1BBools[7] = true;
            byte0x1BInt -= 128;
        }
        if (byte0x1BInt >= 64)
        {
            byte0x1BBools[6] = true;
            byte0x1BInt -= 64;
        }
        if (byte0x1BInt >= 32)
        {
            byte0x1BBools[5] = true;
            byte0x1BInt -= 32;
        }
        if (byte0x1BInt >= 16)
        {
            byte0x1BBools[4] = true;
            byte0x1BInt -= 16;
        }
        if (byte0x1BInt >= 8)
        {
            byte0x1BBools[3] = true;
            byte0x1BInt -= 8;
        }
        if (byte0x1BInt >= 4)
        {
            byte0x1BBools[2] = true;
            byte0x1BInt -= 4;
        }
        if (byte0x1BInt >= 2)
        {
            byte0x1BBools[1] = true;
            byte0x1BInt -= 2;
        }
        if (byte0x1BInt >= 1)
        {
            byte0x1BBools[0] = true;
            byte0x1BInt -= 1;
            byte0x1AInt += 256;
        }
        itemAbilitySlot3Trigger.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[byte0x1AInt]);
        byte1BBit1Button.setSelected(byte0x1BBools[1]);
        byte1BBit2Button.setSelected(byte0x1BBools[2]);
        byte1BBit3Button.setSelected(byte0x1BBools[3]);
        byte1BBit4Button.setSelected(byte0x1BBools[4]);
        byte1BBit5Button.setSelected(byte0x1BBools[5]);
        byte1BBit6Button.setSelected(byte0x1BBools[6]);
        byte1BBit7Button.setSelected(byte0x1BBools[7]);

        //Update text area in preview JFrame
        if ((itemsPreviewFrame != null) && (itemsPreviewFrame.isVisible()))
        {
            //defense preview
            String defStr;
            if ((Integer)itemID.getSelectedItem() >= 128)
            {//3  I'm pretty sure this includes key items... no one's perfect, and they're unequippable anyways.
                int[] defArr = {0,0,0,0,0,0,0,0};
                //load base defense into array
                for (int i = 0; i < 8; i++)
                {//4
                    defArr[i] = (Integer)basePower.getSelectedItem();
                }//a
                if (eleDefMod1Status.isSelected())
                {//calculate total status defense
                    defArr[0] += (Integer)eleDefMod1Amount.getSelectedItem();
                }
                if (eleDefMod2Status.isSelected())
                {
                    defArr[0] += (Integer)eleDefMod2Amount.getSelectedItem();
                }
                if (eleDefMod1Force.isSelected())
                {//calculate total force defense
                    defArr[1] += (Integer)eleDefMod1Amount.getSelectedItem();
                }
                if (eleDefMod2Force.isSelected())
                {
                    defArr[1] += (Integer)eleDefMod2Amount.getSelectedItem();
                }
                if (eleDefMod1Electric.isSelected())
                {//calculate total electric defense
                    defArr[2] += (Integer)eleDefMod1Amount.getSelectedItem();
                }
                if (eleDefMod2Electric.isSelected())
                {
                    defArr[2] += (Integer)eleDefMod2Amount.getSelectedItem();
                }
                if (eleDefMod1Cold.isSelected())
                {//calculate total cold defense
                    defArr[3] += (Integer)eleDefMod1Amount.getSelectedItem();
                }
                if (eleDefMod2Cold.isSelected())
                {
                    defArr[3] += (Integer)eleDefMod2Amount.getSelectedItem();
                }
                if (eleDefMod1Heat.isSelected())
                {//calculate total heat defense
                    defArr[4] += (Integer)eleDefMod1Amount.getSelectedItem();
                }
                if (eleDefMod2Heat.isSelected())
                {
                    defArr[4] += (Integer)eleDefMod2Amount.getSelectedItem();
                }
                if (eleDefMod1Blunt.isSelected())
                {//calculate total blunt defense
                    defArr[5] += (Integer)eleDefMod1Amount.getSelectedItem();
                }
                if (eleDefMod2Blunt.isSelected())
                {
                    defArr[5] += (Integer)eleDefMod2Amount.getSelectedItem();
                }
                if (eleDefMod1Pierce.isSelected())
                {//calculate total pierce defense
                    defArr[6] += (Integer)eleDefMod1Amount.getSelectedItem();
                }
                if (eleDefMod2Pierce.isSelected())
                {
                    defArr[6] += (Integer)eleDefMod2Amount.getSelectedItem();
                }
                if (eleDefMod1Slash.isSelected())
                {//calculate total slash defense
                    defArr[7] += (Integer)eleDefMod1Amount.getSelectedItem();
                }
                if (eleDefMod2Slash.isSelected())
                {
                    defArr[7] += (Integer)eleDefMod2Amount.getSelectedItem();
                }
                //print total defense
                defStr = new String("Elemental Defense" +
                    "\nSla:\t"+defArr[7]+
                    "\nPie:\t"+defArr[6]+
                    "\nBlu:\t"+defArr[5]+
                    "\nHea:\t"+defArr[4]+
                    "\nCol:\t"+defArr[3]+
                    "\nEle:\t"+defArr[2]+
                    "\nFor:\t"+defArr[1]+
                    "\nSta:\t"+defArr[0] + "\n");
            }//b
            else// it's not an armor or key item
            {//5
                defStr = new String("Elemental Defense" +
                    "\nSla:\tnull"+
                    "\nPie:\tnull"+
                    "\nBlu:\tnull"+
                    "\nHea:\tnull"+
                    "\nCol:\tnull"+
                    "\nEle:\tnull"+
                    "\nFor:\tnull"+
                    "\nSta:\tnull\n");
            }//c
            String evaStr;
            if ((Integer)itemID.getSelectedItem() == 32)
            {//6  it's a shield
                int[] evaArr = {0,0,0,0,0,0,0,0};
                int evaElementByte = (Integer)eleDefMod1Amount.getSelectedItem();
                int evaAmount = (Integer)maxAmmo.getSelectedItem();
                //need to determine the elements that get the boost
                if (evaElementByte >= 128)
                {//calculate total slash evasion
                    evaArr[7] = (Integer)maxAmmo.getSelectedItem();
                    evaElementByte -= 128;
                }
                if (evaElementByte >= 64)
                {//calculate total pierce evasion
                    evaArr[6] = (Integer)maxAmmo.getSelectedItem();
                    evaElementByte -= 64;
                }
                if (evaElementByte >= 32)
                {//calculate total blunt evasion
                    evaArr[5] = (Integer)maxAmmo.getSelectedItem();
                    evaElementByte -= 32;
                }
                if (evaElementByte >= 16)
                {//calculate total heat evasion
                    evaArr[4] = (Integer)maxAmmo.getSelectedItem();
                    evaElementByte -= 16;
                }
                if (evaElementByte >= 8)
                {//calculate total cold evasion
                    evaArr[3] = (Integer)maxAmmo.getSelectedItem();
                    evaElementByte -= 8;
                }
                if (evaElementByte >= 4)
                {//calculate total electric evasion
                    evaArr[2] = (Integer)maxAmmo.getSelectedItem();
                    evaElementByte -= 4;
                }
                if (evaElementByte >= 2)
                {//calculate total force evasion
                    evaArr[1] = (Integer)maxAmmo.getSelectedItem();
                    evaElementByte -= 2;
                }
                if (evaElementByte >= 1)
                {//calculate total status evasion
                    evaArr[0] = (Integer)maxAmmo.getSelectedItem();
                    evaElementByte -= 1;
                }
                evaStr = new String("\nElemental Evasion" +
                    "\nSla:\t" + evaArr[7] +
                    "\nPie:\t" + evaArr[6] +
                    "\nBlu:\t" + evaArr[5] +
                    "\nHea:\t" + evaArr[4] +
                    "\nCol:\t" + evaArr[3] +
                    "\nEle:\t" + evaArr[2] +
                    "\nFor:\t" + evaArr[1] +
                    "\nSta:\t" + evaArr[0] + "\n"
                );
            }//d
            else //not a shield
            {
                evaStr = new String("\nElemental Evasion" +
                    "\nSla:\tnull" +
                    "\nPie:\tnull" +
                    "\nBlu:\tnull" +
                    "\nHea:\tnull" +
                    "\nCol:\tnull" +
                    "\nEle:\tnull" +
                    "\nFor:\tnull" +
                    "\nSta:\tnull\n"
                );
            }

            int[] totalMecStats = {0,0,0,0,0,0,0,0};
            int[] totalOtherStats = {0,0,0,0,0,0,0,0};
            if (mec1.isSelected())
            {
                if (strButton1.isSelected())
                {
                    totalMecStats[0] += (Integer)statAmount1.getSelectedItem();
                }
                if (quiButton1.isSelected())
                {
                    totalMecStats[1] += (Integer)statAmount1.getSelectedItem();
                }
                if (intButton1.isSelected())
                {
                    totalMecStats[2] += (Integer)statAmount1.getSelectedItem();
                }
                if (wilButton1.isSelected())
                {
                    totalMecStats[3] += (Integer)statAmount1.getSelectedItem();
                }
                if (psyButton1.isSelected())
                {
                    totalMecStats[4] += (Integer)statAmount1.getSelectedItem();
                }
                if (vitButton1.isSelected())
                {
                    totalMecStats[5] += (Integer)statAmount1.getSelectedItem();
                }
                if (chaButton1.isSelected())
                {
                    totalMecStats[6] += (Integer)statAmount1.getSelectedItem();
                }
                if (HPButton1.isSelected())
                {
                    totalMecStats[7] += (Integer)statAmount1.getSelectedItem() * 5;
                }
            }
            else if (other1.isSelected())
            {//i could maybe eliminate some of these conditionals with local references...
                if (strButton1.isSelected())
                {
                    totalOtherStats[0] += (Integer)statAmount1.getSelectedItem();
                }
                if (quiButton1.isSelected())
                {
                    totalOtherStats[1] += (Integer)statAmount1.getSelectedItem();
                }
                if (intButton1.isSelected())
                {
                    totalOtherStats[2] += (Integer)statAmount1.getSelectedItem();
                }
                if (wilButton1.isSelected())
                {
                    totalOtherStats[3] += (Integer)statAmount1.getSelectedItem();
                }
                if (psyButton1.isSelected())
                {
                    totalOtherStats[4] += (Integer)statAmount1.getSelectedItem();
                }
                if (vitButton1.isSelected())
                {
                    totalOtherStats[5] += (Integer)statAmount1.getSelectedItem();
                }
                if (chaButton1.isSelected())
                {
                    totalOtherStats[6] += (Integer)statAmount1.getSelectedItem();
                }
                if (HPButton1.isSelected())
                {
                    totalOtherStats[7] += (Integer)statAmount1.getSelectedItem() * 5;
                }
            }
            if (mec2.isSelected())
            {
                if (strButton2.isSelected())
                {
                    totalMecStats[0] += (Integer)statAmount2.getSelectedItem();
                }
                if (quiButton2.isSelected())
                {
                    totalMecStats[1] += (Integer)statAmount2.getSelectedItem();
                }
                if (intButton2.isSelected())
                {
                    totalMecStats[2] += (Integer)statAmount2.getSelectedItem();
                }
                if (wilButton2.isSelected())
                {
                    totalMecStats[3] += (Integer)statAmount2.getSelectedItem();
                }
                if (psyButton2.isSelected())
                {
                    totalMecStats[4] += (Integer)statAmount2.getSelectedItem();
                }
                if (vitButton2.isSelected())
                {
                    totalMecStats[5] += (Integer)statAmount2.getSelectedItem();
                }
                if (chaButton2.isSelected())
                {
                    totalMecStats[6] += (Integer)statAmount2.getSelectedItem();
                }
                if (HPButton2.isSelected())
                {
                    totalMecStats[7] += (Integer)statAmount2.getSelectedItem() * 5;
                }
            }
            else if (other2.isSelected())
            {
                if (strButton2.isSelected())
                {
                    totalOtherStats[0] += (Integer)statAmount2.getSelectedItem();
                }
                if (quiButton2.isSelected())
                {
                    totalOtherStats[1] += (Integer)statAmount2.getSelectedItem();
                }
                if (intButton2.isSelected())
                {
                    totalOtherStats[2] += (Integer)statAmount2.getSelectedItem();
                }
                if (wilButton2.isSelected())
                {
                    totalOtherStats[3] += (Integer)statAmount2.getSelectedItem();
                }
                if (psyButton2.isSelected())
                {
                    totalOtherStats[4] += (Integer)statAmount2.getSelectedItem();
                }
                if (vitButton2.isSelected())
                {
                    totalOtherStats[5] += (Integer)statAmount2.getSelectedItem();
                }
                if (chaButton2.isSelected())
                {
                    totalOtherStats[6] += (Integer)statAmount2.getSelectedItem();
                }
                if (HPButton2.isSelected())
                {
                    totalOtherStats[7] += (Integer)statAmount2.getSelectedItem() * 5;
                }
            }
            String statStr = new String("\nBonuses - Mecs"+
                    "\nStr:\t"+totalMecStats[0]+
                    "\nQui:\t"+totalMecStats[1]+
                    "\nInt:\t"+totalMecStats[2]+
                    "\nWil:\t"+totalMecStats[3]+
                    "\nPsy:\t"+totalMecStats[4]+
                    "\nVit:\t"+totalMecStats[5]+
                    "\nCha:\t"+totalMecStats[6]+
                    "\nHP:\t"+totalMecStats[7]+ "\n" +
                    "\nBonuses - Other"+
                    "\nStr:\t"+totalOtherStats[0]+
                    "\nQui:\t"+totalOtherStats[1]+
                    "\nInt:\t"+totalOtherStats[2]+
                    "\nWil:\t"+totalOtherStats[3]+
                    "\nPsy:\t"+totalOtherStats[4]+
                    "\nVit:\t"+totalOtherStats[5]+
                    "\nCha:\t"+totalOtherStats[6]+
                    "\nHP:\t"+totalOtherStats[7]
                );
            itemsPreviewTextArea.setText(defStr + evaStr + statStr);
        }
    }

    // This is the end of the method to initialize DataHandler objects.
    // Below are all the helper methods.

    /**
     * Private helper method for calculating values of eight
     * radio buttons that represent bit toggles equal to one 
     * byte.  Returns an int that represents an eight bit byte.
     * @param JToggleButton bit0
     * @param JToggleButton bit1
     * @param JToggleButton bit2
     * @param JToggleButton bit3
     * @param JToggleButton bit4
     * @param JToggleButton bit5
     * @param JToggleButton bit6
     * @param JToggleButton bit7
     * @return  int tempByte
     */
    private int eightBitToggles(JToggleButton bit0, JToggleButton bit1, JToggleButton bit2, JToggleButton bit3, JToggleButton bit4, JToggleButton bit5, JToggleButton bit6, JToggleButton bit7)
    {
        int tempByte = 0;
        if (bit7.isSelected())
        {
            tempByte += 128;
        }
        if (bit6.isSelected())
        {
            tempByte += 64;
        }
        if (bit5.isSelected())
        {
            tempByte += 32;
        }
        if (bit4.isSelected())
        {
            tempByte += 16;
        }
        if (bit3.isSelected())
        {
            tempByte += 8;
        }
        if (bit2.isSelected())
        {
            tempByte += 4;
        }
        if (bit1.isSelected())
        {
            tempByte += 2;
        }
        if (bit0.isSelected())
        {
            tempByte += 1;
        }
        return tempByte;
    }

    /**
     * Helper method for ability slot calcuation.  Inputs an int representing an 8 bit byte and eight 
     * radio buttons.  Returns an int representing an 8 bit value.
     * @param int inputValue
     * @param JToggleButton radioButtonBit1
     * @param JToggleButton radioButtonBit2
     * @param JToggleButton radioButtonBit3
     * @param JToggleButton radioButtonBit4
     * @param JToggleButton radioButtonBit5
     * @param JToggleButton radioButtonBit6
     * @param JToggleButton radioButtonBit7
     * @return int returnValue
     */
    private int itemAbilityHelper(int inputValue, JToggleButton radioButtomBit1, JToggleButton radioButtomBit2, JToggleButton radioButtomBit3, JToggleButton radioButtomBit4, JToggleButton radioButtomBit5, JToggleButton radioButtomBit6, JToggleButton radioButtomBit7)
    {
        int returnValue = 0;
        if (radioButtomBit7.isSelected() == true)
        {
            returnValue += 128;
        }
        if (radioButtomBit6.isSelected() == true)
        {
            returnValue += 64;
        }
        if (radioButtomBit5.isSelected() == true)
        {
            returnValue += 32;
        }
        if (radioButtomBit4.isSelected() == true)
        {
            returnValue += 16;
        }
        if (radioButtomBit3.isSelected() == true)
        {
            returnValue += 8;
        }
        if (radioButtomBit2.isSelected() == true)
        {
            returnValue += 4;
        }
        if (radioButtomBit1.isSelected() == true)
        {
            returnValue += 2;
        }
        if (inputValue % 2 == 1)
        {
            returnValue += 1;
        }
        return returnValue;
    }
}