import java.awt.*;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.*;
import java.io.*;
import java.lang.String.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.BoxLayout;
import javax.swing.event.*;
import java.text.*;
import javax.swing.border.*;
import java.util.HashMap;
/**
 * SnakeOil (c) 2015 - 2019
 * https://bitbucket.org/MysticLord/
 */
public class MecSelfDev extends JFrame
{
    //local references to static fields
    private HashMap<String, Integer[]> mecDevDataStruct;
    private Integer[] currentEntryArray;

    //misc class fields
    private String currentEntryName;

    //container area
    private JScrollPane skillScrollPane;
    private Box FrameBox;
    private JPanel BorderPanel;
    private JPanel FlowPanel;
    
    //secondary container area
    private Box firstBox;
    private Box secondBox;

    //skill selector area
    private Box skillSelectorBox;
    private JList<String> skillSelector;
    private JScrollPane skillSelectorScrollPane;

    //skill area
    private Box skillBox;
    private JLabel skillLabel;
    private JComboBox<String> skill;
    private JLabel bodyLabel;
    private JComboBox<Integer> body;
    private JLabel learningLabel;
    private JComboBox<Integer> learningDifficulty;
    
    public MecSelfDev()
    {
        super("Mec Self-Development Skills");
        
        for (FixedSizeDataTable dataTable : DataHandler.dataTables)
        {
            if (dataTable.getTableName().equals("mecSelfDev"))
            {//never entering this point..., check data handler
                //find and link local reference
                mecDevDataStruct = dataTable.data;
                break;//quit when you find it - no reason to keep searching.
            }
        }
        
        setupContainers();
        setupSelector();
        setupSkillsArea();
        
        currentEntryArray = mecDevDataStruct.get("0");
        
        initializeAndUpdate();
        pack();
        skillSelector.setSelectedIndex(0);
        setVisible(true);
    }
    
    private void setupContainers()
    {
        //essential, do not modify
        BorderPanel = new JPanel(new BorderLayout());
        FlowPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        FrameBox = new Box(BoxLayout.X_AXIS);

        BorderPanel.add(FrameBox, BorderLayout.NORTH);
        FlowPanel.add(BorderPanel);

        skillScrollPane = new JScrollPane(FlowPanel, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        getContentPane().add(skillScrollPane);
        
        firstBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(firstBox);
        
        secondBox = new Box(BoxLayout.Y_AXIS);
        FrameBox.add(secondBox);
    }
    
    private void setupSelector()
    {
        //form selector area
        skillSelectorBox = new Box(BoxLayout.Y_AXIS);
        skillSelectorBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED),"#", TitledBorder.CENTER, TitledBorder.CENTER));
        firstBox.add(skillSelectorBox);
        
        skillSelector = new JList<String>(DataHandler.ARRAY_STRING_UNSIGNED_QUARTER_BYTE);
        skillSelector.setVisibleRowCount(16);
        skillSelector.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        skillSelector.addListSelectionListener(new ListSelectionListener()
            {
                public void valueChanged(ListSelectionEvent e)
                {
                    currentEntryName = (String)skillSelector.getSelectedValue();
                    currentEntryArray = mecDevDataStruct.get(currentEntryName);
                    initializeAndUpdate();
                }
            });
        
        skillSelectorScrollPane = new JScrollPane(skillSelector, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        skillSelectorBox.add(skillSelectorScrollPane);
    }
    
    private void setupSkillsArea()
    {
        skillBox = new Box(BoxLayout.X_AXIS);
        skillBox.setBorder(new TitledBorder(new BevelBorder(BevelBorder.RAISED), "Skill", TitledBorder.CENTER, TitledBorder.CENTER));
        secondBox.add(skillBox);
        
        JPanel leftPanel = new JPanel(new GridLayout(8,1,1,1));
        skillBox.add(leftPanel);

        JPanel rightPanel = new JPanel(new GridLayout(8,1,1,1));
        skillBox.add(rightPanel);//maybe create a filler JPanel with a gridlayout below this area?
        
        skillLabel = new JLabel("Skill");
        leftPanel.add(skillLabel);
        
        skill = new JComboBox<String>(DataHandler.ARRAY_STRING_ABILITIES);
        skill.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[0] = ((Integer)skill.getSelectedIndex() & 0xff);
                    currentEntryArray[1] = (((Integer)skill.getSelectedIndex() >> 8) & 0x01);
                }
            });
        rightPanel.add(skill);
        
        bodyLabel = new JLabel("Body");
        leftPanel.add(bodyLabel);
        
        body = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        body.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[2] = (Integer)body.getSelectedItem();
                }
            });
        rightPanel.add(body);
        
        learningLabel = new JLabel("Difficulty");
        leftPanel.add(learningLabel);
        
        learningDifficulty = new JComboBox<Integer>(DataHandler.ARRAY_UNSIGNED_BYTE);
        learningDifficulty.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent evt)
                {
                    currentEntryArray[3] = (Integer)learningDifficulty.getSelectedItem();
                }
            });
        rightPanel.add(learningDifficulty);
    }
    
    private void initializeAndUpdate()
    {
        skill.setSelectedItem(DataHandler.ARRAY_STRING_ABILITIES[(currentEntryArray[0] | ((currentEntryArray[1] & 0x01) << 8))]);
        body.setSelectedItem(currentEntryArray[2]);
        learningDifficulty.setSelectedItem(currentEntryArray[3]);
    }
}
