 
/** 
 * SnakeOil (c) 2015 - 2019
 * https://bitbucket.org/MysticLord/
 */
public class PointerAddressedDataTable extends FixedSizeDataTable
{
    private int pointerLength;
    private boolean isLilEndian;
    private long pointerAddress;

    private long tableAddress;

    public PointerAddressedDataTable(String tName, String fName, int tLength, 
    int eSize, int nEntries, int pLength, boolean isItLilEndian, 
    long pAddress)
    {
        super(tName, fName, tLength, eSize, nEntries);
        pointerLength = pLength;
        isLilEndian = isItLilEndian;
        pointerAddress = pAddress;
    }

    public int getPointerLength() {return pointerLength;}

    public boolean isLittleEndian() {return isLilEndian;}

    public long getPointerAddress() {return pointerAddress;}

    public long getTableAddress() {return tableAddress;}

    public void setTableAddress(long tAddress){
        tableAddress = tAddress;
    }
    
    public String toString()
    {
        String returnString = super.toString();
        returnString += " " + getPointerLength();
        returnString += " " + isLittleEndian();
        returnString += " " + getPointerAddress();
        returnString += " " + getTableAddress();
        return returnString;
    }
}