import io,sys

# useage via powershell, cygwin, or command prompt:
# python genericTableDumper > tableDump.txt
#
# make sure filename is correct, python 3 is installed
# might work with python 2, i don't know.
# tableDump.txt can be any name.

# replace SCUS_942.30 with the file name
with open('SCUS_942.30', 'rb') as scus:
    def printData(addr, rows, reads, name, direction):
        scus.seek(addr)
        tblList = []
        rowCntr = 0
        while rowCntr < rows:
            tblList.insert(rowCntr, bytearray(scus.read(reads)))
            rowCntr += 1
        rowCntr = 0
        print(name)
        if direction == 'normal':
            for a in tblList:
                for b in a:
                    # if printing ints, uncomment this one below
                    # print(str(int(b)), end=' ')
                    # if printing hex, uncomment this one below
                    # print(hex(b)[2:].zfill(2), end=' ')
                    # if printing hex for paste into spreadsheet, use this one below
                    print('\'' + hex(b)[2:].zfill(2), end='\' ')
                    # only use one at a time, comment all others
                    # <--this hashtag is a comment
                rowCntr += 1
                print()
        elif direction == 'transposed':
            numOfEntries = len(tblList)
            entrySize = len(tblList[0])
            flipTblList = [[] for i in range(entrySize)]
            for i in range(0, entrySize, 1):
                flipTblList[i] = [0] * numOfEntries
            
            i = 0
            while i < numOfEntries:
                j = 0
                while j < entrySize:
                    flipTblList[j][i] = tblList[i][j]
                    j += 1
                i += 1
            for a in flipTblList:
                for b in a:
                    print('\'' + hex(b)[2:].zfill(2), end='\' ')
                print()
        print()

    printData(47844, 512, 18, 'Skills Table 1', 'normal')
    printData(38620, 512, 4, 'Skills Table 2', 'normal')
    printData(61240, 32, 4, 'Linked Skills Table', 'normal')
    printData(61372, 3, 16, "Counters Table", 'transposed')
    
    # copy and paste this for all tables you want to print.
    # don't forget to edit this print statement, comment it out, or delete it.
    # printData(startingAddress, entries, byesPerEntry, name, type)
    # startingAddress is starting address in decimal (base 10).
    # entries is the number of entries.
    # bytes per entry is how many bytes are in an entry.
    # name is the name you want to print, for convenience to the user. wrap in single or double quotes.
    # type is if you want the table to print as it is present in the game, or ...
    #   ... if you want to transpose it (switch rows and columns).
    # use normal for normal type, transposed for transposed type. wrap in single or double quotes.
    # script usage is at top.
