;***********************************************************************************************************************
;*******			   			 COMANDO $33						********
;******* Este comando lee los 4 bytes a continuacin para testear una variable y ejecutar una caja de texto	********
;******* diferente en caso de que no se cumpla la condicin. La variable es de 4 bits y se almacena en el	********
;******* array $7E:F46A. Los parmetros ledos son:								********
;*******	BYTE 1		-> nmero de elemento de 4 bits al que se accede del array $7E:F46A		********
;*******	BYTE 2		-> 2 nibbles de 4 bits con los que se compara el elemento			********
;*******	BYTES 3 y 4	-> ndice del array de vectores para la caja de texto que se mostrar en caso	********
;*******			de que el valor del elemento no est entre el valor de ambos nibbles		********
;*******			Si el 4 byte es mayor de $0C, quiere decir que estos dos bytes no son el	********
;*******			ndice, sino el siguiente comando.						********
;******* El array $7E:F46A lleva variables del motor de 4 bits (256 en total, 128 bytes de largo).		********
;***********************************************************************************************************************
$C0/2F5F C2 20       REP #$20                A:0826 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIzcHC:0374 VC:036 00 FL:65436
$C0/2F61 E6 78       INC $78    [$00:0078]   A:0826 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envmxdIzcHC:0392 VC:036 00 FL:65436
$C0/2F63 E2 20       SEP #$20                A:0826 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envmxdIzcHC:0442 VC:036 00 FL:65436
;******* el siguiente byte al del comando se usa como ndice a un array
$C0/2F65 A7 78       LDA [$78]  [$FA:08A0]   A:0826 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIzcHC:0484 VC:036 00 FL:65436
;******* leemos del array y obtenemos el valor de 4 bits en el acumulador
$C0/2F67 20 0D 37    JSR $370D  [$C0:370D]   A:0886 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:eNvMxdIzcHC:0550 VC:036 00 FL:65436
$C0/2F6A 48          PHA                     A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIZcHC:0932 VC:036 00 FL:65437
$C0/2F6B C2 20       REP #$20                A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7A P:envMxdIZcHC:0952 VC:036 00 FL:65437
;******* leemos el siguiente byte de la entrada, que contiene dos valores de 4 bits
$C0/2F6D E6 78       INC $78    [$00:0078]   A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7A P:envmxdIZcHC:0970 VC:036 00 FL:65437
$C0/2F6F E2 20       SEP #$20                A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7A P:envmxdIzcHC:1020 VC:036 00 FL:65437
$C0/2F71 A7 78       LDA [$78]  [$FA:08A1]   A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7A P:envMxdIzcHC:1062 VC:036 00 FL:65437
$C0/2F73 85 8D       STA $8D    [$00:008D]   A:08EF X:0026 Y:0800 D:0000 DB:7E S:1F7A P:eNvMxdIzcHC:1128 VC:036 00 FL:65437
;******* en la variable $8D metemos el nibble superior
$C0/2F75 46 8D       LSR $8D    [$00:008D]   A:08EF X:0026 Y:0800 D:0000 DB:7E S:1F7A P:eNvMxdIzcHC:1148 VC:036 00 FL:65437
$C0/2F77 46 8D       LSR $8D    [$00:008D]   A:08EF X:0026 Y:0800 D:0000 DB:7E S:1F7A P:envMxdIzCHC:1182 VC:036 00 FL:65437
$C0/2F79 46 8D       LSR $8D    [$00:008D]   A:08EF X:0026 Y:0800 D:0000 DB:7E S:1F7A P:envMxdIzCHC:1216 VC:036 00 FL:65437
$C0/2F7B 46 8D       LSR $8D    [$00:008D]   A:08EF X:0026 Y:0800 D:0000 DB:7E S:1F7A P:envMxdIzCHC:1250 VC:036 00 FL:65437
;******* en el acumulador dejamos el nibble inferior
$C0/2F7D 29 0F       AND #$0F                A:08EF X:0026 Y:0800 D:0000 DB:7E S:1F7A P:envMxdIzCHC:1284 VC:036 00 FL:65437
$C0/2F7F 85 8E       STA $8E    [$00:008E]   A:080F X:0026 Y:0800 D:0000 DB:7E S:1F7A P:envMxdIzCHC:1296 VC:036 00 FL:65437
$C0/2F81 E6 8E       INC $8E    [$00:008E]   A:080F X:0026 Y:0800 D:0000 DB:7E S:1F7A P:envMxdIzCHC:1316 VC:036 00 FL:65437
;******* comparamos el nibble superior con el valor ledo del array de memoria $7E:F46A
$C0/2F83 68          PLA                     A:080F X:0026 Y:0800 D:0000 DB:7E S:1F7A P:envMxdIzCHC:1350 VC:036 00 FL:65437
$C0/2F84 C5 8D       CMP $8D    [$00:008D]   A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIZCHC:0008 VC:037 00 FL:65437
$C0/2F86 90 1D       BCC $1D    [$2FA5]      A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:eNvMxdIzcHC:0028 VC:037 00 FL:65437
;******* si el valor del array era mayor que el nibble superior, comparamos el nibble inferior con el mismo valor del array
$C0/2F88 C5 8E       CMP $8E    [$00:008E]   A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envMxdIzCHC:7244 VC:037 00 FL:970
$C0/2F8A B0 19       BCS $19    [$2FA5]      A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envMxdIzCHC:7250 VC:037 00 FL:971

;******* este cdigo se ejecuta cuando hay que cambiar de caja de texto: esto ocurre cuando el valor ledo del array $7E:F464
;******* es mayor que la parte los 4 bits MSB del parmetro y; los bytes 3 y 4 contienen el ndice dentro de
;******* la tabla de vectores del nuevo texto
$C0/2F8C C2 20       REP #$20                A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envMxdIzCHC:7262 VC:037 00 FL:972
$C0/2F8E E6 78       INC $78    [$00:0078]   A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envmxdIzCHC:7268 VC:037 00 FL:973
$C0/2F90 E2 20       SEP #$20                A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envmxdIzCHC:7280 VC:037 00 FL:974
$C0/2F92 A7 78       LDA [$78]  [$FA:08A2]   A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envMxdIzCHC:7286 VC:037 00 FL:975
$C0/2F94 C9 0C       CMP #$0C                A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envMxdIzCHC:7292 VC:037 00 FL:976
$C0/2F96 B0 0C       BCS $0C    [$2FA4]      A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envMxdIzCHC:7298 VC:037 00 FL:977
$C0/2F98 C2 20       REP #$20                A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envMxdIzCHC:7310 VC:037 00 FL:978
$C0/2F9A A7 78       LDA [$78]  [$FA:08A2]   A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envmxdIzCHC:7316 VC:037 00 FL:979
$C0/2F9C EB          XBA                     A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envmxdIzCHC:7322 VC:037 00 FL:980
$C0/2F9D 85 8D       STA $8D    [$00:008D]   A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envmxdIzCHC:7328 VC:037 00 FL:981
$C0/2F9F E2 20       SEP #$20                A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envmxdIzCHC:7340 VC:037 00 FL:982
;******* saltamos a la rutina que lee el puntero al texto para leer un nuevo puntero y por tanto, una nueva caja de texto
$C0/2FA1 4C 4C 1B    JMP $1B4C  [$C0:1B4C]   A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envMxdIzCHC:7346 VC:037 00 FL:983

$C0/2FA4 60          RTS                     A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIzCHC:0352 VC:037 00 FL:65437

;******* si ninguno de los dos nibbles era mayor que el valor del array, nos saltamos los dos bytes siguientes de texto que
;******* son el ndice de la nueva caja de texto que habra que haber mostrado
$C0/2FA5 C2 20       REP #$20                A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:eNvMxdIzcHC:0046 VC:037 00 FL:65437
$C0/2FA7 E6 78       INC $78    [$00:0078]   A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:eNvmxdIzcHC:0064 VC:037 00 FL:65437
$C0/2FA9 E6 78       INC $78    [$00:0078]   A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envmxdIzcHC:0114 VC:037 00 FL:65437
$C0/2FAB E6 78       INC $78    [$00:0078]   A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envmxdIzcHC:0164 VC:037 00 FL:65437
$C0/2FAD E2 20       SEP #$20                A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envmxdIzcHC:0214 VC:037 00 FL:65437
$C0/2FAF A7 78       LDA [$78]  [$FA:08A4]   A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIzcHC:0256 VC:037 00 FL:65437
$C0/2FB1 C9 0C       CMP #$0C                A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIzcHC:0322 VC:037 00 FL:65437
$C0/2FB3 B0 EF       BCS $EF    [$2FA4]      A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIzCHC:0334 VC:037 00 FL:65437

$C0/2FB5 C2 20       REP #$20                A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envMxdIzCHC:6956 VC:037 00 FL:931
$C0/2FB7 A7 78       LDA [$78]  [$FA:08A4]   A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envmxdIzCHC:6962 VC:037 00 FL:932
$C0/2FB9 EB          XBA                     A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envmxdIzCHC:6968 VC:037 00 FL:933
$C0/2FBA 85 8D       STA $8D    [$00:008D]   A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envmxdIzCHC:6974 VC:037 00 FL:934
$C0/2FBC E2 20       SEP #$20                A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envmxdIzCHC:6986 VC:037 00 FL:935
$C0/2FBE 4C 4C 1B    JMP $1B4C  [$C0:1B4C]   A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envMxdIzCHC:6992 VC:037 00 FL:936
;***********************************************************************************************************************
;*******			   		    FIN DE COMANDO $33						********
;***********************************************************************************************************************







;***********************************************************************************************************************
;*******			   		      RUTINA $C0/370D						********
;******* Esta rutina recibe en el acumulador un ndice a una array de elementos de 4 bits que est en RAM en	********
;******* la direccin $7E:F46A. El valor ledo se devuelve en el acumulador.					********
;***********************************************************************************************************************
$C0/370D 85 EA       STA $EA    [$00:00EA]   A:0886 X:0026 Y:0800 D:0000 DB:7E S:1F79 P:eNvMxdIzcHC:0590 VC:036 00 FL:65438
$C0/370F 64 EB       STZ $EB    [$00:00EB]   A:0886 X:0026 Y:0800 D:0000 DB:7E S:1F79 P:eNvMxdIzcHC:0610 VC:036 00 FL:65438
$C0/3711 46 EA       LSR $EA    [$00:00EA]   A:0886 X:0026 Y:0800 D:0000 DB:7E S:1F79 P:eNvMxdIzcHC:0630 VC:036 00 FL:65438
$C0/3713 08          PHP                     A:0886 X:0026 Y:0800 D:0000 DB:7E S:1F79 P:envMxdIzcHC:0664 VC:036 00 FL:65438
$C0/3714 DA          PHX                     A:0886 X:0026 Y:0800 D:0000 DB:7E S:1F78 P:envMxdIzcHC:0684 VC:036 00 FL:65438
$C0/3715 A6 EA       LDX $EA    [$00:00EA]   A:0886 X:0026 Y:0800 D:0000 DB:7E S:1F76 P:envMxdIzcHC:0712 VC:036 00 FL:65438
$C0/3717 BF 6A F4 7E LDA $7EF46A,x[$7E:F4AD] A:0886 X:0043 Y:0800 D:0000 DB:7E S:1F76 P:envMxdIzcHC:0740 VC:036 00 FL:65438
$C0/371B FA          PLX                     A:0800 X:0043 Y:0800 D:0000 DB:7E S:1F76 P:envMxdIZcHC:0772 VC:036 00 FL:65438
$C0/371C 28          PLP                     A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F78 P:envMxdIzcHC:0806 VC:036 00 FL:65438
$C0/371D B0 05       BCS $05    [$3724]      A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F79 P:envMxdIzcHC:0832 VC:036 00 FL:65438
$C0/371F 4A          LSR A                   A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F79 P:envMxdIzcHC:0844 VC:036 00 FL:65438
$C0/3720 4A          LSR A                   A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F79 P:envMxdIZcHC:0856 VC:036 00 FL:65438
$C0/3721 4A          LSR A                   A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F79 P:envMxdIZcHC:0868 VC:036 00 FL:65438
$C0/3722 4A          LSR A                   A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F79 P:envMxdIZcHC:0880 VC:036 00 FL:65438
$C0/3723 60          RTS                     A:0800 X:0026 Y:0800 D:0000 DB:7E S:1F79 P:envMxdIZcHC:0892 VC:036 00 FL:65438
$C0/3724 29 0F       AND #$0F                A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envMxdIzCHC:0398 VC:037 00 FL:65435
$C0/3726 60          RTS                     A:0860 X:0026 Y:0800 D:0000 DB:7E S:1F7D P:envMxdIzCHC:0404 VC:037 00 FL:65436
;***********************************************************************************************************************
;*******			   		    FIN DE RUTINA $C0/370D					********
;***********************************************************************************************************************