;***********************************************************************************************************************
;*******			   			 COMANDO $39						********
;******* Este comando lee 1 byte ms de la entrada y lo usa como ndice para acceder al struct $7E:F000. De la	********
;******* posicin a la que se accede se obtiene el byte que identifica al nombre del personaje que hay que	********
;******* mostrar por pantalla. Cada personaje tiene reservado 128 bytes correlativos en esta zona de memoria.	********
;***********************************************************************************************************************
$C0/31F2 A2 00 00    LDX #$0000              A:0832 X:0032 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIzcHC:0508 VC:003 00 FL:30612
$C0/31F5 C2 20       REP #$20                A:0832 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIZcHC:0532 VC:003 00 FL:30612
;******* leemos el byte siguiente y lo multiplicamos por 128
$C0/31F7 E6 78       INC $78    [$00:0078]   A:0832 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envmxdIZcHC:0556 VC:003 00 FL:30612
$C0/31F9 A7 78       LDA [$78]  [$FB:0EC6]   A:0832 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envmxdIzcHC:0636 VC:003 00 FL:30612
$C0/31FB 29 FF 00    AND #$00FF              A:EA00 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:eNvmxdIzcHC:0714 VC:003 00 FL:30612
$C0/31FE EB          XBA                     A:0000 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envmxdIZcHC:0738 VC:003 00 FL:30612
$C0/31FF 4A          LSR A                   A:0000 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envmxdIZcHC:0762 VC:003 00 FL:30612
$C0/3200 18          CLC                     A:0000 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envmxdIZcHC:0780 VC:003 00 FL:30612
;******* el resultado es el offset respecto a $7E:F000 del que leeremos
$C0/3201 69 00 F0    ADC #$F000              A:0000 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envmxdIZcHC:0798 VC:003 00 FL:30612
$C0/3204 85 8D       STA $8D    [$00:008D]   A:F000 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:eNvmxdIzcHC:0822 VC:003 00 FL:30612
$C0/3206 E2 20       SEP #$20                A:F000 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:eNvmxdIzcHC:0856 VC:003 00 FL:30612
$C0/3208 A9 7E       LDA #$7E                A:F000 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:eNvMxdIzcHC:0880 VC:003 00 FL:30612
$C0/320A 85 8F       STA $8F    [$00:008F]   A:F07E X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIzcHC:0898 VC:003 00 FL:30612
;******* leemos el byte y lo comparamos con el byte en $7E:F000 que representa al personaje principal
$C0/320C A7 8D       LDA [$8D]  [$7E:F000]   A:F07E X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIzcHC:0948 VC:003 00 FL:30612
$C0/320E CF 00 F0 7E CMP $7EF000[$7E:F000]   A:F007 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIzcHC:1022 VC:003 00 FL:30612
$C0/3212 F0 B7       BEQ $B7    [$31CB]      A:F007 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIZCHC:1060 VC:003 00 FL:30612
;******* si el byte no representa al del personaje principal, entonces acudimos al diccionario en $FD:1480 para sacar el
;******* nombre, para lo cual, primero hemos de multiplicar por 8 el byte porque cada nombre tiene 8 letras de longitud

;******* como el personaje principal es el nico que puede tener el nombre cambiado, copiamos el nombre que ha metido el
;******* jugador y lo copiamos a la zona temporal $7E:D56D (mximo 8 letras)
$C0/31CB A2 00 00    LDX #$0000              A:F007 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIZCHC:1084 VC:003 00 FL:30612
$C0/31CE A0 00 00    LDY #$0000              A:F007 X:0000 Y:0800 D:0000 DB:7E S:1F7B P:envMxdIZCHC:1108 VC:003 00 FL:30612
$C0/31D1 C0 08 00    CPY #$0008              A:F007 X:0000 Y:0000 D:0000 DB:7E S:1F7B P:envMxdIZCHC:1132 VC:003 00 FL:30612
$C0/31D4 B0 6F       BCS $6F    [$3245]      A:F007 X:0000 Y:0000 D:0000 DB:7E S:1F7B P:eNvMxdIzcHC:1156 VC:003 00 FL:30612
$C0/31D6 BD 00 F3    LDA $F300,x[$7E:F300]   A:F007 X:0000 Y:0000 D:0000 DB:7E S:1F7B P:eNvMxdIzcHC:1174 VC:003 00 FL:30612
$C0/31D9 F0 6A       BEQ $6A    [$3245]      A:F05B X:0000 Y:0000 D:0000 DB:7E S:1F7B P:envMxdIzcHC:1206 VC:003 00 FL:30612
$C0/31DB C9 50       CMP #$50                A:F05B X:0000 Y:0000 D:0000 DB:7E S:1F7B P:envMxdIzcHC:1224 VC:003 00 FL:30612
$C0/31DD F0 66       BEQ $66    [$3245]      A:F05B X:0000 Y:0000 D:0000 DB:7E S:1F7B P:envMxdIzCHC:1242 VC:003 00 FL:30612
$C0/31DF 99 6D D5    STA $D56D,y[$7E:D56D]   A:F05B X:0000 Y:0000 D:0000 DB:7E S:1F7B P:envMxdIzCHC:1260 VC:003 00 FL:30612
$C0/31E2 E8          INX                     A:F05B X:0000 Y:0000 D:0000 DB:7E S:1F7B P:envMxdIzCHC:1292 VC:003 00 FL:30612
$C0/31E3 C8          INY                     A:F05B X:0001 Y:0000 D:0000 DB:7E S:1F7B P:envMxdIzCHC:1310 VC:003 00 FL:30612
$C0/31E4 C9 50       CMP #$50                A:F05B X:0001 Y:0001 D:0000 DB:7E S:1F7B P:envMxdIzCHC:1328 VC:003 00 FL:30612
$C0/31E6 B0 E9       BCS $E9    [$31D1]      A:F05B X:0001 Y:0001 D:0000 DB:7E S:1F7B P:envMxdIzCHC:1346 VC:003 00 FL:30612

;******* cuando terminamos de leer el nombre, saltamos aqu
$C0/3245 C2 20       REP #$20                A:F050 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:envMxdIZCHC:0968 VC:004 00 FL:30612
;******* guardamos en $90 la direccin al final de la zona temporal, justo donde acaba el nombre copiado
$C0/3247 98          TYA                     A:F050 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:envmxdIZCHC:0992 VC:004 00 FL:30612
$C0/3248 18          CLC                     A:0005 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:envmxdIzCHC:1010 VC:004 00 FL:30612
$C0/3249 69 6D D5    ADC #$D56D              A:0005 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:envmxdIzcHC:1028 VC:004 00 FL:30612
$C0/324C 85 90       STA $90    [$00:0090]   A:D572 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:eNvmxdIzcHC:1052 VC:004 00 FL:30612
$C0/324E E2 20       SEP #$20                A:D572 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:eNvmxdIzcHC:1086 VC:004 00 FL:30612
;******* multiplicamos por 5 el ndice que nos indica el siguiente hueco vaco en el array que almacena punteros anidados
;******* al texto
$C0/3250 A5 77       LDA $77    [$00:0077]   A:D572 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:eNvMxdIzcHC:1110 VC:004 00 FL:30612
$C0/3252 0A          ASL A                   A:D500 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:envMxdIZcHC:1136 VC:004 00 FL:30612
$C0/3253 0A          ASL A                   A:D500 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:envMxdIZcHC:1154 VC:004 00 FL:30612
$C0/3254 18          CLC                     A:D500 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:envMxdIZcHC:1172 VC:004 00 FL:30612
$C0/3255 65 77       ADC $77    [$00:0077]   A:D500 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:envMxdIZcHC:1190 VC:004 00 FL:30612
$C0/3257 C2 20       REP #$20                A:D500 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:envMxdIZcHC:1216 VC:004 00 FL:30612
$C0/3259 29 FF 00    AND #$00FF              A:D500 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:envmxdIZcHC:1240 VC:004 00 FL:30612
$C0/325C AA          TAX                     A:0000 X:0005 Y:0005 D:0000 DB:7E S:1F7B P:envmxdIZcHC:1264 VC:004 00 FL:30612
;******* el puntero con el que estbamos leyendo [$78] lo apuntamos al siguiente byte de comando y lo almacenamos en el
;******* array que contiene los punteros que vamos anidando en sucesivas llamadas
$C0/325D A5 78       LDA $78    [$00:0078]   A:0000 X:0000 Y:0005 D:0000 DB:7E S:1F7B P:envmxdIZcHC:1282 VC:004 00 FL:30612
$C0/325F 1A          INC A                   A:0EC6 X:0000 Y:0005 D:0000 DB:7E S:1F7B P:envmxdIzcHC:1316 VC:004 00 FL:30612
$C0/3260 9D 1D D5    STA $D51D,x[$7E:D51D]   A:0EC7 X:0000 Y:0005 D:0000 DB:7E S:1F7B P:envmxdIzcHC:1334 VC:004 00 FL:30612
$C0/3263 A5 7B       LDA $7B    [$00:007B]   A:0EC7 X:0000 Y:0005 D:0000 DB:7E S:1F7B P:envmxdIzcHC:0006 VC:005 00 FL:30612
$C0/3265 9D 20 D5    STA $D520,x[$7E:D520]   A:0F7A X:0000 Y:0005 D:0000 DB:7E S:1F7B P:envmxdIzcHC:0040 VC:005 00 FL:30612
;******* ahora el puntero [$78] lo ponemos apuntando a la zona temporal para leer el nombre de ah
$C0/3268 A9 6D D5    LDA #$D56D              A:0F7A X:0000 Y:0005 D:0000 DB:7E S:1F7B P:envmxdIzcHC:0080 VC:005 00 FL:30612
$C0/326B 85 78       STA $78    [$00:0078]   A:D56D X:0000 Y:0005 D:0000 DB:7E S:1F7B P:eNvmxdIzcHC:0104 VC:005 00 FL:30612
$C0/326D A5 90       LDA $90    [$00:0090]   A:D56D X:0000 Y:0005 D:0000 DB:7E S:1F7B P:eNvmxdIzcHC:0138 VC:005 00 FL:30612
$C0/326F 85 7B       STA $7B    [$00:007B]   A:D572 X:0000 Y:0005 D:0000 DB:7E S:1F7B P:eNvmxdIzcHC:0172 VC:005 00 FL:30612
$C0/3271 E2 20       SEP #$20                A:D572 X:0000 Y:0005 D:0000 DB:7E S:1F7B P:eNvmxdIzcHC:0206 VC:005 00 FL:30612
$C0/3273 A5 7A       LDA $7A    [$00:007A]   A:D572 X:0000 Y:0005 D:0000 DB:7E S:1F7B P:eNvMxdIzcHC:0230 VC:005 00 FL:30612
$C0/3275 9D 1F D5    STA $D51F,x[$7E:D51F]   A:D5FB X:0000 Y:0005 D:0000 DB:7E S:1F7B P:eNvMxdIzcHC:0256 VC:005 00 FL:30612
$C0/3278 E6 77       INC $77    [$00:0077]   A:D5FB X:0000 Y:0005 D:0000 DB:7E S:1F7B P:eNvMxdIzcHC:0288 VC:005 00 FL:30612
;******* el banco del puntero [$78] es siempre la RAM $7E
$C0/327A A9 7E       LDA #$7E                A:D5FB X:0000 Y:0005 D:0000 DB:7E S:1F7B P:envMxdIzcHC:0328 VC:005 00 FL:30612
$C0/327C 85 7A       STA $7A    [$00:007A]   A:D57E X:0000 Y:0005 D:0000 DB:7E S:1F7B P:envMxdIzcHC:0346 VC:005 00 FL:30612
$C0/327E 60          RTS                     A:D57E X:0000 Y:0005 D:0000 DB:7E S:1F7B P:envMxdIzcHC:0372 VC:005 00 FL:30612
;***********************************************************************************************************************
;*******			   		    FIN DE COMANDO $39						********
;***********************************************************************************************************************




